/* glMat.sl
 *
 * DESCRIPTION:
 *   juiced-up plastic shader that has similar parameters to OpenGL
 *   materials
 *
 * PARAMETERS:
 *  Kd, Ka, Ks, Ke(emission), rough, specularcolor, ambientcolor, 
 *  emissivecolor
 *
 * ANTIALIASING:
 *
 * AUTHOR: Mark B. Allan
 *
 * HISTORY:
 *
 * The RenderMan (R) Interface Procedures and RIB Protocol are:
 * Copyright 1988, 1989, Pixar.  All rights reserved.
 * RenderMan (R) is a registered trademark of Pixar.
 */

surface
glMat	 (	float Kd 				= 0.5;
			float Ka 				= 1.0;
         	float Ks 				= 0.5;
         	float Ke 				= 0.0;
         	float rough 			= 0.1;
	 		color specularcolor 	= 0.5;
	 		color ambientcolor	 	= 1.0;
	 		color emissivecolor		= 0.0)
{
  point Nf;
  float temp;
  float	Ks1;
  float	Ks2;
  float	rough1;
  float	rough2;
  
  Nf = faceforward (normalize(N),I);
  
  Ks1 = Ks*0.8; 
  Ks2 = Ks*0.2;
  
  rough1 = rough;
  rough2 = rough/7.5;
  
  Oi = Os;
  Ci = Os *	(( Cs * (ambientcolor * Ka*ambient() + Kd*diffuse(Nf)) 		+
	      	(specularcolor * Ks1*specular(Nf,-normalize(I),rough))		+
	      	(specularcolor * Ks2*specular(Nf,-normalize(I),rough2))	)	+
	      	Ke*emissivecolor) ;
}

