# Valid Defines:
#---------------
# LINUX,SGI    - platform
# USE_SLCARGS  - use BMRT's slcargs lib to get shader info
# RIVA_GLX     - kludge 'missing points' bug in NVidia GLX
# GL_DEBUG     - enable glGetError()

######################################################################
#### LINUX
######################################################################
# NOTES:
# If you have a NVidia accelerator and are using the old 6/99 GLX
# 3.3.1 X server, you will want to add the 
# 'RIVA_GLX' define. There is a bug in the server where multiple
# GL_POINTS in a Begin/End block get 'lost'. If you're not using
# the RIVA GLX module, you don't need it.
#### 
unix:DEFINES        =	LINUX USE_SLCARGS 
unix:TEMPLATE       =	app
unix:CONFIG         =	qt opengl x11 warn_on release
#unix:CONFIG         =	qt opengl x11 warn_on debug
unix:INCLUDEPATH    =	../include ../ParticleAPI /usr/X11R6/include /usr/local/BMRT/include 
unix:LIBS           =	-L../ParticleAPI/particle -L/usr/local/BMRT/lib -lXi -ltiff -lm -lparticle -lribout -ldl -rdynamic

######################################################################
#### SGI
######################################################################
irix-n32:DEFINES        =	SGI GL_DEBUG
irix-n32:TEMPLATE       =	app
irix-n32:CONFIG         =	qt opengl x11 warn_on release
#irix-n32:CONFIG         =	qt opengl x11 warn_on debug
irix-n32:INCLUDEPATH    =   ../ParticleAPI /usr/local/BMRT/include ..
irix-n32:LIBS           =   -L../ParticleAPI/particle -L/usr/local/BMRT/lib -lqimgio  -ljpeg -ltiff -lribout -lparticle -lm 
irix-n32:TMAKE_CXXFLAGS		+= -n32 LANG:bool=ON -woff 1209,1233,1314,1355,1375,1430,1506

######################################################################
#### WIN32
######################################################################
# NOTES: 
# I do not have a Qt licence for Win32, but my employer does.
# Occasionally, I compile under windows to keep the code clean, 
# but I cannot and will not release a Win32 version of Flow.
####
win32-msvc:DEFINES      =	WIN32 
win32-msvc:TEMPLATE     =	vcapp
#win32-msvc:TEMPLATE     =	app
win32-msvc:CONFIG       =	qt opengl windows debug
win32-msvc:INCLUDEPATH  =	D:\BMRT\include F:\DevLibs .. ..\ParticleAPI
win32-msvc:LIBS         =	glu32.lib F:\qt\lib\qgl.lib D:\BMRT\lib\libribout.lib F:\qt\lib\qimgio.lib F:\DevLibs\libjpeg.lib ..\ParticleAPI\particle\particle.lib

TARGET		= flow
CLEAN_FILES +=	*.bck
MOC_DIR		=	moc

HEADERS		= \
		  GLExt.h \
		  MBAStyle.h \
		  aboutDialog.h \
		  addParticleAction.h \
		  basetypes.h \
		  camera.h \
		  cameraWidget.h \
		  colorButton.h \
		  compatibility.h \
		  configFileIO.h \
		  configFlowIO.h \
		  define.h \
		  extern.h \
		  forkVector.h \
		  glDomain.h \
		  glPrimitives.h \
		  glPort.h \
		  glPortCam.h \
		  glPortController.h \
		  glPortOrtho.h \
		  glState.h \
		  glWidget.h \
		  glWidgetOrtho.h \
		  hitList.h \
		  imageFileDialog.h \
		  lightGroup.h \
		  lightGroupWidget.h \
		  mainFlow.h \
		  main.h \
		  mbaCurve.h \
		  mbaCurveSinWidget.h \
		  mbaCurveAssignDialog.h \
		  mbaCurveCollection.h \
		  mbaGLSurface.h \
		  mbaGLSurfaceWidget.h \
		  mbaLight.h \
		  mbaMainWindow.h \
		  mbaRMShader.h \
		  mbaRMShaderWidget.h \
		  mbaRMShaderStringWidget.h \
		  mbaScene.h \
		  mbaSceneWidget.h \
		  mbaSceneTreePartItem.h \
		  mbaSceneTreeWidget.h \
		  mbaSurfaceTabDialog.h \
		  mmath.h \
		  mwidgets.h \
		  noise.h \
		  numInput.h \
		  numInputValid.h \
		  numInTriplef.h \
		  pAction.h \
		  pBool.h \
		  pBoolWidget.h \
		  pDomain.h \
		  pDomainWidget.h \
		  pFloat.h \
		  pFloatWidget.h \
		  pPolyAction.h \
		  pGeometry.h \
		  partDrawOGL.h \
		  particleControl.h \
		  particleControlWidget.h \
		  prefDialog.h \
		  prefDialogCode.h \
		  prefDialogGeneral.h \
		  prefDialogRender.h \
		  prefDialogUI.h \
		  pPolygonObject.h \
		  pPolygonTweak.h \
		  pixmaps.h \
		  renderPanelCode.h \
		  renderPanelCodeConfig.h \
		  renderPanelCodeOptions.h \
		  renderPanelGL.h \
		  renderPanelGeneral.h \
		  renderPanelHosts.h \
		  renderPanelMPEG.h \
		  renderPanelRIB.h \
		  renderPanelTabDialog.h \
		  renderRIB.h \
		  renderman.h \
		  startup.h \
		  shaderPreviewList.h
SOURCES		=  \
		  GLExt.cpp \
		  MBAStyle.cpp \
		  aboutDialog.cpp \
		  addParticleAction.cpp \
		  basetypes.cpp \
		  camera.cpp \
		  cameraWidget.cpp \
		  configFileIO.cpp \
		  configFlowIO.cpp \
		  colorButton.cpp \
		  forkVector.cpp \
		  glDomain.cpp \
		  glPrimitives.cpp \
		  glPort.cpp \
		  glPortCam.cpp \
		  glPortCamMouse.cpp \
		  glPortController.cpp \
		  glPortOrtho.cpp \
		  glPortOrthoMouse.cpp \
		  glState.cpp \
		  glWidget.cpp \
		  glWidgetOrtho.cpp \
		  hitList.cpp \
		  hitListDomain.cpp \
		  hitListLight.cpp \
		  imageFileDialog.cpp \
		  lightGroup.cpp \
		  lightGroupSaveLoad.cpp \
		  lightGroupWidget.cpp \
		  m_opengl.cpp \
		  mbaCurve.cpp \
		  mbaCurveSinWidget.cpp \
		  mbaCurveAssignDialog.cpp \
		  mbaCurveCollection.cpp \
		  mbaGLSurface.cpp \
		  mbaGLSurfaceWidget.cpp \
		  mbaLight.cpp \
		  mbaMainWindow.cpp \
		  mbaRMShader.cpp \
		  mbaRMShaderWidget.cpp \
		  mbaRMShaderStringWidget.cpp \
		  mbaRMShaderWidgetSaveUpdate.cpp \
		  mbaScene.cpp \
		  mbaScene_writeCode.cpp \
		  mbaSceneWidget.cpp \
		  mbaSceneTreePartItem.cpp \
		  mbaSceneTreeWidget.cpp \
		  mbaSurfaceTabDialog.cpp \
		  main.cpp \
		  mainFlow.cpp \
		  mmath.cpp \
		  mwidgets.cpp \
		  noise.cpp \
		  numInput.cpp \
		  numInputValid.cpp \
		  numInTriplef.cpp \
		  pAction.cpp \
		  pPolyAction.cpp \
		  pBool.cpp \
		  pBoolWidget.cpp \
		  pDomain.cpp \
		  pDomainWidget.cpp \
		  pFloat.cpp \
		  pFloatWidget.cpp \
		  pGeometry.cpp \
		  pPolygonObject.cpp \
		  pPolygonTweak.cpp \
		  partDrawOGL.cpp \
		  particleControl.cpp \
		  particleControlAddDel.cpp \
		  particleControlRender.cpp \
		  particleControlSaveLoad.cpp \
		  particleControlWidget.cpp \
		  prefDialogCode.cpp \
		  prefDialogGeneral.cpp \
		  prefDialog.cpp \
		  prefDialogRender.cpp \
		  prefDialogUI.cpp \
		  renderPanelCode.cpp \
		  renderPanelCodeConfig.cpp \
		  renderPanelCodeOptions.cpp \
		  renderPanelGL.cpp \
		  renderPanelGeneral.cpp \
		  renderPanelHosts.cpp \
		  renderPanelMPEG.cpp \
		  renderPanelRIB.cpp \
		  renderPanelTabDialog.cpp \
		  renderRIB.cpp \
		  renderman.cpp \
		  shaderPreviewList.cpp \ 
		  startup.cpp
