#include "GLExt.h"

#include <GL/gl.h>
#include <GL/glext.h>
#include <string.h>

bool GLExt::pointsParameters = false;

void GLExt::initialize()
{
	pointsParameters = isSupported("GL_EXT_point_parameters");
}

bool GLExt::isSupported(const char *extension)
{
	const GLubyte *extensions = 0;
	const GLubyte *start;
	GLubyte *where, *terminator;

	/* Extension names should not have spaces. */
	where = (GLubyte *) strchr(extension, ' ');
	if (where || *extension == '\0')
		return false;
	extensions = glGetString(GL_EXTENSIONS);
	/* It takes a bit of care to be fool-proof about parsing the
	OpenGL extensions string. Don't be fooled by sub-strings,
	etc. */
	start = extensions;
	for (;;) {
		where = (GLubyte *) strstr((const char *) start, extension);
		if (!where)
			break;
		terminator = where + strlen(extension);
		if (where == start || *(where - 1) == ' ')
			if (*terminator == ' ' || *terminator == '\0')
				return true;
		start = terminator;
	}
	return false;
}
