#ifndef JoystickDevice_h
#define JoystickDevice_h

#include "define.h"

//==============================================================================
class JoystickDevice
{
public:
	JoystickDevice();
	~JoystickDevice();
	
	bool	initialize(const char* deviceName = JOYSTICK_DEVICE);
	bool	shutdown();
	
	/**
	 * @return number of axes the joystick supports
	 */
	inline	int			getAxes()		{	return axes;	}
	/**
	 * @return number of buttons the joystick supports
	 */
	inline	int			getButtons()	{	return buttons;	}
	/**
	 * @return version of joystick driver
	 */
	inline	const char*	getVersion()	{	return version;	}	
	/**
	 * @return joystick identifier string
	 */
	inline	const char*	getName()		{	return name;	}
	/**
	 * @return joystick device file descriptor.
	 */
	inline	int			getJoyFD()		{	return joy_fd;	}
	
protected:
	int		joy_fd;	
	int		axes;
	int		buttons;
	char	version[NAME_LENGTH];
	char	name[NAME_LENGTH];
	char	devName[NAME_LENGTH];
};

#endif // JoystickDevice_h



