#ifndef JoystickWidget_h
#define JoystickWidget_h

#include <qlist.h>
#include <qlabel.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qslider.h>
#include <qmenubar.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qsocketnotifier.h>

#include "define.h"
#include "JoystickDevice.h"

//==============================================================================
class JoystickWidget : public QWidget
{
	Q_OBJECT
public:
	JoystickWidget(const char* jsDevice = "/dev/js0", QWidget *parent = 0, const char* name = 0);
	~JoystickWidget();

	bool	initializeJoystick(const char* devName = JOYSTICK_DEVICE);
	
public slots:
	void	testSlot();
	void	joyActivity(int);

private:
	QLabel	*defaultLabel();
	QLabel	*defaultTextLabel(const char* text);
	
protected:
	QVBoxLayout	*topVLayout;
	QGridLayout	*labelLayout;
	QHBoxLayout	*sliderLayout;
	
	QMenuBar	*menuBar;
	QPopupMenu	*fileMenu;
	
	QLabel		*devLabel;
	QLabel		*axesLabel;
	QLabel		*buttonsLabel;
	QLabel		*nameLabel;
	QLabel		*versionLabel;
	
	QSocketNotifier	*joyNotifier;
	JoystickDevice	*joystick;
	
	QLabel			*axisXLabel;
	QLabel			*axisYLabel;
	
	QButtonGroup	*joyButGroup;
	QList<QSlider>	*axisGroup;
};

#endif // JoystickWidget_h
