#include "aboutDialog.h"

#include <qpixmap.h>

#include "extern.h"
extern char * flow_splash_xpm[];

//==============================================================================
AboutDialog::AboutDialog()
	: QDialog(0, "about", true)
{
	flowLabel = new QLabel(this);
	flowLabel->setBackgroundPixmap(QPixmap((const char**)flow_splash_xpm));
//	flowLabel->setFixedSize(flowLabel->sizeHint());
	flowLabel->setFixedSize(310, 260);
	flowLabel->setFrameStyle(QFrame::Sunken | QFrame::Panel );
	
	closeBut = new QPushButton(this);
	closeBut->setText("&close");
	closeBut->setDefault(true);
	
	QLabel *tmpLabel;
	
	tmpLabel = new QLabel(this);
	tmpLabel->setText("flow is\n(c) Copyright 1999 by Mark B. Allan");
	tmpLabel->setFont(*g_font_S);
	tmpLabel->setAlignment(AlignCenter);
	tmpLabel->setMinimumSize(tmpLabel->sizeHint());
	copyFlow = tmpLabel;

	tmpLabel = new QLabel(this);
	tmpLabel->setText("Particle System API is\n(c) Copyright 1997-1998 by David K. McAllister");
	tmpLabel->setFont(*g_font_S);
	tmpLabel->setAlignment(AlignCenter);
	tmpLabel->setMinimumSize(tmpLabel->sizeHint());
	copyParticle = tmpLabel;

	tmpLabel = new QLabel(this);
	tmpLabel->setText("The RenderMan(R) Interface Procedures and RIB Protocol are:\nCopyright 1988, 1989, Pixar.  All rights reserved.\nRenderMan(R) is a registered trademark of Pixar.");
	tmpLabel->setFont(*g_font_S);
	tmpLabel->setAlignment(AlignCenter);
	tmpLabel->setMinimumSize(tmpLabel->sizeHint());
	copyRIB = tmpLabel;
	
	QObject::connect(closeBut, SIGNAL(clicked()), SLOT(accept()) );
	
	topVLayout = new QVBoxLayout(this, 10, 5);
	
	topVLayout->addStretch(1);
	topVLayout->addWidget(flowLabel);
	topVLayout->addStretch(2);
	topVLayout->addWidget(copyFlow);
	topVLayout->addStretch(2);
	topVLayout->addWidget(copyParticle);
	topVLayout->addStretch(2);
	topVLayout->addWidget(copyRIB);
	topVLayout->addStretch(2);
	topVLayout->addSpacing(10);
	topVLayout->addWidget(closeBut);
	topVLayout->addStretch(1);
	
	topVLayout->activate();
	
//	resize(10, 10);
}

//--------------------------------------------------------------------
AboutDialog::~AboutDialog()
{
}
