/**
 * addParticleAction.cpp
 * Copyright 1999 by Mark B. Allan
 * 
 * ParticleAction add widget
 */
#include "addParticleAction.h"
#include "extern.h"

#include "qapplication.h"

/**
 * default constructor
 */
AddParticleActionWidget::AddParticleActionWidget ( QWidget *parent, const char* name)
	: QTabDialog (parent, name, true)
{
//	setFont(*g_font_MB);
	funcType = PFuncUndefined;
	
	//-- Buttons, fonts ----------------
	setOkButton(0);
	setCancelButton("&Cancel");
	
	//-- Lists ------------------------
	stateList = new QListBox(this, "AddAction_StateList");
	stateList->setMinimumSize(80, 40);
	stateList->setFont(*g_font_M);
	stateList->insertItem("Color");
	stateList->insertItem("Color Domain");
	stateList->insertItem("Size");
	stateList->insertItem("Size Domain");
	stateList->insertItem("Starting Age");
	stateList->insertItem("Time Step");
	stateList->insertItem("Velocity");
	stateList->insertItem("Velocity Domain");
	stateList->insertItem("Vertex 2nd Position");
	stateList->insertItem("Vertex 2nd Position Domain");
	stateList->insertItem("Vertex 2nd Position Tracks");

	actionList = new QListBox(this, "AddAction_ActionList");
	actionList->setMinimumSize(80, 40);
	actionList->setFont(*g_font_M);
	actionList->insertItem("Bounce");
	actionList->insertItem("Damping");
	actionList->insertItem("Explosion");
	actionList->insertItem("Follow");
	actionList->insertItem("Gravitate");
	actionList->insertItem("Gravity");
	actionList->insertItem("Jet");
	actionList->insertItem("Kill Old");
	actionList->insertItem("Kill Slow");
	actionList->insertItem("Orbit Line");
	actionList->insertItem("Orbit Point");
	actionList->insertItem("Random Acceleration");
	actionList->insertItem("Random Displace");
	actionList->insertItem("Random Velocity");
	actionList->insertItem("Restore");
	actionList->insertItem("Sink");
	actionList->insertItem("Sink Velocity");
	actionList->insertItem("Source");
	actionList->insertItem("Target Color");
	actionList->insertItem("Target Size");
	actionList->insertItem("Vertex");
	actionList->insertItem("Vortex");
	actionList->insertItem("Turbulence");
	
	polyList = new QListBox(this, "AddAction_PolyList");
	polyList->setMinimumSize(80, 40);
	polyList->setFont(*g_font_M);
	polyList->insertItem("Polygonal Bounce");
	polyList->insertItem("Polygonal Source");
	polyList->insertItem("Polygonal Object(NoOp)");
	
	geomList = new QListBox(this, "AddAction_GeomList");
	geomList->setMinimumSize(80, 40);
	geomList->setFont(*g_font_M);
	geomList->insertItem("sphere");
	geomList->insertItem("cone");
	geomList->insertItem("disk");
	geomList->insertItem("cylinder");
//	geomList->insertItem("hyperboloid");
//	geomList->insertItem("paraboloid");
//	geomList->insertItem("torus");
	
	//-- Connect -----------------------
	QObject::connect(stateList, SIGNAL(selected(int)), SLOT(StateSelected(int)));
	QObject::connect(actionList, SIGNAL(selected(int)), SLOT(ActionSelected(int)));
	QObject::connect(polyList, SIGNAL(selected(int)), SLOT(PolySelected(int)));
	QObject::connect(geomList, SIGNAL(selected(int)), SLOT(GeomSelected(int)));
	
	addTab(stateList, "&State");
	addTab(actionList, "&Action");
	addTab(polyList, "&Poly");
	addTab(geomList, "&Geom");
	
//	setTabEnabled("AddAction_PolyList", false);
	
	resize(300, 520);
}

//--------------------------------------------------------------------
AddParticleActionWidget::~AddParticleActionWidget()
{
}

//--------------------------------------------------------------------
void AddParticleActionWidget::StateSelected(int i)
{
	funcType = PFuncState;
	index = i;
	accept();
}

//--------------------------------------------------------------------
void AddParticleActionWidget::ActionSelected(int i)
{
	funcType = PFuncAction;
	index = i;
	accept();
}

//--------------------------------------------------------------------
void AddParticleActionWidget::PolySelected(int i)
{
	funcType = PFuncPoly;
	index = i;
	accept();
}

//--------------------------------------------------------------------
void AddParticleActionWidget::GeomSelected(int i)
{
	funcType = PFuncGeom;
	index = i;
	accept();
}





