/**
 * addParticleAction.h
 * Copyright 1999 by Mark B. Allan
 * 
 * ParticleAction add widget
 */
#ifndef ADDPARTICLEACTION_H
#define ADDPARTICLEACTION_H

#include <qdialog.h>
#include <qlistbox.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qmainwindow.h>
#include <qtabdialog.h>

#include "mwidgets.h"
/**
 * Tab dialog to select which new action to add.
 */
//==============================================================================
class AddParticleActionWidget : public QTabDialog
{
	Q_OBJECT
public:
	AddParticleActionWidget( QWidget *parent = 0, const char* name = 0);
	~AddParticleActionWidget();
	
	enum FuncType { 
		PFuncUndefined = -1,	/**< Error catcher */
		PFuncState, 			/**< State setting action */
		PFuncAction, 			/**< action action */
		PFuncPoly,  			/**< polygon action */
		PFuncGeom 				/**< RM geometry. Quadrics. */
	 };

	inline	int	selected()	{	return index;	}
	inline	int	WhichType()	{	return funcType;	}
	
protected slots:
	void StateSelected(int);
	void ActionSelected(int);
	void PolySelected(int);
	void GeomSelected(int);
	
private:
	QVBoxLayout	*topLayout;
	QVBoxLayout	*listLayout;
	QHBoxLayout	*stateLayout;
	QHBoxLayout	*actionLayout;
	QHBoxLayout	*polyLayout;

	FuncType	funcType;
	int			index;
	QListBox	*actionList;
	QListBox	*stateList;
	QListBox	*polyList;
	QListBox	*geomList;
	
	QLabel		*stateLabel;
	QLabel		*actionLabel;
	QLabel		*polyLabel;
	
	QButtonGroup	*buttonGroup;
	MToolButton		*ok;

};


#endif
