/**
 * basetypes.cpp
 * Copyright 1999 by Mark B. Allan
 * 
 * primitive classes
 */
#include "basetypes.h"

#include "compatibility.h"
#include <GL/gl.h>
#include <math.h>

#include "extern.h"

//=====================================================
GColor::GColor 	(float inRed, float inGreen, float inBlue, float inAlpha)
{
	r = inRed;	g = inGreen;	b = inBlue; a = inAlpha;
}
GColor::GColor (float *in)
{
	r = in[0];	g = in[1];	b = in[2];	a = 1.0;
}

GColor::GColor 	(const GColor &in)
{
	r = in.r;
	g = in.g;	
	b = in.b; 
	a = in.a;
}

//----------------------------------------------------
GColor& GColor::operator = (const GColor &old)
{
	r = old.r;	g = old.g;	b = old.b;	a = old.a;	
	return *this;
}

//----------------------------------------------------
void	GColor::set (float inRed, float inGreen, float inBlue, float inAlpha)
{
	r = inRed;	g = inGreen;	b = inBlue; a = inAlpha;
}
void	GColor::set (float *in)
{
	r = in[0];	g = in[1];	b = in[2];
}
void	GColor::SetRGB (float inRed, float inGreen, float inBlue)
{
	r = inRed;	g = inGreen;	b = inBlue;
}
void	GColor::SetR (float inRed)
{
	r = inRed;	
}
void	GColor::SetG (float inGreen)
{
	g = inGreen;
}
void	GColor::SetB (float inBlue)
{
	b = inBlue;
}
void	GColor::SetA (float inAlpha)
{
	a = inAlpha;
}

//----------------------------------------------------
float	*GColor::RibColor ()
{
	ribColor[0] = r;
	ribColor[1] = g;
	ribColor[2] = b;
	return (float*)ribColor;
}
	
