/**
 * extern.h
 * Copyright 1999 by Mark B. Allan
 * 
 * Global variables. This file should be smaller...
 */
#include <qcolor.h>
#include <qfont.h>
#include <qiconset.h>
#include <qstrlist.h>
#include <string.h>

extern	bool	g_disableOrtho;

extern	QPalette basePalette;
extern	QPalette flowPalette;

extern	char	*g_fontName;
extern	int		g_fontSize;

class QStyle;
extern	QStyle	*winStyle;
extern	bool	g_winStyleToolBars;

extern	bool	g_persistentGeom;
extern	bool	g_toolTipsEnabled;
extern	bool	g_saveBaseSceneOnExit;
extern	bool	g_killChildrenOnExit;

extern	int		g_randSeed;

extern	bool	g_hasRendermanExec;
extern	bool	g_hasShaderInfoExec;	//FIXME this isn't used currently. popen() on this needs more error checking...
extern	bool	g_hasTiffToJpegExec;
extern	char	*g_rendermanExec;
extern	char	*g_shaderInfoExec;
extern	char	*g_tiffToJpegExec;
extern	char	*g_rendermanOpts;
extern	char	*g_envShaderPath;
extern	char	*g_defaultSurfaceShader;
extern	char	*g_defaultDisplaceShader;
extern	char	*g_compiledShaderExt;
extern	int		g_rendW;
extern	int		g_rendH;
extern	float	g_rendA;
extern	float	g_rendRatio;
extern	float	g_rendCropTop;
extern	float	g_rendCropBot;
extern	float	g_rendCropLeft;
extern	float	g_rendCropRight;
extern	int		g_rendInterlace;
extern	int		g_previewTableCellSize;
extern	int		g_previewRenderSize;
extern	int		g_pixmapCacheSize;
extern	int		g_numPreviewCols;	// Number columns in shader preview
extern	float	g_rendSamples[2];
extern	bool	g_allowTrueDisplace;
extern	bool	g_allowShadows;
extern	bool	g_motionBlur;
extern	int		g_numBlurSteps;

extern	char	*g_homeDir;
extern	char	*g_flowHome;
extern	char	*g_shadersPath;
extern	char	*g_shaderSurfDir;
extern	char	*g_shaderDispDir;
extern	char	*g_rendName;

extern	int		g_partSkip;
extern	float	g_moveSpeed;
extern	float	g_gridUnitSize;
extern	int		g_gridNumUnits;
extern	bool	g_glThick;
extern	bool	g_glFastParticles;
extern	bool	g_glSortParticles;
	
extern	QStrList	g_surfaceShadersList;
extern	QStrList	g_displacementShadersList;
extern	QStrList	g_lightShadersList;
extern	QStrList	g_imagerShadersList;
extern	QStrList	g_volumeShadersList;
void	CheckShaders();
void	SortShaders(QStrList& masterList);
void	StrListFromPath(QStrList *list, const char* path);

extern	int		g_numLabelWidth;
extern	int		g_numInputWidth;
extern	int		g_height_S;
extern	int		g_height_M;
extern	int		g_comboHeight;


extern	QFont		*g_font_S;
extern	QFont		*g_font_M;
extern	QFont		*g_font_L;
extern	QFont		*g_font_SB;
extern	QFont		*g_font_MB;
extern	QFont		*g_font_LB;
extern	QFont		*g_font_SBI;
extern	QFont		*g_font_MBI;
extern	QFont		*g_font_LBI;

extern	char		*flowIcon_xpm[];
extern	QIconSet	*icoSet_add;
extern	QIconSet	*icoSet_close;
extern	QIconSet	*icoSet_copy;
extern	QIconSet	*icoSet_clone;
extern	QIconSet	*icoSet_shade;
extern	QIconSet	*icoSet_del;
extern	QIconSet	*icoSet_dis;
extern	QIconSet	*icoSet_dis_on;
extern	QIconSet	*icoSet_dwn;
extern	QIconSet	*icoSet_up;
extern	QIconSet	*icoSet_lock;
extern	QIconSet	*icoSet_lock_on;
extern	QIconSet	*icoSet_rm;
extern	QIconSet	*icoSet_play;
extern	QIconSet	*icoSet_rew;
extern	QIconSet	*icoSet_paste;
extern	QIconSet	*icoSet_clear;
extern	QIconSet	*icoSet_dis_s;
extern	QIconSet	*icoSet_shade_s;
extern	QPixmap		*pix_file;
extern	QPixmap		*pix_save;

extern	int		g_frame;

class	MainFlow;
class	MBAScene;
class	MBASceneWidget;
class	MBASurfaceTabDialog;
class	RenderPanelTabDialog;
class	RenderRIB;
class	LightGroupWidgetFrame;
class	LightGroupWidget;
class	CameraView;
class	ParticleControl;
class	GlPortCam;
class	GLWidget;
class	ParticleControlWidget;
class	ParticleControlFrame;
class	MBACurveCollection;
class	PolygonTweak;
extern	QWidget					*g_mainWidget;
extern	MainFlow				*g_mainFlow;
extern	MBAScene				*g_scene;
extern	MBASceneWidget			*g_sceneWidget;
extern	LightGroupWidgetFrame	*g_lightGroupWidgetFrame;
extern	LightGroupWidget		*g_lightGroupWidget;
extern	CameraView				*g_globalCam;
extern	GLWidget				*g_glWidget;
extern	GlPortCam				*g_camGLPort;
extern	ParticleControlWidget	*g_particleControlWidget;
extern	ParticleControlFrame	*g_particleControlFrame;
extern	MBACurveCollection		*g_curveControl;
extern	PolygonTweak			*g_polyTweakWidget;
extern	MBASurfaceTabDialog		*g_surfaceEditWidget;
extern	RenderPanelTabDialog	*g_renderOptions;
extern	RenderRIB				*g_renderRIB;

extern	int		g_winManXAdd;
extern	int		g_winManYAdd;
extern	int		g_dskTopW;
extern	int		g_dskTopH;

extern	bool	GL__lighting;
extern	int		GL__polygonMode;

extern	bool	g_glInitialized;
extern	bool	g_glCullFace;
extern	bool	g_glBlend;
extern	bool	g_glAlphaTest;
extern	bool	g_glTwoSideLight;

extern	int		g_fps;

extern	float	g_gridXOffset;
extern	float	g_gridYOffset;
extern	float	g_gridZOffset;

