/**
 * glPort.h
 * Copyright 1999 by Mark B. Allan
 * 
 * base GL widget that does all the work
 */
#ifndef glPort_h
#define glPort_h

#include <qgl.h>
#include <qevent.h>
#include <qtimer.h>
#include <qlist.h>
#include <qlcdnumber.h> 
#include <qdatetime.h> 
#include <qlabel.h> 
#include <qpoint.h>
#include <stdio.h>

#include <particle/papi.h>

#include "glState.h"
#include "mwidgets.h"

class CameraView;
class GLWidget; 
class PPolygonObject;

/**
 * base GL port thing. This stuff needs to be rewritten.
 */
//==============================================================================
class GlPort	: public QGLWidget
{
	Q_OBJECT
public:
	GlPort (QWidget* parent, const char* name, const QGLWidget* listShare);
	~GlPort ();

    virtual	void resizeGL( int w, int h ) = 0;
	
	void	setGLState(GLState &in)	{ glState = in; }
	GLState	&getGLState()			{ return glState; }
	/**
	 * return immediately from 'paintGL' if true
	 */
	static inline void	disableGLDraw(bool status)	{	noGLDraw = status;	}
	
protected:
	virtual	void		initializeGL()  = 0;
    virtual	void		paintGL()       = 0;
	virtual	void 		mousePressEvent(QMouseEvent *msEv)		= 0;
	virtual	void 		mouseReleaseEvent(QMouseEvent *msEv)	= 0;
	virtual	void 		mouseMoveEvent(QMouseEvent *msEv)		= 0;

protected:
    static int*	displayLists;
    static int	totalLists;
    static int	listUsers;
    static int	portIDSeed;
	static bool	noGLDraw;
	
	int			portID;
	int			width;
	int			height;
	double		aspect;
	CameraView	*currentCam;
	
	int		glGridDL;
	bool	gridXY;
	bool	gridXZ;
	bool	gridYZ;
	
	GLState	glState;
};


#endif // glPort_h
