#ifndef glPortController_h
#define glPortController_h

#include <qtimer.h>

#include "glPortCam.h"
#include "glPortOrtho.h"
#include "define.h"

/**
 * This class will control gl screen refresh to the viewports. It's
 * necessary because updating GL based on mouse movements clobbers the
 * timer-based refresh of the animation window.
 */
//==============================================================================
class GlPortController
{
public:
	GlPortController(GlPortCam *baseContext);
	~GlPortController();

	void	registerOrthoUpdateGL(int index);
	
protected:
	GlPortCam	*curCamPort;						/**< current camera port */
	GlPortOrtho	*orthoPort[NUM_ORTHO_PORTS];		/**< array of orthographic ports */
	bool		updateOrtho[NUM_ORTHO_PORTS];		/**< flag array to control timer-based ortho updates */

	QTimer	*timer;
	int		timerID;
	bool	simulationEngaged;
};


#endif //glPortController_h

