/**
 * glPrimitives.h
 * Copyright 1999 by Mark B. Allan
 * 
 * GL equivalents of RM primitives, etc.
 */
#include "compatibility.h"
#include <GL/gl.h>
#include <stdlib.h>
#include <stdio.h>

#include "glPrimitives.h"
#include "extern.h"

//FIXME - -------------------------------------------------------------
//FIXME -  PRETTY MUCH EVERYTHING IN glPrimitives NEEDS TO BE REWRITTEN
//FIXME - -------------------------------------------------------------

typedef	float RglPoint[3];

//====================================================
// NOTES: 
// drawing the 'X' grid means to draw the YZ grid, etc
// glColor should be called prior to drawing the grid.
void	DrawGlGrid (bool X, bool Y, bool Z, float unitSize, int numUnits, float color)
{
	float	clrBase = color;
	float	hBase   = color*0.75;
	float	clrAdd  = 0.5;
	float	width0  = 1.0f;
	float	width1  = 3.0f;
	float	i; 	// don't want to do all that casting, so make it a float...
	float	totalSize = unitSize*numUnits;
	float	letter = totalSize + unitSize;	// center of axis labels
	float	hu = 0.5f*unitSize;				// 1/2 size of axis labels
	
	glLineWidth(1.0);
	glTranslatef(  g_gridXOffset,  g_gridYOffset,  g_gridZOffset );
	if (X) // draw YZ grid
	{
		glColor3f(clrBase, clrBase, clrBase);
		if(g_glThick) glLineWidth(width0);
//		glNormal3f(1.0f, 0.0f, 0.0f);
		glBegin(GL_LINES);
		for (i = 1.0; i < numUnits; i++)
		{
			glVertex3f ( 0.0f,   totalSize,    i*unitSize  );
			glVertex3f ( 0.0f,        0.0f,    i*unitSize  );
			glVertex3f ( 0.0f,   totalSize,   -i*unitSize  );
			glVertex3f ( 0.0f,  	  0.0f,   -i*unitSize  );
			glVertex3f ( 0.0f,   i*unitSize,   totalSize   );
			glVertex3f ( 0.0f,   i*unitSize,  -totalSize   );
			glVertex3f ( 0.0f,  	   0.0f,   totalSize   );
			glVertex3f ( 0.0f,  	   0.0f,  -totalSize   );
		}
		glEnd();
		if(g_glThick) glLineWidth(width1);
		glBegin(GL_LINES);
		glVertex3f (  0.0f,   totalSize,           numUnits*unitSize  );
		glVertex3f (  0.0f, 	   0.0f,           numUnits*unitSize  );
		glVertex3f (  0.0f,   totalSize,          -numUnits*unitSize  );
		glVertex3f (  0.0f, 	   0.0f,          -numUnits*unitSize  );
		glVertex3f (  0.0f,   numUnits*unitSize,   totalSize          );
		glVertex3f (  0.0f,   numUnits*unitSize,  -totalSize          );
		glVertex3f (  0.0f,         	   0.0f,   totalSize          );
		glVertex3f (  0.0f,         	   0.0f,  -totalSize          );
		
		//label Y
		glColor3f(clrBase, clrBase+clrAdd, clrBase);
		glVertex3f (  0.0f,   totalSize,           0.0f               );
		glVertex3f (  0.0f,        0.0f,           0.0f               );
		glVertex3f (  0.0f,  letter+hu, -hu  );
		glVertex3f (  0.0f,  letter   ,  0.0f);
		glVertex3f (  0.0f,  letter+hu,  hu  );
		glVertex3f (  0.0f,  letter   ,  0.0f);
		glVertex3f (  0.0f,  letter,     0.0f);
		glVertex3f (  0.0f,  letter-hu,  0.0f);
		//label Z
		glColor3f(clrBase, clrBase, clrBase+clrAdd*0.3);
		glVertex3f (  0.0f,   0.0f,               -totalSize          );
		glVertex3f (  0.0f,   0.0f,                0.0f               );
		glColor3f(clrBase, clrBase, clrBase+clrAdd);
		glVertex3f (  0.0f,   0.0f,                totalSize          );
		glVertex3f (  0.0f,   0.0f,                0.0f               );
		glVertex3f (  0.0f,  hu,  letter-hu );
		glVertex3f (  0.0f,  hu,  letter+hu );
		glVertex3f (  0.0f,  hu,  letter+hu );
		glVertex3f (  0.0f, -hu,  letter-hu );
		glVertex3f (  0.0f, -hu,  letter-hu );
		glVertex3f (  0.0f, -hu,  letter+hu );
		glEnd();
	}
	if (Y) // draw XZ grid
	{
		glColor3f(clrBase, clrBase, clrBase);
		if(g_glThick) glLineWidth(width0);
//		glNormal3f(0.0f, 1.0f, 0.0f);
		glBegin(GL_LINES);
		for (i = 1.0; i < numUnits; i++)
		{
			glVertex3f (   totalSize,  0.0f,   i*unitSize  );
			glVertex3f (  -totalSize,  0.0f,   i*unitSize  );
			glVertex3f (   totalSize,  0.0f,  -i*unitSize  );
			glVertex3f (  -totalSize,  0.0f,  -i*unitSize  );
			glVertex3f (   i*unitSize, 0.0f,   totalSize   );
			glVertex3f (   i*unitSize, 0.0f,  -totalSize   );
			glVertex3f (  -i*unitSize, 0.0f,   totalSize   );
			glVertex3f (  -i*unitSize, 0.0f,  -totalSize   );
		}
		glEnd();
		if(g_glThick) glLineWidth(width1);
		glBegin(GL_LINES);
		glVertex3f (   totalSize,		   0.0f,   numUnits*unitSize  );
		glVertex3f (  -totalSize,		   0.0f,   numUnits*unitSize  );
		glVertex3f (   totalSize,		   0.0f,  -numUnits*unitSize  );
		glVertex3f (  -totalSize,		   0.0f,  -numUnits*unitSize  );
		glVertex3f (   numUnits*unitSize,  0.0f,   totalSize		  );
		glVertex3f (   numUnits*unitSize,  0.0f,  -totalSize		  );
		glVertex3f (  -numUnits*unitSize,  0.0f,   totalSize		  );
		glVertex3f (  -numUnits*unitSize,  0.0f,  -totalSize		  );
		//label Z
		glColor3f(hBase, hBase, hBase+clrAdd*0.5);
		glVertex3f (   0.0f,			   0.0f,   0.0f		  );
		glVertex3f (   0.0f,			   0.0f,  -totalSize		  );
		glColor3f(hBase, hBase, hBase+clrAdd);
		glVertex3f (   0.0f,			   0.0f,   totalSize		  );
		glVertex3f (   0.0f,			   0.0f,   0.0f		  );
		glVertex3f (   hu,  0.0f, letter-hu );
		glVertex3f (   hu,  0.0f, letter+hu );
		glVertex3f (   hu,  0.0f, letter+hu );
		glVertex3f (  -hu,  0.0f, letter-hu );
		glVertex3f (  -hu,  0.0f, letter-hu );
		glVertex3f (  -hu,  0.0f, letter+hu );
		//label X
		glColor3f(hBase+clrAdd*0.5, hBase, hBase);
		glVertex3f (   0.0f,	   0.0f,   0.0f	  );
		glVertex3f (  -totalSize,  0.0f,   0.0f   );
		glColor3f(hBase+clrAdd, hBase, hBase);
		glVertex3f (   totalSize,	  0.0f,   0.0f   );
		glVertex3f (   0.0f,		  0.0f,   0.0f   );
		glVertex3f (  letter-hu, 0.0f,  hu );
		glVertex3f (  letter+hu, 0.0f, -hu );
		glVertex3f (  letter+hu, 0.0f,  hu );
		glVertex3f (  letter-hu, 0.0f, -hu );
		glEnd();
	}
	if (Z) // draw XY grid
	{
		glColor3f(clrBase, clrBase, clrBase);
		if(g_glThick) glLineWidth(width0);
		glBegin(GL_LINES);
		//glNormal3f(0.0f, 0.0f, 1.0f);
		for (i = 1.0; i < numUnits; i++)
		{
			glVertex3f (   totalSize,	 i*unitSize,   0.0f);
			glVertex3f (  -totalSize,	 i*unitSize,   0.0f);
			glVertex3f (   totalSize,	       0.0f,   0.0f);
			glVertex3f (  -totalSize,   	   0.0f,   0.0f);
			glVertex3f (   i*unitSize,   totalSize ,   0.0f);
			glVertex3f (   i*unitSize,  	   0.0f,   0.0f);
			glVertex3f (  -i*unitSize,   totalSize ,   0.0f);
			glVertex3f (  -i*unitSize,  	   0.0f,   0.0f);
		}
		glEnd();
		if(g_glThick) glLineWidth(width1);
		glBegin(GL_LINES);
		glVertex3f (   totalSize,			numUnits*unitSize,    0.0f);
		glVertex3f (  -totalSize,			numUnits*unitSize,    0.0f);
		glVertex3f (   totalSize,		 		    	 0.0f,    0.0f);
		glVertex3f (  -totalSize,		 		    	 0.0f,    0.0f);
		glVertex3f (   numUnits*unitSize,	totalSize		 ,	  0.0f);
		glVertex3f (   numUnits*unitSize,		    	 0.0f,	  0.0f);
		glVertex3f (  -numUnits*unitSize,	totalSize		 ,	  0.0f);
		glVertex3f (  -numUnits*unitSize,   			 0.0f,	  0.0f);
		//label X
		glColor3f(hBase+clrAdd*0.5, hBase, hBase);
		glVertex3f (   0.0f,			0.0f			 ,	  0.0f);
		glVertex3f (  -totalSize,		0.0f			 ,	  0.0f);
		glColor3f(hBase+clrAdd, hBase, hBase);
		glVertex3f (   totalSize,		0.0f			 ,	  0.0f);
		glVertex3f (   0.0f,			0.0f			 ,	  0.0f);
		glVertex3f (  letter-hu,  hu, 0.0f );
		glVertex3f (  letter+hu, -hu, 0.0f );
		glVertex3f (  letter+hu,  hu, 0.0f );
		glVertex3f (  letter-hu, -hu, 0.0f );
		//label Y
		glColor3f(hBase, hBase+clrAdd, hBase);
		glVertex3f (   0.0f,				totalSize		 ,	  0.0f);
		glVertex3f (   0.0f,			    0.0f			 ,	  0.0f);
		glVertex3f ( -hu  ,  letter+hu,  0.0f);
		glVertex3f (  0.0f,  letter   ,  0.0f);
		glVertex3f (  hu  ,  letter+hu,  0.0f);
		glVertex3f (  0.0f,  letter   ,  0.0f);
		glVertex3f (  0.0f,  letter   ,  0.0f);
		glVertex3f (  0.0f,  letter-hu,  0.0f);
		glEnd();
	}
	glTranslatef( -g_gridXOffset, -g_gridYOffset, -g_gridZOffset );
}

/**
 * RiSphere clone
 */
void RglSphere (float radius, float zmin, float zmax, float thetamax, int detail)
{
	int			ixy;
	int			iz;
	int			zDensity;
	int			xyDensity;
	float		x,y,z;
	float		xySize;
	float		rad;
	float		zrad;
	float		zradStep; 
	float		radStep;
	float		zminRad;
	float		zmaxRad;
	
	//-- do some quick error checking
	if (!radius || !thetamax || zmin == zmax )	return;
	if (thetamax >  360.0f)	thetamax = 360.0f;
	if (thetamax < -360.0f)	thetamax = -360.0f;
	if (zmin < -radius)	zmin = -radius;
	if (zmin >  radius)	zmin = radius;
	if (zmax < -radius)	zmax = -radius;
	if (zmax >  radius)	zmax = radius;

	//-- set number of y polygons to half that of detail, & account for partial spheres
	zDensity = abs((int)( ((zmax-zmin)/radius)*(float)detail )/3);
	if (zDensity < 2)	zDensity = 2;
	xyDensity = abs((int)( (D2RAD(thetamax)/(2.0*M_PI))*(float)detail ));
	if (xyDensity < 4)	xyDensity = 4;

	//-- make space for vertices
	RglPoint **verts = new RglPoint*[zDensity+1];
	RglPoint **norms = new RglPoint*[zDensity+1];
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		norms[iz] = new RglPoint[xyDensity+1];
		verts[iz] = new RglPoint[xyDensity+1];
	}
		
	zmaxRad = -acos(zmax/radius);
	zminRad = -acos(zmin/radius);
	
	zradStep = (zmaxRad-zminRad)/(float)(zDensity);
	radStep  = D2RAD(thetamax)/(float)xyDensity;
	
	zrad = zmaxRad;
	
	for (iz = 0; iz < zDensity+1; iz++)
	{
		z = cos(zrad) * radius;
		rad = -M_PI/2.0;
		xySize = sin(zrad) * radius;
		for(ixy = 0; ixy < (xyDensity+1); ixy++)
		{
			x = sin (rad)*xySize;	
			y = cos (rad)*xySize;
			verts[iz][ixy][0] = norms[iz][ixy][0] = x;	
			verts[iz][ixy][1] = norms[iz][ixy][1] = y;
			verts[iz][ixy][2] = norms[iz][ixy][2] = z;
			normalizeVec(norms[iz][ixy]);
			rad += radStep;
		}
		zrad -= zradStep;
	}			

	for (iz = 0; iz < zDensity; iz++)
	{
		glBegin(GL_QUAD_STRIP);
		if(zmin < zmax) //-- if we want to flip the normals, swap zmin and zmax
			for(ixy = 0; ixy <= xyDensity; ixy++)
			{
				glNormal3fv(norms[iz+1][ixy]);
				glVertex3fv(verts[iz+1][ixy]);
				glNormal3fv(norms[iz][ixy]);
				glVertex3fv(verts[iz][ixy]);
			}
		else
			for(ixy = 0; ixy <= xyDensity; ixy++)
			{
				glNormal3f( -norms[iz+1][ixy][0], 
							-norms[iz+1][ixy][1], 
							-norms[iz+1][ixy][2]);
				glVertex3fv(verts[iz+1][ixy]);
				glNormal3f( -norms[iz][ixy][0], 
							-norms[iz][ixy][1], 
							-norms[iz][ixy][2]);
				glVertex3fv(verts[iz][ixy]);
			}
		glEnd();
	}
	
	//-- cleanup
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		delete []verts[iz];
		delete []norms[iz];
	}
	delete []verts;
	delete []norms;
}

/**
 * RiDisk clone
 */
//--------------------------------------------------------------------
void RglDisk (float height, float radius, float thetamax, int detail)
{
	//-- Special case for faster drawing...
	if(detail == 5 && thetamax == 360.0)
	{
		glNormal3f(0.0, 0.0, 1.0);
		glBegin(GL_TRIANGLE_FAN);
		glVertex3f( 0.000000, 0.000000, height);
		glVertex3f(radius* 1.000000,        0.000000, height);
		glVertex3f(radius* 0.309017,radius*-0.951057, height);
		glVertex3f(radius*-0.809017,radius*-0.587785, height);
		glVertex3f(radius*-0.809017,radius* 0.587785, height);
		glVertex3f(radius* 0.309017,radius* 0.951057, height);
		glVertex3f(radius* 1.000000,        0.000000, height);
		glEnd();
		return;
	}
	
	int 	zDensity;
	int		xyDensity;
	int		ixy;
	int		iz;
	float	x,y;
	float	rad;
	float	radStep;
	float	norm[3];
	
	//-- do some kludgy error checking
	if ( radius == 0.0f || thetamax == 0.0f  )
		return;
	if (thetamax >  360.0f)	thetamax = 360.0f;
	if (thetamax < -360.0f)	thetamax = -360.0f;
	
	//-- calculate tesselation
	xyDensity = abs((int)( (D2RAD(thetamax)/(2.0*M_PI))*(float)detail ));
	zDensity = abs((int)((float)detail/4.0f));
	if		(xyDensity < 4)		xyDensity = 4;
	else if	(xyDensity > 100)	xyDensity = 100;
	if		(zDensity < 2)		zDensity = 2;
	else if(zDensity > 100)		zDensity = 100;
	
	//-- make space for vertices
	RglPoint	**verts = new RglPoint*[zDensity+1];
	RglPoint	**norms = new RglPoint*[zDensity+1];
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		norms[iz] = new RglPoint[xyDensity+1];
		verts[iz] = new RglPoint[xyDensity+1];
		for(ixy = 0; ixy < xyDensity+1; ixy++)
		{
			norms[iz][ixy][0] = 0.0f;
			norms[iz][ixy][1] = 0.0f;
			norms[iz][ixy][2] = 0.0f;
		}
	}
	
	//-- Calculate tip and base
	radStep	= (D2RAD(thetamax))/( (float)xyDensity );
	rad		= M_PI/2.0;
	for (ixy = 0; ixy < xyDensity+1; ixy++)
	{
		//-- verts for tip
		verts[0][ixy][0] = verts[0][ixy][1] = 0.0f;
		verts[0][ixy][2] = height;
		//-- verts for base
		x = sin (rad)*radius;	
		y = cos (rad)*radius;
		verts[zDensity-1][ixy][0] = x;
		verts[zDensity-1][ixy][1] = y;
		verts[zDensity-1][ixy][2] = height;
		if (ixy > 0)
		{
			if(thetamax < 0.0f)
				calcNormal	(norm, verts[0][ixy-1], verts[zDensity-1][ixy-1], verts[zDensity-1][ixy]);
			else
				calcNormal	(norm, verts[0][ixy-1], verts[zDensity-1][ixy], verts[zDensity-1][ixy-1]);
			norms[0][ixy][0] += norm[0];
			norms[0][ixy][1] += norm[1];
			norms[0][ixy][2] += norm[2];
			norms[0][ixy-1][0] += norm[0];
			norms[0][ixy-1][1] += norm[1];
			norms[0][ixy-1][2] += norm[2];
		}
		rad += radStep;
	}
	norms[0][0][0] += norms[0][xyDensity][0];
	norms[0][0][1] += norms[0][xyDensity][1];
	norms[0][0][2] += norms[0][xyDensity][2];
	norms[0][xyDensity][0] += norms[0][0][0];
	norms[0][xyDensity][1] += norms[0][0][1];
	norms[0][xyDensity][2] += norms[0][0][2];
	
	for(ixy = 0; ixy <  xyDensity+1; ixy++)
	{
		normalizeVec(norms[0][ixy]);
		norms[zDensity-1][ixy][0] = norms[0][ixy][0] ;
		norms[zDensity-1][ixy][1] = norms[0][ixy][1] ;
		norms[zDensity-1][ixy][2] = norms[0][ixy][2] ;
	}
		
	//-- Interpolate tesselation
	float	zDf = (float)zDensity-1;
	float	izf;
	for(iz = 1; iz < zDensity-1; iz++)
	{
		izf = (float)iz;
		for (ixy = 0; ixy < xyDensity+1; ixy++)
		{
			verts[iz][ixy][0] = verts[0][ixy][0]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][0]*(izf/zDf);
			verts[iz][ixy][1] = verts[0][ixy][1]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][1]*(izf/zDf);
			verts[iz][ixy][2] = verts[0][ixy][2]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][2]*(izf/zDf);
			norms[iz][ixy][0] = norms[0][ixy][0];
			norms[iz][ixy][1] = norms[0][ixy][1];
			norms[iz][ixy][2] = norms[0][ixy][2];
		}
	}
	
	//-- Draw tip
	float s1, t1, t2, zd, xyd;
	zd	= zDensity-1.0;
	xyd	= xyDensity-1.0;
	
	s1 = 0.0;
	t1 = 1.0;	
	glBegin(GL_TRIANGLE_FAN);
	glTexCoord2f(s1, t1);
	glNormal3fv(norms[0][0]);
	glVertex3fv(verts[0][0]);
	for (ixy = xyDensity; ixy >= 0; ixy--)
	{
		s1 = ixy/xyd;
		glTexCoord2f(s1, t1);
		glVertex3fv(verts[1][ixy]);
	}
	glEnd();
	//-- Draw the rest
	for(iz = 1; iz < zDensity-1; iz++)
	{
		t1 = (zd-iz)/zd;
		t2 = (zd-iz-1.0)/zd;
		glBegin(GL_QUAD_STRIP);
		izf = (float)iz;
		for (ixy = 0; ixy < xyDensity+1; ixy++)
		{
			s1 = ixy/xyd;
			glTexCoord2f(s1, t2);
			glVertex3fv(verts[iz+1][ixy]);
			glTexCoord2f(s1, t1);
			glVertex3fv(verts[iz][ixy]);
		}
		glEnd();
	}
	
	//-- cleanup
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		delete []verts[iz];
		delete []norms[iz];
	}
	delete []verts;
	delete []norms;
}

/**
 * RiCone clone
 */
//--------------------------------------------------------------------
void RglCone (float height, float radius, float thetamax, int detail)
{
	int 	zDensity;
	int		xyDensity;
	int		ixy;
	int		iz;
	float	x;
	float	y;
	float	rad;
	float	radStep;
	float	norm[3];
	
	//-- do some quick error checking
	if (!radius || !thetamax)	return;
	if (thetamax >  360.0f)		thetamax =  360.0f;
	if (thetamax < -360.0f)		thetamax = -360.0f;
	
	//-- calculate tesselation
	xyDensity	= abs((int)( (D2RAD(thetamax)/(2.0*M_PI))*(float)detail ));
	zDensity	= abs((int)((height/radius)*((float)detail/5.0f)));
	if 		(xyDensity < 4)		xyDensity = 4;
	else if	(xyDensity > 100)	xyDensity = 100;
	if		(zDensity < 2)		zDensity  = 2;
	else if	(zDensity > 100)	zDensity  = 100;
	
	//-- make space for vertices
	RglPoint	**verts = new RglPoint*[zDensity+1];
	RglPoint	**norms = new RglPoint*[zDensity+1];
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		norms[iz] = new RglPoint[xyDensity+1];
		verts[iz] = new RglPoint[xyDensity+1];
		for(ixy = 0; ixy < xyDensity+1; ixy++)
		{
			norms[iz][ixy][0] = 0.0f;
			norms[iz][ixy][1] = 0.0f;
			norms[iz][ixy][2] = 0.0f;
		}
	}
	
	//-- Calculate tip and base
	radStep	= D2RAD(thetamax)/(float)xyDensity;
	rad		= M_PI/2.0;
	for (ixy = 0; ixy < xyDensity+1; ixy++)
	{
		//-- verts for tip
		verts[0][ixy][0] = verts[0][ixy][1] = 0.0f;
		verts[0][ixy][2] = height;
		//-- verts for base
		x = sin (rad)*radius;	
		y = cos (rad)*radius;
		verts[zDensity-1][ixy][0] = x;
		verts[zDensity-1][ixy][1] = y;
		verts[zDensity-1][ixy][2] = 0.0f;
		if (ixy > 0)
		{
			if(thetamax < 0.0f)
				calcNormal	(norm, verts[0][ixy-1], verts[zDensity-1][ixy-1], verts[zDensity-1][ixy]);
			else
				calcNormal	(norm, verts[0][ixy-1], verts[zDensity-1][ixy], verts[zDensity-1][ixy-1]);
			norms[0][ixy][0] += norm[0];
			norms[0][ixy][1] += norm[1];
			norms[0][ixy][2] += norm[2];
			norms[0][ixy-1][0] += norm[0];
			norms[0][ixy-1][1] += norm[1];
			norms[0][ixy-1][2] += norm[2];
		}
		rad += radStep;
	}
	if ( fabs(thetamax) > 350.0)
	{
		norms[0][0][0] += norms[0][xyDensity][0];
		norms[0][0][1] += norms[0][xyDensity][1];
		norms[0][0][2] += norms[0][xyDensity][2];
		norms[0][xyDensity][0] += norms[0][0][0];
		norms[0][xyDensity][1] += norms[0][0][1];
		norms[0][xyDensity][2] += norms[0][0][2];
	}
	for(ixy = 0; ixy <  xyDensity+1; ixy++)
	{
		normalizeVec(norms[0][ixy]);
		norms[zDensity-1][ixy][0] = norms[0][ixy][0] ;
		norms[zDensity-1][ixy][1] = norms[0][ixy][1] ;
		norms[zDensity-1][ixy][2] = norms[0][ixy][2] ;
	}
		
	//-- Interpolate tesselation
	float	zDf = (float)zDensity-1;
	float	izf;
	for(iz = 1; iz < zDensity-1; iz++)
	{
		izf = (float)iz;
		for (ixy = 0; ixy < xyDensity+1; ixy++)
		{
			verts[iz][ixy][0] = verts[0][ixy][0]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][0]*(izf/zDf);
			verts[iz][ixy][1] = verts[0][ixy][1]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][1]*(izf/zDf);
			verts[iz][ixy][2] = verts[0][ixy][2]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][2]*(izf/zDf);
			norms[iz][ixy][0] = norms[0][ixy][0];
			norms[iz][ixy][1] = norms[0][ixy][1];
			norms[iz][ixy][2] = norms[0][ixy][2];
		}
	}
	
	float s1, s2, t1, t2, zd, xyd;
	zd	= zDensity-1.0;
	xyd	= xyDensity-1.0;
	//-- Draw tip
	t1 = 1.0;
	t2 = (zd-1.0)/zd;
	glBegin(GL_TRIANGLES);
	for (ixy = 0; ixy < xyDensity; ixy++)
	{
		s1 = ixy/xyd;
		s2 = (ixy+1.0)/xyd;
		
		glTexCoord2f(s1, t1);
		glNormal3fv(norms[0][ixy]);
		glVertex3fv(verts[0][ixy]);
		
		glTexCoord2f(s2, t2);
		glNormal3fv(norms[1][ixy+1]);
		glVertex3fv(verts[1][ixy+1]);
		
		glTexCoord2f(s1, t2);
		glNormal3fv(norms[1][ixy]);
		glVertex3fv(verts[1][ixy]);
	}
	glEnd();
	//-- Draw the rest
	for(iz = 1; iz < zDensity-1; iz++)
	{
		t1 = (zd-iz)/zd;
		t2 = (zd-iz-1.0)/zd;
		glBegin(GL_QUAD_STRIP);
		izf = (float)iz;
		for (ixy = 0; ixy < xyDensity+1; ixy++)
		{
			s1 = ixy/xyd;
			
			glTexCoord2f(s1, t2);
			glNormal3fv(norms[iz+1][ixy]);
			glVertex3fv(verts[iz+1][ixy]);
			
			glTexCoord2f(s1, t1);
			glNormal3fv(norms[iz][ixy]);
			glVertex3fv(verts[iz][ixy]);
		}
		glEnd();
	}
	//-- Cleanup
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		delete []verts[iz];
		delete []norms[iz];
	}
	delete []verts;
	delete []norms;
	
}

/**
 * RiCylinder clone
 */
//--------------------------------------------------------------------
void RglCylinder (float radius, float zmin, float zmax, float thetamax, int detail)
{
	int 	zDensity;
	int		xyDensity;
	int		ixy;
	int		iz;
	float	x;
	float	y;
	float	rad;
	float	radStep;
	
	//-- do some quick error checking
	if (!radius || !thetamax)	return;
	if (thetamax >  360.0f)	thetamax = 360.0f;
	if (thetamax < -360.0f)	thetamax = -360.0f;
	
	//-- calculate tesselation
	xyDensity	= abs((int)( (D2RAD(thetamax)/(2.0*M_PI))*(float)detail ));
	zDensity	= abs((int)(((zmax-zmin)/radius)*((float)detail/10.0f)));
	if		(xyDensity < 4)		xyDensity = 4;
	else if	(xyDensity > 100)	xyDensity = 100;
	if		(zDensity < 2)		zDensity = 2;
	else if(zDensity > 100)		zDensity = 100;
	
	//-- make space for vertices
	RglPoint	**verts = new RglPoint*[zDensity+1];
	RglPoint	**norms = new RglPoint*[zDensity+1];
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		norms[iz] = new RglPoint[xyDensity+1];
		verts[iz] = new RglPoint[xyDensity+1];
		for(ixy = 0; ixy < xyDensity+1; ixy++)
		{
			norms[iz][ixy][0] = 0.0f;
			norms[iz][ixy][1] = 0.0f;
			norms[iz][ixy][2] = 0.0f;
		}
	}
	
	//-- calculate min and max
	radStep	= (D2RAD(thetamax))/( (float)xyDensity );
	rad		= M_PI/2.0;
	for (ixy = 0; ixy < xyDensity+1; ixy++)
	{
		x = sin (rad)*radius;	
		y = cos (rad)*radius;
		verts[0][ixy][0] = verts[zDensity-1][ixy][0] = x;
		verts[0][ixy][1] = verts[zDensity-1][ixy][1] = y;
		verts[0][ixy][2] = zmin;
		verts[zDensity-1][ixy][2] = zmax;
		norms[0][ixy][0] = norms[zDensity-1][ixy][0] = x;
		norms[0][ixy][1] = norms[zDensity-1][ixy][1] = y;
		norms[0][ixy][2] = norms[zDensity-1][ixy][2] = 0.0;
		normalizeVec(norms[0][ixy]);
		normalizeVec(norms[zDensity-1][ixy]);
		rad += radStep;
	}
		
	//-- interpolate tesselation
	float	izf;
	float	zDf = (float)zDensity-1;
	for(iz = 1; iz < zDensity-1; iz++)
	{
		izf = (float)iz;
		for (ixy = 0; ixy < xyDensity+1; ixy++)
		{
			verts[iz][ixy][0] = verts[0][ixy][0]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][0]*(izf/zDf);
			verts[iz][ixy][1] = verts[0][ixy][1]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][1]*(izf/zDf);
			verts[iz][ixy][2] = verts[0][ixy][2]*((zDf-izf)/zDf) + verts[zDensity-1][ixy][2]*(izf/zDf);
			norms[iz][ixy][0] = norms[0][ixy][0];
			norms[iz][ixy][1] = norms[0][ixy][1];
			norms[iz][ixy][2] = norms[0][ixy][2];
		}
	}
	
	//-- Draw cylinder
	float s1, t1, t2, zd, xyd;
	zd	= zDensity-1.0;
	xyd	= xyDensity-1.0;
	
	for(iz = 0; iz < zDensity-1; iz++)
	{
		t1 = (zd-iz)/zd;
		t2 = (zd-iz-1.0)/zd;
		izf = (float)iz;
		glBegin(GL_TRIANGLE_STRIP);
		for (ixy = 0; ixy < xyDensity+1; ixy++)
		{
			s1 = ixy/xyd;
			
			glTexCoord2f(s1, t1);
			glNormal3fv(norms[iz][ixy]);
			glVertex3fv(verts[iz][ixy]);
			
			glTexCoord2f(s1, t2);
			glNormal3fv(norms[iz+1][ixy]);
			glVertex3fv(verts[iz+1][ixy]);
		}
		glEnd();
	}
	
	//-- Cleanup
	for (iz = 0; iz < (zDensity+1); iz++)
	{
		delete []verts[iz];
		delete []norms[iz];
	}
	delete []verts;
	delete []norms;
	
}




/*===========================================================================*/
//																RglHyperboloid
/*===========================================================================*/
void	RglHyperboloid(float *point1, float *point2, float thetamax, int detail)
{
	int			ixy;
	int			xyDensity;
	float		x1, x2;
	float		y1, y2;
	float		xM, yM, zM;
	float		z1, z2;
	float		tan1;
	float		tan2;
	float		rad_1;
	float		rad_2;
	float		radM;
	float		radStep;
	float		radius1;
	float		radius2;
	float		radiusM;
	RglPoint		norm;
	float		w1;
	float		w2;
	
	//do some kludgy error checking
	if (thetamax > 360.0)	thetamax = 360.0;
	if (thetamax < 0.0) 	thetamax = 0.0;
	
	xyDensity = (int) ( (D2RAD(thetamax)/(2.0f*M_PI))*(float)detail );
	if (xyDensity < 4)
		xyDensity = 4;
	radStep = (D2RAD(thetamax))/( (float)xyDensity );
	
	RglPoint		*verts1 = new RglPoint[xyDensity+1];
	RglPoint		*verts2 = new RglPoint[xyDensity+1];
	RglPoint		*vertsM = new RglPoint[xyDensity+1];
	
	radius1 	= sqrt( (point1[0]*point1[0]) + (point1[1]*point1[1]) );
	radius2 	= sqrt( (point2[0]*point2[0]) + (point2[1]*point2[1]) );
	z1 = point1[2];
	z2 = point2[2];	
	w2 = radius1/(radius1+radius2);
	w1 = radius2/(radius1+radius2);
	xM = ( (point1[0]*w1)+(point2[0]*w2) );
	yM = ( (point1[1]*w1)+(point2[1]*w2) );
	zM = ( (point1[2]*w1)+(point2[2]*w2) );
	radiusM		= sqrt(	(xM*xM) + (yM*yM) );
	
	tan1 = atan(point1[1]/point1[0]);
	if ( tan1 < 0.0 ) 	
		tan1 = M_PI/2.0 + ((M_PI/2.0) + tan1);
	tan2 = atan(point2[1]/point2[0]);
	if ( tan2 < 0.0 ) 	
		tan2 = M_PI/2.0 + ((M_PI/2.0) + tan2);
	rad_1 = tan1+(M_PI/2.0f);
	rad_2 = tan2+(M_PI/2.0f);
	radM = (rad_1+rad_2)/2.0f;
	
	if (point1[0] == 0.0f)
	{
		rad_1 = rad_2;
		radM = rad_2;
	}
	if (point2[0] == 0.0f)
	{
		rad_2 = rad_1;
		radM = rad_1;
	}
//	warning ("RglHyperboloid, rad_1 = %f	rad_2 = %f	radM = %f", rad_1, rad_2, radM);

	for(ixy = 0; ixy <= xyDensity; ixy++)
	{
		x1 = sin (rad_1)*radius1;	
		y1 = cos (rad_1)*radius1;
		x2 = sin (rad_2)*radius2;	
		y2 = cos (rad_2)*radius2;
		xM = sin (radM)*radiusM;	
		yM = cos (radM)*radiusM;

		verts1[ixy][0] = x1;	
		verts1[ixy][1] = y1;
		verts1[ixy][2] = - z1;
		verts2[ixy][0] = x2;	
		verts2[ixy][1] = y2;
		verts2[ixy][2] = - z2;
		vertsM[ixy][0] = xM;	
		vertsM[ixy][1] = yM;
		vertsM[ixy][2] = - zM;
		
		
		rad_1 -= radStep;
		rad_2 -= radStep;
		radM -= radStep;
	}
				
	if ( fabs(rad_1) == fabs(rad_2) )
		for(ixy = 0; ixy < xyDensity; ixy++)
		{
			glBegin(GL_QUADS);
				copyVec (norm, verts2[ixy], 3);		glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts2[ixy]);
	
				copyVec (norm, verts2[ixy+1], 3);	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts2[ixy+1]);

				copyVec (norm, verts1[ixy+1], 3);	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts1[ixy+1]);
			
				copyVec (norm, verts1[ixy], 3);		glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts1[ixy]);

			glEnd();
		}
	else
		for(ixy = 0; ixy < xyDensity; ixy++)
		{
			glBegin(GL_TRIANGLES);
				copyVec (norm, verts2[ixy], 3);	  glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts2[ixy]);
				copyVec (norm, verts2[ixy+1], 3);   glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts2[ixy+1]);
				copyVec (norm, vertsM[ixy+1], 3);   glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(vertsM[ixy+1]);
			
				copyVec (norm, verts2[ixy], 3); 	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts2[ixy]);
				copyVec (norm, vertsM[ixy+1], 3);	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(vertsM[ixy+1]);
				copyVec (norm, vertsM[ixy], 3); 	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(vertsM[ixy]);
			
				copyVec (norm, vertsM[ixy], 3); 	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(vertsM[ixy]);
				copyVec (norm, vertsM[ixy+1], 3);	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(vertsM[ixy+1]);
				copyVec (norm, verts1[ixy+1], 3);	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts1[ixy+1]);
			
				copyVec (norm, vertsM[ixy], 3); glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(vertsM[ixy]);
				copyVec (norm, verts1[ixy+1], 3);	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts1[ixy+1]);
				copyVec (norm, verts1[ixy], 3); 	glNormal3fv(vecReplace(norm, 2, 0.0) );
				glVertex3fv(verts1[ixy]);
			glEnd();
		}
	
	delete [] verts1;
	delete [] verts2;
	delete [] vertsM;
}


/*===========================================================================*/
//															 RglBilinearPatch
/*===========================================================================*/
// even though I use u and v, I really don't know which is which...
void RglBilinearPatch (float p[2][2][3], int detail)
{
	float	norm[3];
	int 	i;
	int 	j;
	float	***subdiv;
	double	uInc;
	double	vInc;
	double	u;
	double	v;
	int		uDetail;
	int		vDetail;
	
//	return;
	
	if (detail < 1)
		detail = 1;
	
//	uDetail = vDetail = detail;
	//-- figure out a nice subdivision...
	float	tmpA;
	float	tmpB;
	float	tmpC;
	float uDist;
	float vDist;
	tmpA = p[0][0][0]-p[0][1][0];
	tmpB = p[0][0][1]-p[0][1][1];
	tmpC = p[0][0][2]-p[0][1][2];
	uDist = fabs(tmpA) + fabs(tmpB) + fabs(tmpC);
	tmpA = p[1][0][0]-p[1][1][0];
	tmpB = p[1][0][1]-p[1][1][1];
	tmpC = p[1][0][2]-p[1][1][2];
	uDist += fabs(tmpA) + fabs(tmpB) + fabs(tmpC);
	tmpA = p[0][0][0]-p[1][0][0];
	tmpB = p[0][0][1]-p[1][0][1];
	tmpC = p[0][0][2]-p[1][0][2];
	vDist = fabs(tmpA) + fabs(tmpB) + fabs(tmpC);
	tmpA = p[0][1][0]-p[1][1][0];
	tmpB = p[0][1][1]-p[1][1][1];
	tmpC = p[0][1][2]-p[1][1][2];
	vDist += fabs(tmpA) + fabs(tmpB) + fabs(tmpC);
	if(uDist < vDist)
	{
		uDetail = detail;
		vDetail = (int)((float)detail*(uDist/vDist));
	}
	else
	{
		uDetail = (int)((float)detail*(vDist/uDist));
		vDetail = detail;
	}
	//-- sanity checks...
	if(vDetail < 1)
		vDetail = 1;
	if(uDetail < 1)
		uDetail = 1;
	if(vDetail > 100)
		vDetail = 100;
	if(uDetail > 100)
		uDetail = 100;
	
	//-- allocate memory
	subdiv	= new float**[vDetail+1];
	for (i = 0; i < vDetail+1; i++)
	{
		subdiv[i] = new float*[uDetail+1];
		for (j = 0; j < uDetail+1; j++)
			subdiv[i][j] = new float[3];
	}
	
	//-- calculate vertices
	uInc = 1.0/(double)uDetail;
	vInc = 1.0/(double)vDetail;
	v = 0.0;
	for (i = 0; i < vDetail+1; i++)
	{
		u = 0.0;
		for (j = 0; j < uDetail+1; j++)
		{
			subdiv[i][j][0] = (1.0-u)*(1.0-v)*p[0][0][0] + u*(1.0-v)*p[1][0][0] + (1.0-u)*v*p[0][1][0] + u*v*p[1][1][0];
			subdiv[i][j][1] = (1.0-u)*(1.0-v)*p[0][0][1] + u*(1.0-v)*p[1][0][1] + (1.0-u)*v*p[0][1][1] + u*v*p[1][1][1];
			subdiv[i][j][2] = (1.0-u)*(1.0-v)*p[0][0][2] + u*(1.0-v)*p[1][0][2] + (1.0-u)*v*p[0][1][2] + u*v*p[1][1][2];
			// flip Z for gl/RIB compatibility
			subdiv[i][j][2] = -subdiv[i][j][2];
			u += uInc;
		}
		v += vInc;
	}
	
	//-- draw vertices
	for (i = 0; i < vDetail; i++)
	{
		glBegin(GL_TRIANGLE_STRIP);
		calcNormal	(norm, subdiv[i][1], subdiv[i+1][1], subdiv[i][0]);
		glNormal3fv	(norm);
		glVertex3fv(subdiv[i+1][0]);
		glVertex3fv(subdiv[i  ][0]);
		for (j = 0; j < uDetail; j++)
		{
			calcNormal	(norm, subdiv[i][j+1], subdiv[i+1][j+1], subdiv[i][j]);
			glNormal3fv	(norm);
			glVertex3fv(subdiv[i+1][j+1]);
			glVertex3fv(subdiv[i  ][j+1]);
		}
		glEnd();
	}
			
	// Cleanup...
	for (i = 0; i < vDetail+1; i++)
	{
		for (j = 0; j < uDetail+1; j++)
			delete [] subdiv[i][j];
		delete [] subdiv[i];
	}
	delete [] subdiv;
}

	
//--------------------------------------------------------------------
void  lookAt ( float fromx, float fromy, float fromz,
               float tox,   float toy,   float toz,
               float **m )
{
	float x[3], y[3], z[3];
	float mag;

	/* Z vector */
	z[0] = fromx - tox;
	z[1] = fromy - toy;
	z[2] = fromz - toz;
	mag = sqrt( z[0]*z[0] + z[1]*z[1] + z[2]*z[2] );
	if (mag) 
	{ 
		z[0] /= mag;
		z[1] /= mag;
		z[2] /= mag;
	}

	/* Y vector */
	y[0] = 0;
	y[1] = 1;
	y[2] = 0;

	/* X vector = Y cross Z */
	x[0] =  y[1]*z[2] - y[2]*z[1];
	x[1] = -y[0]*z[2] + y[2]*z[0];
	x[2] =  y[0]*z[1] - y[1]*z[0];

	/* Recompute Y = Z cross X */
	y[0] =  z[1]*x[2] - z[2]*x[1];
	y[1] = -z[0]*x[2] + z[2]*x[0];
	y[2] =  z[0]*x[1] - z[1]*x[0];

	/* mpichler, 19950515 */
	/* cross product gives area of parallelogram, which is < 1.0 for
	* non-perpendicular unit-length vectors; so normalize x, y here
	*/
	mag = sqrt( x[0]*x[0] + x[1]*x[1] + x[2]*x[2] );
	if (mag) {
		x[0] /= mag;
		x[1] /= mag;
		x[2] /= mag;
	}

	mag = sqrt( y[0]*y[0] + y[1]*y[1] + y[2]*y[2] );
	if (mag) {
		y[0] /= mag;
		y[1] /= mag;
		y[2] /= mag;
	}

#define M(row,col)  (*m)[col*4+row]
	M(0,0) = x[0];  M(0,1) = x[1];  M(0,2) = x[2];  M(0,3) = 0.0;
	M(1,0) = y[0];  M(1,1) = y[1];  M(1,2) = y[2];  M(1,3) = 0.0;
	M(2,0) = z[0];  M(2,1) = z[1];  M(2,2) = z[2];  M(2,3) = 0.0;
	M(3,0) = 0.0;   M(3,1) = 0.0;   M(3,2) = 0.0;   M(3,3) = 1.0;
#undef M
	
//	glMultMatrixf( m );
//
// 	/*translate Eye to Origin */
//	glTranslated( -fromx, -fromy, -fromz );
//	
}

float	*vecReplace (float *vec, int index, float value) 
{ vec[index] = value; return vec; }

float	*copyVec(float *newVec, float *oldVec, int dim)	
{
	for (int i = 0; i < dim; i++)
		newVec[i] = oldVec[i];
	return newVec;
}

float	*normalizeVec (float *vec)
{
	float	length;
	
	length = sqrt( (vec[0]*vec[0]) + (vec[1]*vec[1]) + (vec[2]*vec[2]) );
	
	if (length == 0.0)
		length = 1.0;
		
	vec[0] /= length;
	vec[1] /= length;
	vec[2] /= length;
	
	return vec;
}	

float	*calcNormal (float *norm, float *vert1, float *vert2, float *vert3 )
{
	float	u1[3] = {	vert1[0] - vert2[0], 
						vert1[1] - vert2[1],
						vert1[2] - vert2[2] };
	float	u2[3] = {	vert2[0] - vert3[0],
						vert2[1] - vert3[1],
						vert2[2] - vert3[2] };
	norm[0] = u1[1]*u2[2] - u1[2]*u2[1];		
	norm[1] = u1[2]*u2[0] - u1[0]*u2[2];		
	norm[2] = u1[0]*u2[1] - u1[1]*u2[0];		
	
	float	length = sqrt( (norm[0]*norm[0]) + (norm[1]*norm[1]) + (norm[2]*norm[2]) );
	if (length == 0.0)
		length = 1.0;
	norm[0] /= length;
	norm[1] /= length;
	norm[2] /= length;
	
	return norm;
}


////--------------------------------------------------------------------
//void  lookAt ( float fromx, float fromy, float fromz,
//               float tox,   float toy,   float toz,
//               float **m )
//{
//	float x[3], y[3], z[3];
//	float mag;
//
//	/* Z vector */
//	z[0] = fromx - tox;
//	z[1] = fromy - toy;
//	z[2] = fromz - toz;
//	mag = sqrt( z[0]*z[0] + z[1]*z[1] + z[2]*z[2] );
//	if (mag) 
//	{ 
//		z[0] /= mag;
//		z[1] /= mag;
//		z[2] /= mag;
//	}
//
//	/* Y vector */
//	y[0] = 0;
//	y[1] = 1;
//	y[2] = 0;
//
//	/* X vector = Y cross Z */
//	x[0] =  y[1]*z[2] - y[2]*z[1];
//	x[1] = -y[0]*z[2] + y[2]*z[0];
//	x[2] =  y[0]*z[1] - y[1]*z[0];
//
//	/* Recompute Y = Z cross X */
//	y[0] =  z[1]*x[2] - z[2]*x[1];
//	y[1] = -z[0]*x[2] + z[2]*x[0];
//	y[2] =  z[0]*x[1] - z[1]*x[0];
//
//	/* mpichler, 19950515 */
//	/* cross product gives area of parallelogram, which is < 1.0 for
//	* non-perpendicular unit-length vectors; so normalize x, y here
//	*/
//	mag = sqrt( x[0]*x[0] + x[1]*x[1] + x[2]*x[2] );
//	if (mag) {
//		x[0] /= mag;
//		x[1] /= mag;
//		x[2] /= mag;
//	}
//
//	mag = sqrt( y[0]*y[0] + y[1]*y[1] + y[2]*y[2] );
//	if (mag) {
//		y[0] /= mag;
//		y[1] /= mag;
//		y[2] /= mag;
//	}
//
//#define M(row,col)  (*m)[col*4+row]
//	M(0,0) = x[0];  M(0,1) = x[1];  M(0,2) = x[2];  M(0,3) = 0.0;
//	M(1,0) = y[0];  M(1,1) = y[1];  M(1,2) = y[2];  M(1,3) = 0.0;
//	M(2,0) = z[0];  M(2,1) = z[1];  M(2,2) = z[2];  M(2,3) = 0.0;
//	M(3,0) = 0.0;   M(3,1) = 0.0;   M(3,2) = 0.0;   M(3,3) = 1.0;
//#undef M
//	
////	glMultMatrixf( m );
////
//// 	/*translate Eye to Origin */
////	glTranslated( -fromx, -fromy, -fromz );
////	
//}




