/**
 * glPrimitives.h
 * Copyright 1999 by Mark B. Allan
 * 
 * GL equivalents of RM primitives, etc.
 */
#ifndef glPrimitives_h
#define glPrimitives_h

#include <math.h>

#define D2RAD(d) (2.0*M_PI*d/360.0)

//float	d2rad (float degrees);
float	*vecReplace (float *vec, int index, float value); 
float	*copyVec(float *newVec, float *oldVec, int dim);
float	*calcNormal (float *norm, float *vert1, float *vert2, float *vert3 );
float	*normalizeVec (float *vec);

void	DrawGlGrid (bool X = false, bool Y = true, bool Z = false, float unitSize = 1.0, int numUnits = 5, float color = 0.3);

void 	RglSphere (float radius, float zmin, float zmax, float thetamax, int detail);
void 	RglCone (float height, float radius, float thetamax, int detail);
void 	RglDisk (float height, float radius, float thetamax, int detail);
void 	RglCylinder (float radius, float zmin, float zmax, float thetamax, int detail);

void	RglHyperboloid(float *point1, float *point2, float thetamax, int detail);
void	RglBilinearPatch (float p[2][2][3], int detail);

void  lookAt ( float fromx, float fromy, float fromz,
               float tox,   float toy,   float toz,
               float **m );
#endif //glPrimitives_h
