#ifndef glState_h
#define glState_h

//==============================================================================
class GLState
{
public:
	GLState();
	~GLState();
	
	GLState& operator = (GLState&);
	
	void	initialize();
	void	execute();
	
	void	setAlphaTest(bool);
	void	setBlend(bool);
	void	setCullFace(bool);
	void	setDepthTest(bool);
	void	setDepthMask(bool);
	void	setLighting(bool);
	void	setLineSmooth(bool);
	void	setNormalize(bool);
	void	setPointSmooth(bool);
	void	setTwoSideLight(bool);
	void	setWireframe(bool);
	
	bool	getAlphaTest()	 { return alphaTest;	}
	bool	getBlend()		 { return blend;		}
	bool	getCullFace()	 { return cullFace; 	}
	bool	getDepthTest()	 { return depthTest;	}
	bool	getDepthMask()	 { return depthMask;	}
	bool	getLighting()	 { return lighting; 	}
	bool	getLineSmooth()  { return lineSmooth;	}
	bool	getNormalize()	 { return normalize;	}
	bool	getPointSmooth() { return pointSmooth;	}
	bool	getTwoSideLight(){ return twoSideLight; }
	bool	getWireframe()	 { return wireframe;	}
	
protected:
	bool	initialized;
	
	bool	alphaTest;
	bool	blend;
	bool	cullFace;
	bool	depthTest;
	bool	depthMask;
	bool	lighting;
	bool	lineSmooth;
	bool	normalize;
	bool	pointSmooth;
	bool	twoSideLight;
	bool	wireframe;
};

#endif // glState_h
