/**
 * glWidget.cpp
 * Copyright 1999 by Mark B. Allan
 * 
 * frame around glPort
 */
#include "glWidget.h"
#include "extern.h"
#include "particleControlWidget.h"

#include <qkeycode.h>

//----------------------------------------------------------
GLWidget::GLWidget (QWidget * parent, const char* name, const QGLWidget* listShare )
	: QWidget (parent, name)
{
	topVLayout		= 0;
	glPortFrame		= 0;
	glPortLayout	= 0;
	glPortCam		= 0;
	glPortOrtho		= 0;
	
	setFocusPolicy(QWidget::StrongFocus);
	
	//----------------------------------glPort
	//frame for GL context
	glPortFrame = new QFrame(this);
    glPortFrame->setFrameStyle( QFrame::Sunken | QFrame::Panel );
    glPortFrame->setLineWidth( 1 );

	//layout to auto-resize
	glPortLayout = new QHBoxLayout(glPortFrame, 1, 1);
	
	//gl context
	glPortCam = new GlPortCam (glPortFrame, "glPortCam", listShare, this);
	glPortLayout->addWidget(glPortCam,1);
	glPortLayout->activate();
	//----------------------------------layout
	topVLayout		= new QVBoxLayout (this, 2, 2);
	topVLayout->addWidget(glPortFrame, 1);
	topVLayout->activate();
}


//----------------------------------------------------------
GLWidget::~GLWidget ()
{	
}

////----------------------------------------------------------
//void GLWidget::resizeEvent(QResizeEvent *rEv)
//{
//	int wMod;
//	int newW, newH;
//	int mult;
//	int doW, doH;
//	
//	newW = rEv->size().width();
//	newH = rEv->size().height();
//	
//	mult = newW/g_rendW;
//	wMod = newW % g_rendW;
//	
//	doW = newW - wMod;
//	doH = g_rendH*mult;
//	if(mult < 1)
//	{
//		doW = g_rendW;
//		doH = g_rendH;
//	}
//	
//	if(wMod || newH != g_rendH*mult)
//		resize(doW, doH);
//	else
//		QWidget::resizeEvent(rEv);
//}

////----------------------------------------------------------
//void GLWidget::ToggleMoveMode(bool on)
//{
//	if (on)
//		glPort->SetMouseMode( 1 );
//	else
//		glPort->SetMouseMode( 0 );
//}
//

//----------------------------------------------------------
void GLWidget::keyPressEvent ( QKeyEvent *kE )
{
	kE->ignore();
	QWidget::keyPressEvent(kE);
}
