/**
 * glWidget.h
 * Copyright 1999 by Mark B. Allan
 * 
 * frame around glPort
 */
#ifndef glWidget_h
#define glWidget_h

#include "glPortCam.h"
#include "glPortOrtho.h"

#include <qframe.h>
#include <qlabel.h>
#include <qlayout.h>
#include "mwidgets.h"
#include <qlcdnumber.h> 

/**
 * 
 */
class GLWidget	: public QWidget
{
	Q_OBJECT
	
public:
	GLWidget (QWidget * parent, const char* name = 0, const QGLWidget* listShare=0 );
	~GLWidget();
	
	inline	GlPortCam	*GetGLPort()	{	return glPortCam;	}
	
//protected slots:
//	void	ToggleMoveMode(bool on);

protected:
	void	keyPressEvent ( QKeyEvent * );
// 	void	resizeEvent(QResizeEvent *rEv);
	
protected:
	QVBoxLayout	*topVLayout;
	
	GlPortCam	*glPortCam;
	GlPortOrtho	*glPortOrtho;
	
	QFrame		*glPortFrame;
	
	QHBoxLayout	*glPortLayout;

};

#endif //glWidget_h
