/**
 * glWidgetOrtho.h
 * Copyright 1999 by Mark B. Allan
 * 
 * frame around glPort
 */
#ifndef glWidgetOrtho_h
#define glWidgetOrtho_h

#include "glPort.h"

#include <qframe.h>
#include <qlabel.h>
#include <qlayout.h>
#include "mwidgets.h"
#include <qcombobox.h> 
#include <qslider.h> 

#include "numInput.h"

class GlPortOrtho;
class CameraView;
/**
 * 
 */
//==============================================================================
class GLWidgetOrtho	: public QWidget
{
	Q_OBJECT
	
public:
	GLWidgetOrtho (QWidget * parent, const char* name = 0, const QGLWidget* listShare=0, int view = 0 );
	~GLWidgetOrtho();

public slots:
	void	setCurrentName(const char*);
	
protected slots:
	void 	setProjection(int);
	void 	refreshInputWidgets(CameraView *currentCam);
	void	selectionModeChanged(int);
	void	setGridSnapMult(int);
	void	setHitZoneSize(int);
	
protected:
	void 	setProjection(int, bool onlySet);
	void	keyPressEvent ( QKeyEvent * );
	void	focusInEvent ( QFocusEvent * );
 	
protected:
	static int	count;
	QHBoxLayout	*topHLayout;
	QHBoxLayout	*glPortLayout;
	QVBoxLayout	*topVLayout;
	QHBoxLayout	*selectLayout;
	QHBoxLayout	*toolLayout;
	
	GlPortOrtho	*glPortOrtho;
	
	QFrame		*glPortFrame;

	QComboBox	*projectionCombo;
	QComboBox	*selectionCombo;
	QLabel		*selectionModeLabel;
	
	MToolButton	*hilightHitZonesBut;
	
	QSlider		*hitZoneSlider;
	
	MToolButton	*gridSnapBut;
	QComboBox	*gridDivCombo;
//	NumInput	*camXPosInput;
//	NumInput	*camYPosInput;
//	NumInput	*camZPosInput;
//	NumInput	*camXRotInput;
//	NumInput	*camYRotInput;
//	NumInput	*camZRotInput;
//	NumInput	*camZoomInput;
	
};

#endif //glWidgetOrtho_h
