/**
 * lightGroupSaveLoad.cpp
 * Copyright 1999 by Mark B. Allan
 * 
 * IO routines for LightGroup
 */
#include "extern.h"
#include "define.h"
#include "lightGroup.h"
#include "mbaLight.h"

//----------------------------------------------------------
bool	LightGroup::SaveLightGroup(FILE *outfile, int tabs)
{
	int		i;
	char	buffer[256];
	char	tabBuf[32] = { 0 };
	char	*walker = buffer;
	
	walker = tabBuf;
	for (i = 0; i < tabs; i++)
	{	*walker = '\t';	*(walker+1) = '\0';	walker++;	}
	walker = buffer;
	for (i = 0; i < tabs; i++)
	{	*walker = '\t';	*(walker+1) = '\0';	walker++;	}

	fprintf(outfile, "#----------------------------------------------------------------------\n");
	fprintf (outfile, "%sLightGroup %s\n", tabBuf, (const char*)name );
	fprintf (outfile, "%s{\n", tabBuf);
	for (i = 0; i < (int)lightList.count(); i++)
	{
		lightList.at(i)->WriteLight(outfile, tabs+1);
	}
	sprintf (walker, "}\n");
	fputs(buffer, outfile);
	
	return true;
}

//----------------------------------------------------------
bool	LightGroup::LoadLightGroup(FILE *infile, const char* nm)
{
	bool	retVal = false;
	char	buffer[512];
	QCString	tmpString;
	
	name = nm;

	GL_ERROR_MSG("LightGroup::LoadLightGroup -- enter");
	lightList.clear();
	GL_ERROR_MSG("LightGroup::LoadLightGroup -- clear");
	
	while (fgets(buffer, 512, infile) > 0)
	{
		tmpString = buffer;
		tmpString = tmpString.simplifyWhiteSpace();
		if ( tmpString == "Light" )
		{
			lightList.append( new MBALight(infile) );
			GL_ERROR_MSG("LightGroup::LoadLightGroup -- append");
		}
		else if (tmpString == "}")
		{
			emit Updated();
			retVal = true;
			break;
		}
	}
	
	GL_ERROR_MSG("LightGroup::LoadLightGroup -- leave");
	return retVal;	
}

