#ifdef WIN32
	#pragma warning (disable:4305)
	#pragma warning (disable:4244)
#endif

#include "compatibility.h"
#include <particle/general.h>
#include <GL/gl.h>

#include "glPrimitives.h"
#include "pPolygonObject.h"
#include "particleControl.h"
//#include "pAction.h"
#include "camera.h"
#include "extern.h"

extern	CameraView		*g_globalCam;
extern _ParticleState	_ps;

//--------------------------------------------------------------------
GLfloat* scaleColor(float *in)
{
	static GLfloat	out[4];
	out[0] = (float)in[0];
	out[1] = (float)in[1];
	out[2] = (float)in[2];
	out[3] = (float)in[3];
	float max = 1.0;
	if (out[0] > max)
		max = out[0];
	if (out[1] > max)
		max = out[1];
	if (out[2] > max)
		max = out[2];
	if (max > 1.0)
	{
		float tmp = 1.0/max;
		out[0] *= tmp;
		out[1] *= tmp;
		out[2] *= tmp;
	}
	return out;
}

//--------------------------------------------------------------------
void m_pDrawGroupp(int primitive, int skip, PPolygonObject *polygons)
{	
	skip += 1;
	// Get a pointer to the particles in gp memory
	ParticleGroup *pg = _ps.pgrp;
	if(pg == NULL)
		return; // ERROR
		
	if(pg->p_count < 1)
		return;

	float	emis[4] = { 0.00, 0.00, 0.00, 1.00 };
	float	ambt[4] = { 0.00, 0.00, 0.00, 1.00 };
	float	diff[4] = { 1.00, 1.00, 1.00, 1.00 };
	float	spec[4] = { 0.50, 0.50, 0.50, 1.00 };
	 
	glMaterialfv (GL_FRONT_AND_BACK, GL_EMISSION,	emis);
	glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT,		ambt);
	glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE,		diff);
	glMaterialfv (GL_FRONT_AND_BACK, GL_SPECULAR,	spec);
	glMaterialf  (GL_FRONT_AND_BACK, GL_SHININESS,	100);
	
//	glNormal3f(0.0, 1.0, 0.0);
	
	int 		i;
	//float		*mat = new float[16];
	PPolygon	*poly = 0;
	float		xzlen, yzlen;
	float		yrot, xrot;
	float		dir[3] = {0.0, 0.0, 0.0};
	float		rot[3] = {0.0, 0.0, 0.0};
	if(g_glFastParticles)
	{
		switch(primitive)
		{
			case ParticleControl::Point:
			case ParticleControl::Disk:
				#ifndef RIVA_GLX  
				glBegin(GL_POINTS);
				for(i = 0; i < pg->p_count; i+=skip)
				{
					Particle &m = pg->list[i];
					glColor4fv(scaleColor((float*)&m.color));
					glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, scaleColor((float*)&m.color));
					glVertex3fv((GLfloat *)&m.pos);
				}
				glEnd();
				#else
				for(i = 0; i < pg->p_count; i+=skip)
				{
					Particle &m = pg->list[i];
					glColor4fv(scaleColor((float*)&m.color));
					glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, scaleColor((float*)&m.color));
					glBegin(GL_POINTS);
					glVertex3fv((GLfloat *)&m.pos);
					glEnd();
				}
				#endif
				break;
			case ParticleControl::Line:
				glBegin(GL_LINES);
				for(i = 0; i < pg->p_count; i+=skip)
				{
					Particle &m = pg->list[i];
					glColor4fv(scaleColor((float*)&m.color));
					glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, scaleColor((float*)&m.color));
					glVertex3fv((GLfloat *)&m.pos);
					// For lines, make a tail with the velocity vector's direction and
					// a length
					pVector tail(-m.vel.x, -m.vel.y, -m.vel.z);
					tail *= m.size.y;
					tail += m.pos;
					glVertex3fv((GLfloat *)&tail);
				}
				glEnd();
				break;
			case ParticleControl::Polygon:
				if(polygons)
				{
					glBegin(GL_TRIANGLES);
					for(i = 0; i < pg->p_count; i++)
					{
						Particle &m = pg->list[i];
						glColor4fv(scaleColor((float*)&m.color));
						glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, scaleColor((float*)&m.color));
						int polyIndex = (i % polygons->NumPolygons());
						poly = polygons->PolygonAt(polyIndex);
						poly->drawGL(m.pos.x-poly->centroid.X(), m.pos.y-poly->centroid.Y(), m.pos.z-poly->centroid.Z());
					}
					glEnd();
				}
				break;
			case ParticleControl::Connect:
				break;
		}
	}
	else
	{
		switch(primitive)
		{
			case ParticleControl::Point:
				break;
			case ParticleControl::Line:
				break;
			case ParticleControl::Disk:
				//FIXME - this mostly sorta works, but isn't really correct...
				for(i = 0; i < pg->p_count; i+=skip)
				{
					Particle &m = pg->list[i];
					glColor4fv(scaleColor((float*)&m.color));
					glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, scaleColor((float*)&m.color));

					if(i%128)
					{
						dir[0] =   (g_globalCam->vals->position.X()-m.pos.x);
						dir[1] =  -(g_globalCam->vals->position.Y()-m.pos.y);
						dir[2] =  -(g_globalCam->vals->position.Z()-m.pos.z);
//						dir[0] =   m.vel.x;
//						dir[1] =  -m.vel.y;
//						dir[2] =  -m.vel.z;
						if( dir[0]+dir[1]+dir[2] )
						{
							xzlen = sqrt(dir[0]*dir[0]+dir[2]*dir[2]);
							if (xzlen == 0)
								yrot = (dir[1]<0.0) ? 180.0 : 0.0;
							else
								yrot = 180.0*acos(dir[2]/xzlen)/M_PI;

							yzlen = sqrt(dir[1]*dir[1]+xzlen*xzlen);
							if (yzlen == 0.0)
								yzlen = 0.0000001;
							xrot = 180.0*acos(xzlen/yzlen)/M_PI;

							if (dir[1] > 0.0)
								rot[0] =  xrot;
							else
								rot[0] = -xrot;
							if (dir[0] > 0.0)
								rot[1] = -yrot;
							else
								rot[1] =  yrot;
						}
					}
					glPushMatrix();
						glTranslatef(m.pos.x, m.pos.y, m.pos.z);
						glRotatef(180.0+rot[1], 0.0, 1.0, 0.0);
						glRotatef(rot[0], 1.0, 0.0, 0.0);
						RglDisk(0.0, m.size.x, 360.0, 5);
					glPopMatrix();
				}
				break;
			case ParticleControl::Polygon:
				if(polygons)
				{
					glBegin(GL_TRIANGLES);
					for(i = 0; i < pg->p_count; i++)
					{
						Particle &m = pg->list[i];
						glColor4fv(scaleColor((float*)&m.color));
						glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, scaleColor((float*)&m.color));
						int polyIndex = (i % polygons->NumPolygons());
						poly = polygons->PolygonAt(polyIndex);
						poly->drawGL(m.pos.x-poly->centroid.X(), m.pos.y-poly->centroid.Y(), m.pos.z-poly->centroid.Z());
					}
					glEnd();
				}
				break;
			case ParticleControl::Connect:
	//			#define MOD_SIZE 10
	//			for(int j = 0; j < MOD_SIZE; j++)
	//			{
	//				Particle &m = pg->list[j];
	//				glColor4fv((GLfloat *)&m.color);
	//				glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, (GLfloat *)&m.color);
	//				glBegin(GL_LINE_STRIP);
	//				for(int i = j; i < pg->p_count; i+=MOD_SIZE)
	//				{
	//					Particle &m = pg->list[i];
	//					glVertex3fv((GLfloat *)&m.pos);
	//				}
	//				glEnd();
	//			}
				break;
		}
	}
//	delete [] mat;
}



//--------------------------------------------------------------------
void m_pDrawGroupl(int dlist, bool const_size, bool const_color, bool const_rotation)
{
	// Get a pointer to the particles in gp memory
	ParticleGroup *pg = _ps.pgrp;
	if(pg == NULL)
		return; // ERROR
	
	if(pg->p_count < 1)
		return;

	//if(const_color)
	//	glColor4fv((GLfloat *)&pg->list[0].color);
	int i;
	for(i = 0; i < pg->p_count; i++)
	{
		Particle &m = pg->list[i];

		glPushMatrix();
		glTranslatef(m.pos.x, m.pos.y, m.pos.z);

		if(!const_size)
			glScalef(m.size.x, m.size.x, m.size.x);

		// Expensive! A sqrt, cross prod and acos. Yow.
		if(!const_rotation)
		{
			pVector vN(m.vel);
			vN.normalize();
			pVector voN(m.velB);
			voN.normalize();

			pVector biN;
			if(voN.x == vN.x && voN.y == vN.y && voN.z == vN.z)
				biN = pVector(0, 1, 0);
			else
				biN = vN ^ voN;
			biN.normalize();

			pVector N(vN ^ biN);

			double M[16];
			M[0] = vN.x;  M[4] = biN.x;  M[8] = N.x;  M[12] = 0;
			M[1] = vN.y;  M[5] = biN.y;  M[9] = N.y;  M[13] = 0;
			M[2] = vN.z;  M[6] = biN.z;  M[10] = N.z; M[14] = 0;
			M[3] = 0;     M[7] = 0;      M[11] = 0;   M[15] = 1;
			glMultMatrixd(M);
		}

		// Warning: this depends on alpha following color in the Particle struct.
		if(!const_color)
			glColor4fv((GLfloat *)&m.color);

		glCallList(dlist);

		glPopMatrix();
	}
	
//	glEnd();
}
//void m_pDrawGroupp(int primitive, bool const_size, bool const_color)
//{
//	// Get a pointer to the particles in gp memory
//	ParticleGroup *pg = _ps.pgrp;
//	if(pg == NULL)
//		return; // ERROR
//		
//	if(pg->p_count < 1)
//		return;
//
//	//if(const_color)
//	//	glColor4fv((GLfloat *)&pg->list[0].color);
//	
////	float	emis[4] = { 0.00, 0.00, 0.00, 1.00 };
////	float	ambt[4] = { 0.00, 0.00, 0.00, 1.00 };
////	float	diff[4] = { 0.00, 0.00, 0.00, 1.00 };
////	float	spec[4] = { 1.00, 1.00, 1.00, 1.00 };
////	
//	float	emis[4] = { 0.00, 0.00, 0.00, 0.10 };
//	float	ambt[4] = { 0.00, 0.00, 0.00, 0.10 };
//	float	diff[4] = { 0.00, 0.00, 0.00, 0.10 };
//	float	spec[4] = { 1.00, 1.00, 1.00, 0.10 };
//	
//	glMaterialfv (GL_FRONT_AND_BACK, GL_EMISSION,	emis);
//	glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT,	ambt);
//	glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE,	diff);
//	glMaterialfv (GL_FRONT_AND_BACK, GL_SPECULAR,	spec);
//	glMaterialf  (GL_FRONT_AND_BACK, GL_SHININESS,	100);
//	
//	glBegin((GLenum)primitive);
//	
//	glNormal3f(0.0, 1.0, 0.0);
//	
//	for(i = 0; i < pg->p_count; i++)
//	{
//		Particle &m = pg->list[i];
//		
//		// Warning: this depends on alpha following color in the Particle struct.
//		if(!const_color)
//		{
//			glColor4fv((GLfloat *)&m.color);
//			glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE, (GLfloat *)&m.color);
//		}
//		//------------------------------
//		glPushMatrix();
//		glTranslatef(m.pos.x, m.pos.y, m.pos.z);
//
////		if(!const_size)
////			glScalef(m.size, m.size, m.size);
//
//		// Expensive! A sqrt, cross prod and acos. Yow.
//		if(1)
//		{
//			pVector vN(m.vel);
//			vN.normalize();
//			pVector voN(m.velB);
//			voN.normalize();
//
//			pVector biN;
//			if(voN.x == vN.x && voN.y == vN.y && voN.z == vN.z)
//				biN = pVector(0, 1, 0);
//			else
//				biN = vN ^ voN;
//			biN.normalize();
//
//			pVector N(vN ^ biN);
//
//			double M[16];
//			M[0] = vN.x;  M[4] = biN.x;  M[8] = N.x;  M[12] = 0;
//			M[1] = vN.y;  M[5] = biN.y;  M[9] = N.y;  M[13] = 0;
//			M[2] = vN.z;  M[6] = biN.z;  M[10] = N.z; M[14] = 0;
//			M[3] = 0;     M[7] = 0;      M[11] = 0;   M[15] = 1;
//			glMultMatrixd(M);
//		}
//		
//		float	tail[3] = {	m.vel.x*m.size,
//							m.vel.y*m.size,
//							m.vel.z*m.size};
//		float	len;
//		len = sqrt( tail[0]*tail[0] + tail[1]*tail[1] + tail[2]*tail[2] );
//		
//		float	pt1[3];
//		float	pt2[3];
//		pt1[0] = 0.01;
//		pt1[1] = 0.01;
//		pt1[2] = 0.0;
//		pt2[0] = 0.01;
//		pt2[1] = 0.01;
//		pt2[2] = len;
//		
//		glRotatef(90.0, 0.0, 1.0, 0.0);
//		RglHyperboloid( pt1, pt2, 360.0, 8);
//		//glCallList(dlist);
//
//		glPopMatrix();
//
//	}
//	glEnd();
//}

