/**
 * main.cpp
 * Copyright 1999 by Mark B. Allan
 */
//-------------------------------------------------------
#include "main.h"
#include "startup.h"
#include "configFileIO.h"
#include <qstringlist.h>
                 
#include "pixmaps.h"

#ifndef WIN32
#include "slc.h"
#endif

#include "MBAStyle.h"
#include <qtooltip.h>
#include <qwindowsstyle.h> 
#include <qmotifstyle.h> 
#include <qcdestyle.h> 
#include <qsgistyle.h> 
#include <qplatinumstyle.h> 

//==============================================================================
int main( int argc, char **argv )
{
	int	end;

    QApplication::setColorSpec( QApplication::ManyColor );
    QApplication a(argc,argv);
	
//	a.setStyle(new MBAStyle());
//	a.setStyle(new QSGIStyle());
	a.setStyle(new QMotifStyle());
//	a.setStyle(new QCDEStyle());
//	a.setStyle(new QWindowsStyle());
//	a.setStyle(new QPlatinumStyle());

	winStyle = new QWindowsStyle();
	
	QRect dskTopRect = QApplication::desktop()->rect();
	g_dskTopW = dskTopRect.width();
	g_dskTopH = dskTopRect.height();
	
	SetGlobals();

	MainStartup startup;
	
    a.setMainWidget( &startup );

	startup.resize(10, 10);
	startup.move( (g_dskTopW/2)-startup.width()/2, (g_dskTopH/2)-startup.height()/2 );
	startup.show();
	
	startup.BeginStartup();
		
	end = a.exec();
	
	return end;
}

//--------------------------------------------------------------------
void	SetGlobals()
{
	char	*defaultRendName = "flow";
	g_rendName = new char[strlen(defaultRendName)+1];
	strcpy(g_rendName, defaultRendName);

	g_curveControl = new MBACurveCollection;
	
	pix_file = new QPixmap((const char**)i_file_xpm);
	pix_save = new QPixmap((const char**)filesave_xpm);

	icoSet_add = new QIconSet(QPixmap((const char**)b_gry_add_xpm) );
	icoSet_add->setPixmap(QPixmap((const char**)b_gry_add_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_add->setPixmap(QPixmap((const char**)b_clr_add_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_add->setPixmap(QPixmap((const char**)b_dis_add_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_copy = new QIconSet(QPixmap((const char**)b_gry_copy_xpm) );
	icoSet_copy->setPixmap(QPixmap((const char**)b_gry_copy_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_copy->setPixmap(QPixmap((const char**)b_clr_copy_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_copy->setPixmap(QPixmap((const char**)b_dis_copy_xpm), QIconSet::Large, QIconSet::Disabled);

	icoSet_clone = new QIconSet(QPixmap((const char**)b_gry_clone_xpm) );
	icoSet_clone->setPixmap(QPixmap((const char**)b_gry_clone_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_clone->setPixmap(QPixmap((const char**)b_clr_clone_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_clone->setPixmap(QPixmap((const char**)b_dis_clone_xpm), QIconSet::Large, QIconSet::Disabled);

	icoSet_close = new QIconSet(QPixmap((const char**)b_gry_close_xpm) );
	icoSet_close->setPixmap(QPixmap((const char**)b_gry_close_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_close->setPixmap(QPixmap((const char**)b_clr_close_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_close->setPixmap(QPixmap((const char**)b_dis_close_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_del = new QIconSet(QPixmap((const char**)b_gry_del_xpm) );
	icoSet_del->setPixmap(QPixmap((const char**)b_gry_del_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_del->setPixmap(QPixmap((const char**)b_clr_del_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_del->setPixmap(QPixmap((const char**)b_dis_del_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_dis = new QIconSet(QPixmap((const char**)b_gry_dis_xpm) );
	icoSet_dis->setPixmap(QPixmap((const char**)b_gry_dis_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_dis->setPixmap(QPixmap((const char**)b_clr_dis_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_dis->setPixmap(QPixmap((const char**)b_dis_dis_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_dis_on = new QIconSet((const char**)b_clr_dis_xpm);
	
	icoSet_dwn = new QIconSet(QPixmap((const char**)b_gry_dwn_xpm) );
	icoSet_dwn->setPixmap(QPixmap((const char**)b_gry_dwn_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_dwn->setPixmap(QPixmap((const char**)b_clr_dwn_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_dwn->setPixmap(QPixmap((const char**)b_dis_dwn_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_lock = new QIconSet(QPixmap((const char**)b_gry_lock_xpm) );
	icoSet_lock->setPixmap(QPixmap((const char**)b_gry_lock_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_lock->setPixmap(QPixmap((const char**)b_clr_lock_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_lock->setPixmap(QPixmap((const char**)b_dis_lock_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_lock_on = new QIconSet( *icoSet_lock );
	icoSet_lock_on->setPixmap(QPixmap((const char**)b_clr_lock_xpm), QIconSet::Large, QIconSet::Normal  );

	icoSet_paste = new QIconSet(QPixmap((const char**)b_gry_paste_xpm) );
	icoSet_paste->setPixmap(QPixmap((const char**)b_gry_paste_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_paste->setPixmap(QPixmap((const char**)b_clr_paste_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_paste->setPixmap(QPixmap((const char**)b_dis_paste_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_rm = new QIconSet(QPixmap((const char**)b_gry_rm_xpm) );
	icoSet_rm->setPixmap(QPixmap((const char**)b_gry_rm_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_rm->setPixmap(QPixmap((const char**)b_clr_rm_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_rm->setPixmap(QPixmap((const char**)b_dis_rm_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_up = new QIconSet(QPixmap((const char**)b_gry_up_xpm) );
	icoSet_up->setPixmap(QPixmap((const char**)b_gry_up_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_up->setPixmap(QPixmap((const char**)b_clr_up_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_up->setPixmap(QPixmap((const char**)b_dis_up_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_dis_s = new QIconSet(QPixmap((const char**)b_gry_dis_s_xpm) );
	icoSet_dis_s->setPixmap(QPixmap((const char**)b_gry_dis_s_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_dis_s->setPixmap(QPixmap((const char**)b_clr_dis_s_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_dis_s->setPixmap(QPixmap((const char**)b_dis_dis_s_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_shade_s = new QIconSet(QPixmap((const char**)b_gry_shade_s_xpm) );
	icoSet_shade_s->setPixmap(QPixmap((const char**)b_gry_shade_s_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_shade_s->setPixmap(QPixmap((const char**)b_clr_shade_s_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_shade_s->setPixmap(QPixmap((const char**)b_dis_shade_s_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_shade = new QIconSet(QPixmap((const char**)b_gry_shade_xpm) );
	icoSet_shade->setPixmap(QPixmap((const char**)b_gry_shade_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_shade->setPixmap(QPixmap((const char**)b_clr_shade_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_shade->setPixmap(QPixmap((const char**)b_dis_shade_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_clear = new QIconSet(QPixmap((const char**)b_gry_clear_xpm) );
	icoSet_clear->setPixmap(QPixmap((const char**)b_gry_clear_xpm), QIconSet::Large, QIconSet::Normal  );
	icoSet_clear->setPixmap(QPixmap((const char**)b_clr_clear_xpm), QIconSet::Large, QIconSet::Active  );
	icoSet_clear->setPixmap(QPixmap((const char**)b_dis_clear_xpm), QIconSet::Large, QIconSet::Disabled);
	
	icoSet_play = new QIconSet(QPixmap((const char**)f_gry_play_xpm) );
	icoSet_play->setPixmap(QPixmap((const char**)f_gry_play_xpm), QIconSet::Large, QIconSet::Normal);
	icoSet_play->setPixmap(QPixmap((const char**)f_clr_play_xpm), QIconSet::Large, QIconSet::Active);
	
	icoSet_rew = new QIconSet(QPixmap((const char**)f_gry_rew_xpm) );
	icoSet_rew->setPixmap(QPixmap((const char**)f_gry_rew_xpm), QIconSet::Large, QIconSet::Normal);
	icoSet_rew->setPixmap(QPixmap((const char**)f_clr_rew_xpm), QIconSet::Large, QIconSet::Active);
	
}

//--------------------------------------------------------------------
void	StrListFromPath(QStrList *list, const char* path)
{
	char	*pathVal;
	char	delimiter = ':';
	char	*begin;
	char	*end;
	
	pathVal = new char[strlen(path)+1];
	strcpy(pathVal, path);
	
	begin = pathVal;
	while( (end = strchr(begin, delimiter)) )
	{
		*end = '\0';
		if(strlen(begin) > 0)
			list->inSort(begin);
		begin = end+1;
	}
	if(strlen(begin) > 0)
	{
		list->append(begin);
	}
	
	delete [] pathVal;
}

//--------------------------------------------------------------------
void	SortShadersSlcTell(QStrList& masterList)
{
#ifndef WIN32
	int		i;
	FILE	*tellPipe;
	char	buffer[256];
	char	command[128];
	QCString	tmpString;
	int		pipeExitStatus;
	
	g_surfaceShadersList.setAutoDelete(true);
	g_displacementShadersList.setAutoDelete(true);
	g_imagerShadersList.setAutoDelete(true);
	g_volumeShadersList.setAutoDelete(true);
	g_surfaceShadersList.clear();
	g_displacementShadersList.clear();
	g_imagerShadersList.clear();
	g_volumeShadersList.clear();
	
	for (i = 0; i < (int)masterList.count(); i++)
	{
		if( !(i%5) )
			fprintf(stderr, ".");
		sprintf(command, "%s %s", g_shaderInfoExec, masterList.at(i));
		tellPipe = popen(command, "r");
		if (tellPipe > 0)
		{
			fgets(buffer, 255, tellPipe);
			tmpString = buffer;
			pipeExitStatus = pclose(tellPipe);
			if (pipeExitStatus != 0)
			{
				///FIXME -  Put some error catch here - slctell probably didn't exec properly...
			}
			if ( tmpString.find("surface") >= 0)
				g_surfaceShadersList.append(masterList.at(i));
			else if ( tmpString.find("displacement") >= 0)
				g_displacementShadersList.append(masterList.at(i));
			else if ( tmpString.find("light") >= 0)
				g_lightShadersList.append(masterList.at(i));
			else if ( tmpString.find("imager") >= 0)
				g_imagerShadersList.append(masterList.at(i));
			else if ( tmpString.find("volume") >= 0)
				g_volumeShadersList.append(masterList.at(i));
			else 
				warning("%s", buffer);
		}
	}
	fprintf(stderr, "\n");
#endif
}

#ifdef USE_SLCARGS
//--------------------------------------------------------------------
void	SortShadersSlcArgs(QStrList& masterList)
{
#ifndef WIN32
	int		i;
	char	command[128];
	QCString	tmpString;
	
	warning("SortShadersSlcArgs");
	g_surfaceShadersList.setAutoDelete(true);
	g_displacementShadersList.setAutoDelete(true);
	g_imagerShadersList.setAutoDelete(true);
	g_volumeShadersList.setAutoDelete(true);
	g_surfaceShadersList.clear();
	g_displacementShadersList.clear();
	g_imagerShadersList.clear();
	g_volumeShadersList.clear();
	
	for (i = 0; i < (int)masterList.count(); i++)
	{
		if( !(i%5) )
			fprintf(stderr, ".");
		sprintf(command, "%s", masterList.at(i));

		SLC_SetShader(command);
		switch(SLC_GetType())
		{
			case SLC_TYPE_SURFACE:
				g_surfaceShadersList.append(masterList.at(i));
				break;
			case SLC_TYPE_DISPLACEMENT:
				g_displacementShadersList.append(masterList.at(i));
				break;
			case SLC_TYPE_LIGHT:
				g_lightShadersList.append(masterList.at(i));
				break;
			case SLC_TYPE_IMAGER:
				g_imagerShadersList.append(masterList.at(i));
				break;
			case SLC_TYPE_VOLUME:
				g_volumeShadersList.append(masterList.at(i));
				break;
			default:
				warning("Shader type not recognized: %s", command);
		}
	}
	fprintf(stderr, "\n");
#endif //WIN32
}
#endif //NO_SLCARGS

//--------------------------------------------------------------------
bool	CheckShaders()
{
	int			i;
	int			j;
	QDir		curDir;
	char		nameFilter[16];
	QStringList	fileList;
	QStrList	tmpList;
	QStrList	masterList;
	QStrList	shadersPathList;
	
	curDir.setFilter( QDir::Files | QDir::Readable );
	curDir.setSorting(QDir::Name);
	sprintf(nameFilter, "*%s", g_compiledShaderExt);
	curDir.setNameFilter(nameFilter);
	if (g_shadersPath)
	{
		warning("---- shaders - searching shader environment");
		StrListFromPath( &shadersPathList, g_shadersPath );
		for(i = 0; i < (int)shadersPathList.count(); i++)
		{
			curDir.setPath(shadersPathList.at(i));
			if (curDir.exists() && curDir.isReadable())
			{
				if (curDir.entryList().count() > 0)
				{
					fileList = curDir.entryList();
					for(j = 0; j < (int)fileList.count(); j++)
						tmpList.inSort( (*(fileList.at(j))).copy() );
				}
			}
		}
		warning("---- shaders - create master list");
		for(i = 0; i < (int)tmpList.count(); i++)
		{
			QCString tmpString;
			QCString tmpString2;
			
			tmpString = tmpList.at(i);

			j = tmpString.findRev(g_compiledShaderExt);
			if (j > 0)
			{
#ifdef USE_SLCARGS
				int k;
				QCString dsoString;
				dsoString.sprintf(".%s%s", SLC_GetARCH(), g_compiledShaderExt);
				if( (k = tmpString.findRev(dsoString)) > 0) //
					tmpString.truncate(k);
				else
#endif
				tmpString.truncate(j);
				//warning("%s", (const char*)tmpString);
				if(masterList.count() > 0)	// get rid of duplicates
				{
					tmpString2 = masterList.last();	
					if(tmpString != (const char*)tmpString2)
						masterList.append(tmpString);
				}
				else
					masterList.append(tmpString);
			}
		}
		warning("---- shaders - sort shader types");
#ifndef USE_SLCARGS
		SortShadersSlcTell(masterList);
#else
		SortShadersSlcArgs(masterList);
#endif
		warning("---- shaders - done.");
	}
	else
	{
		warning("What the hell? g_shadersPath = 0 should have already been checked.");
		exit(-1);
	}
	return true;
}

//--------------------------------------------------------------------
void	checkGLError(const char* text)
{
	switch(glGetError())
	{
		case GL_NO_ERROR:	break;//		fprintf(stderr, "%-40s : GL_NO_ERROR\n", text);		break;
		case GL_INVALID_ENUM:		fprintf(stderr, "%-40s : GL_INVALID_ENUM\n", text);  	break;
		case GL_INVALID_VALUE:		fprintf(stderr, "%-40s : GL_INVALID_VALUE\n", text); 	break;
		case GL_INVALID_OPERATION:	fprintf(stderr, "%-40s : GL_INVALID_OPERATION\n", text); break;
		case GL_STACK_OVERFLOW:		fprintf(stderr, "%-40s : GL_STACK_OVERFLOW\n", text);	break;
		case GL_STACK_UNDERFLOW:	fprintf(stderr, "%-40s : GL_STACK_UNDERFLOW\n", text);	break;
		case GL_OUT_OF_MEMORY:		fprintf(stderr, "%-40s : GL_OUT_OF_MEMORY\n", text); 	break;
		default:					fprintf(stderr, "%-40s : UNKNOWN GL ERROR", text);
	}
}

