/**
 * mbaCurveAssignDialog.h
 * Copyright 1999 by Mark B. Allan
 * 
 * finds all things a curve could be attached to
 */
#ifndef mbaCurveAssignDialog_h
#define mbaCurveAssignDialog_h

#include <qwidget.h>
#include <qdialog.h>
#include <qlistview.h>
#include <qlayout.h>
#include <qpushbutton.h>

#include "pFloat.h"

class MBAListViewFloat;

/**
 * unimplemented
 */
//==============================================================================
class MBACurveAssignDialog : public QDialog
{
	Q_OBJECT
public:
	MBACurveAssignDialog(QWidget *parent = 0, const char* name = 0, bool modal = true);
	~MBACurveAssignDialog();

protected:
	void	GenerateSceneTree();
	
protected slots:
	void	TreeSelectionChanged(QListViewItem *);
	void	Accepted();
	
protected:
	QVBoxLayout	*topVLayout;
	QHBoxLayout	*butLayout;
	
	QListView	*sceneTree;

	QListViewItem	*lightGroupRoot;
	QListViewItem	*cameraRoot;
	QListViewItem	*particleControlRoot;
	
	QPushButton	*acceptBut;
	QPushButton	*cancelBut;
	

};

/**
 * unimplemented
 */
//==============================================================================
class MBAListViewFloat : public QListViewItem
{
public:
	MBAListViewFloat(QListViewItem *, const char* name, PFloat *pFp);
	~MBAListViewFloat();

	PFloat	*pFloatPointer;
};

#endif
