/**
 * mbaGLSurfaceWidget.h
 * Copyright 1999 by Mark B. Allan
 * 
 * edit GL material
 */
#ifndef mbaGLSurfaceWidget_h
#define mbaGLSurfaceWidget_h

#include <qframe.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qcombobox.h>

#include "numInput.h"
#include "mbaGLSurface.h"

class ColorButton;

/**
 * MBA_GLSurfaceWidget
 */
class MBA_GLSurfaceWidget	: public QFrame
{
	Q_OBJECT
	
public:
	MBA_GLSurfaceWidget(QWidget* parent = 0, const char* name = 0);
	~MBA_GLSurfaceWidget();
	
	void	SetGLSurfacePointer(MBA_GLSurface *);
	void	Copy();
	void	Paste();
	
	inline	bool	isValid()	{	return (bool)glSurface;	}

signals:
	void	Updated();
	
protected slots:
	void	UpdateDiff(float r, float g, float b);
	void	UpdateSpec(float r, float g, float b);
	void	UpdateAmbt(float r, float g, float b);
	void	UpdateEmis(float r, float g, float b);
	void	UpdateRough(float);
	void	UpdateAlpha(float);
	
	void	setEnabled(bool);
	
protected:
	QHBoxLayout	*topHLayout;
	QVBoxLayout	*col0Layout;
	QVBoxLayout	*col1Layout;
	
	QLabel	*diffLabel;
	QLabel	*specLabel;
	QLabel	*ambtLabel;
	QLabel	*emisLabel;
	
	ColorButton	*diffColor;
	ColorButton	*specColor;
	ColorButton	*ambtColor;
	ColorButton	*emisColor;
		
	NumInput	*alphaInput;
	NumInput	*roughInput;
	
	MBA_GLSurface	*glSurface;
	MBA_GLSurface	copySurface;
};

#endif // MBA_GLSurfaceWidget_h


