/**
 * mbaMainWindow.h
 * Copyright 1999 by Mark B. Allan
 * 
 * QMainWindow w/ some hooks controlling toolbar placement
 */
#ifndef mbaMainWindow_h
#define mbaMainWindow_h

#include <qmainwindow.h>
#include <qlist.h>

/**
 * 
 */
//==============================================================================
class MbaMainWindow : public QMainWindow
{
	Q_OBJECT

public:
	MbaMainWindow(QWidget *parent = 0, const char* name = 0);
	~MbaMainWindow();
	
	enum ToolPosition { NoPos = -1, ToolTop, ToolBot, ToolLeft, ToolRight };

	virtual bool	setToolBar(int num, QMainWindow::ToolBarDock dock, bool newline = true) = 0;
	virtual QMainWindow::ToolBarDock	toolBarDock(int num);
	
protected:
	int		numToolBars;
	QList<QMainWindow::ToolBarDock>	dockList;
};

#endif



