/**
 * mbaRMShaderStringWidget.h
 * Copyright 1999 by Mark B. Allan
 * 
 * popup widget for editing string values of RM shaders
 */
#ifndef mbaRMShaderStringWidget_h
#define mbaRMShaderStringWidget_h

#include <qfiledialog.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qframe.h>
#include <qlabel.h>

#include "mwidgets.h"
#include "imageFileDialog.h"

/**
 * 
 */
//==============================================================================
class MbaRMShaderStringWidget	: public QDialog
{
	Q_OBJECT
public:
	MbaRMShaderStringWidget(const char* strVal, const char* dir, QWidget *parent = 0, const char* name = 0);
	~MbaRMShaderStringWidget();
	
	inline const char* StringValue()	{	return stringEdit->text();	}
	inline const char* LastDir()		{	return (const char*)lastDir;	}

protected slots:
	void ShowFileDialog();
	
protected:
	QVBoxLayout	*topVLayout;
	QHBoxLayout	*butHLayout;
	QVBoxLayout	*fileLayout;
	
	QLabel		*stringLabel;
	QLineEdit	*stringEdit;
	
	QPushButton	*butOk;
	QPushButton	*butCancel;
	QPushButton	*showFile;
	
	QFrame		*fileFrame;
	ImageFileDialog	*fileDialog;
	
	QCString		lastDir;
};

#endif // mbaRMShaderStringWidget_h

