/**
 * mbaSceneTreePartItem.cpp
 * Copyright 1999 by Mark B. Allan
 * 
 * items to put into scene tree widget
 */
#include "mbaSceneTreePartItem.h"

#include "extern.h"
#include "mbaScene.h"
#include "particleControl.h"

//==================================================================================================
MBASceneTreePartItemCheck::MBASceneTreePartItemCheck( int in, QCheckListItem* parent, const char* text)
	: QCheckListItem(parent, text, QCheckListItem::CheckBox)
{
	index = in;
}

//--------------------------------------------------------------------
MBASceneTreePartItemCheck::~MBASceneTreePartItemCheck()
{
}

//--------------------------------------------------------------------
void MBASceneTreePartItemCheck::stateChange(bool status)
{
//	warning("MBASceneTreePartItemCheck::stateChange(%d)", status);
	ParticleControl	*partCtrl = 0;
	if (index >= 0 && index < g_scene->numParticleSystems())
	{
		partCtrl = g_scene->ParticleSystemAt(index);
		if (partCtrl)
		{
			partCtrl->setEnabled(status);
		}
		//warning("set particle system %d to %d", index, status);
	}
}
