/**
 * mbaSceneWidget.h
 * Copyright 1999 by Mark B. Allan
 * 
 * scene widget
 */
#ifndef mbaSceneWidget_h
#define mbaSceneWidget_h

#include "mwidgets.h"
#include <qpushbutton.h>
#include <qtoolbar.h> 
#include <qlayout.h> 

#include "mbaMainWindow.h"
#include "mbaScene.h"
#include "mbaSceneTreeWidget.h"

/**
 * 
 */
//==============================================================================
class MBASceneWidgetMain	:	public QWidget
{
	Q_OBJECT
	
public:
	MBASceneWidgetMain(MBAScene *scene, QWidget *parent = 0, const char* name = 0);
	~MBASceneWidgetMain();
	
	void	SetScenePointer(MBAScene *in);

protected slots:
	void	ShowCurveAssign();
	
protected:
	MBASceneTreeWidget	*sceneTreeWidget;
	
	QVBoxLayout	*topVLayout;

	QPushButton		*curveAssignBut;
};

/**
 * 
 */
//==============================================================================
class MBASceneWidget	:	public MbaMainWindow
{
	Q_OBJECT
	
public:
	MBASceneWidget(MBAScene *scene, QWidget *parent = 0, const char* name = 0, ToolBarDock buttonBarDock = Top);
	~MBASceneWidget();

	inline void	SetScenePointer(MBAScene *in)	{	mainWidget->SetScenePointer(in);	}

	bool	setToolBar(int num, QMainWindow::ToolBarDock dock, bool newline = true);
protected:
	MBASceneWidgetMain	*mainWidget;
	
	QToolBar		*toolBar;
	MToolButton		*closeBut;
	MToolButton		*refreshBut;
};


#endif
