/**
 * mbaSurfaceTabDialog.h
 * Copyright 1999 by Mark B. Allan
 * 
 * topmost surface properties widget, w/ tabs for Surface, Displacement & GL
 */
#ifndef mbaSurfaceTabDialog_h
#define mbaSurfaceTabDialog_h

#include <qtabwidget.h>
#include <qlayout.h>
#include "mwidgets.h" 
#include <qtoolbar.h> 

#include "mbaMainWindow.h"
#include "mbaGLSurfaceWidget.h"
#include "mbaRMShaderWidget.h"

/**
 * 
 */
//====================================================================
class MBASurfaceTabDialog	: public MbaMainWindow
{
	Q_OBJECT
public:
	MBASurfaceTabDialog(QWidget *parent=0, const char*name=0, ToolBarDock buttonBarDock = Right);
	~MBASurfaceTabDialog();

	enum	WhichTab { SurfaceTab, DisplaceTab, OpenGLTab };
	
	void	SetGLSurfacePointer(MBA_GLSurface *in);
	// Geez, I HATE this. It works but makes the code spagetti. Damn.
	void	SetRMSurfacePointerPointer(MBA_RMShader **in, bool addDelOK = false);
	void	SetRMDisplacePointerPointer(MBA_RMShader **in, bool addDelOK = false);
	
	QToolBar	*GetToolBar(int toolBarNum);
	
	bool	setToolBar(int num, QMainWindow::ToolBarDock dock, bool newline = true);

	void	reloadShaders();
	
signals:
	void	Updated();
	
protected slots:
	void	Paste();
	void	Copy();
	void	add();
	void	Delete();
	void	TestCombined();
	void	EnableProperty(bool);
	void	TabSelected(const QString&);

protected:
	void	SetDisableButton();
	void	SetButtonsEnabled();
	
protected:
	WhichTab		currentTab;
	
	QHBoxLayout		*topHLayout;
	
	QToolBar		*manipToolBar;
	
	MToolButton		*closeBut;
	MToolButton		*disableBut;
	MToolButton		*copyBut;
	MToolButton		*pasteBut;
	MToolButton		*addBut;
	MToolButton		*delBut;
	MToolButton		*combineTest;
	
	MTabWidget			*tabDialog;
	MBA_GLSurfaceWidget	*glSurfaceWidget;
	MBA_RMShaderWidget	*rmSurfaceWidget;
	MBA_RMShaderWidget	*rmDisplaceWidget;

	bool			okToAddDelSurface;
	bool			okToAddDelDisplace;
	MBA_RMShader	**ppRMSurface;
	MBA_RMShader	**ppRMDisplace;
	
	bool	surfaceDisabled;
	bool	displaceDisabled;
	bool	openGLDisabled;
	
	const char*	surfaceTabText;
	const char* displaceTabText;
	const char*	openGLTabText;
};

#endif //mbaSurfaceTabDialog_h
