#ifndef mwidgets_h
#define mwidgets_h

#include <qtoolbutton.h>
#include <qtabwidget.h>
#include <qlineedit.h>
#include <qlabel.h>

/**
 * Tool button that uses PaletteBackground rather than the useless default
 * PaletteButton.
 */
class MToolButton : public QToolButton
{
public:
	MToolButton( QWidget * parent, const char * name = 0 );
	~MToolButton();
};

/**
 */
class MLabel : public QLabel
{
public:
	MLabel( QWidget * parent, const char * name = 0 );
	~MLabel();
};

/**
 * QLineEdit that emits returnPressed() on focus out
 */
class MLineEdit	: public QLineEdit
{
public:
	MLineEdit(QWidget *parent = 0, const char* name = 0);
	~MLineEdit();
	
protected:
	void focusOutEvent(QFocusEvent *);
};

/**
 * MTabWidget that uses a palette based on Button
 */
class MTabWidget	: public QTabWidget
{
public:
	MTabWidget(QWidget *parent = 0, const char* name = 0);
	~MTabWidget();
	
protected:
	void paletteChange(const QPalette &oldPalette);
};

#endif
