/**
 * numInTriple.h
 * Copyright 1999 by Mark B. Allan
 * 
 * three numerical inputs side-by-side
 */
#ifndef numInTriplef_h
#define numInTriplef_h

#include <qvalidator.h> 
#include <qlineedit.h>
#include <qlayout.h>
#include <qlabel.h>
#include "numInput.h"

class NumInTriplefEdit;
class NumInTriplefLabel;

/**
 * NumInTriplef
 */
//=======================================================================
class NumInTriplef : public QWidget
{
    Q_OBJECT
public:

    NumInTriplef	( QWidget* parent = 0, const char* name = 0);
    ~NumInTriplef	();
	
public:
	inline	float		Val0()	{	return val0;	}
	inline	float		Val1()	{	return val1;	}
	inline	float		Val2()	{	return val2;	}

	void		SetTotalWidth (int w);
	void		SetHeight(int h);
	
	void		setEnabled (bool);
	void		SetIndicator(int);
	
	float		SetValueSolid (int, float);
	void		SetValueAll (float, float, float);
	
public slots:
	float		SetValue0 (float);
	float		SetValue1 (float);
	float		SetValue2 (float);
	
signals:
	void		Value0Changed (float);
	void		Value1Changed (float);
	void		Value2Changed (float);
//	void		Updated ();
	
protected:
	
protected:
	bool				active;
	int					height;
	NumInTriplefEdit	*input0Edit;
	NumInTriplefEdit	*input1Edit;
	NumInTriplefEdit	*input2Edit;
	QFrame	*indicate0;
	QFrame	*indicate1;
	QFrame	*indicate2;
	
//	float				curVal;
	float				val0;
	float				val1;
	float				val2;
};
	
/**
 * NumInTriplef Line Edit
 */
//=======================================================================
class NumInTriplefEdit : public QLineEdit
{
    Q_OBJECT
	
public:

    NumInTriplefEdit	( int, QWidget* parent = 0, const char* name = 0 );
    ~NumInTriplefEdit	();
	
	inline float	GetLastGoodValue ()	{return lastGoodValue;}

	void		setEnabled (bool);
	void		focusOutEvent ( QFocusEvent * );
	void		focusInEvent ( QFocusEvent * );
	
signals:
	void		ValueChanged(float);
	
public slots:
	void		SetValue (float);

protected slots:
	void		InputComplete();

protected:	
	void		mousePressEvent(QMouseEvent *);
	
	bool		active;
	bool		longInput;
	int			index;
	float		xloc;
	float		lastGoodValue;
	QValidator	*currentValidator;
};

#endif // NumInTriplef_included
