#ifndef numInputValid_h
#define numInputValid_h

#include <qvalidator.h>

/**
 * Line Edit Validator	: Double
 */
//-----------------------------------------------------------------------
class NumInputDblValidator : public QValidator
{
    Q_OBJECT
public:

    NumInputDblValidator( QWidget* parent, const char* name = NULL);
    ~NumInputDblValidator();
	
	State	validate ( QString &, int & ) const;
	void	fixup (QString &) const;
	
public slots:
	void	SetMax (double in);
	void	SetMin (double in);

private:
	double		max;
	double		min;
};

/**
 * Line Edit Validator	: Integer
 */
//-----------------------------------------------------------------------
class NumInputIntValidator : public QValidator
{
    Q_OBJECT
	
public:
    NumInputIntValidator( QWidget* parent, const char* name = 0);
    ~NumInputIntValidator();
	
	State	validate ( QString &, int & ) const;
	void	fixup (QString &) const;
	
public slots:
	void	SetMax (int in);
	void	SetMin (int in);

private:
	int		max;
	int		min;
};

#endif //numInputValid
