#include "pBoolWidget.h"
#include "extern.h"

PBoolWidget::PBoolWidget(PBool *in, const char* lbl, QWidget *parent, const char* name)
	:	QWidget (parent, name)
{
	pBool = in;
	
	input = new QCheckBox(this);
	input->setText(lbl);
	input->setFixedSize(120, 25);
//	input->setFont( *g_font_MB );
	
	input->move(0, 0);	//Widget won't display under Windows unless this is here...
	
	if (!pBool)
		setEnabled(false);
	
	setFixedSize(120, 25);
	
	QObject::connect(input, SIGNAL(clicked()), SIGNAL(Updated()) );
}

PBoolWidget::~PBoolWidget()
{
}

//--------------------------------------------------------------------
void	PBoolWidget::setEnabled(bool status)
{
	input->setEnabled(status);
}


//--------------------------------------------------------------------
void	PBoolWidget::SetBoolPointer(PBool *inP, const char* lbl)
{
//	warning("PBoolWidget::SetBoolPointer(PBool *inP, const char* lbl)");
	input->setText(lbl);
	if (inP)
	{
		if (pBool)
		{
			QObject::disconnect(input, SIGNAL(toggled(bool)), pBool, SLOT(SetValSlot(bool)) );
		}
		
		pBool = inP;
		
		input->setEnabled(true);
		input->setChecked((bool)*pBool);
		QObject::connect(input, SIGNAL(toggled(bool)), pBool, SLOT(SetValSlot(bool)) );
	}
	else
	{
		if (pBool)
		{
			QObject::disconnect(input, SIGNAL(toggled(bool)), pBool, SLOT(SetValSlot(bool)) );
		}
		pBool = inP;
		input->setEnabled(false);
		input->setChecked(false);
	}
	
}


