#ifndef PDOMAINWIDGET_H
#define PDOMAINWIDGET_H


#include <qwidget.h>
#include <qlayout.h>
#include <qcombobox.h>
#include <qlabel.h>

#include "numInput.h"
#include <particle/papi.h>
#include "pDomain.h"

/**
 * 
 */
class PDomainWidget : public QWidget
{
	Q_OBJECT
public:
	PDomainWidget(PDomain *d = 0, const char* lbl = 0, QWidget* parent = 0, const char*name = 0);
	~PDomainWidget();
	
	enum ComboMode	
	{	DomainNormal = 0, DomainBounce, DomainTransform };
	
	inline PDomainEnum	Type()	{	return domain->Type();	}
	inline float	A0()	 {	return domain->A0();	}
	inline float	A1()	 {	return domain->A1();	}
	inline float	A2()	 {	return domain->A2();	}
	inline float	A3()	 {	return domain->A3();	}
	inline float	A4()	 {	return domain->A4();	}
	inline float	A5()	 {	return domain->A5();	}
	inline float	A6()	 {	return domain->A6();	}
	inline float	A7()	 {	return domain->A7();	}
	inline float	A8()	 {	return domain->A8();   }
	
	void	Update();
	void	SetDomain();
	void	SetDomainPointer(PDomain* inP = 0, const char* lbl = 0);
	
	void	SwitchMode(ComboMode m);

	inline void	SetFocus()	{	dInput[0]->SetFocus();	}

signals:
	void	Updated();
	
public slots:
	void	setEnabled(bool);
	// Totally WEAK - Qt will crash under certain circumstances
	// if the following slots return values.
	void	SetType(PDomainEnum in);
	void	SetA0(float in);
	void	SetA1(float in);
	void	SetA2(float in);
	void	SetA3(float in);
	void	SetA4(float in);
	void	SetA5(float in);
	void	SetA6(float in);
	void	SetA7(float in);
	void	SetA8(float in);
	
protected slots:
	void	TranslateType(int);
	void	SwitchType(int);
	
protected:
	void	SetFloatValues();
	
	ComboMode	mode;
	
	QLabel		*label;

	PDomain		*domain;

	QVBoxLayout	*topLayout;
	QComboBox	*typeCombo;
	
	NumInput	*dInput[MAX_DOMAIN_FLOATS];
	
//	NumInput	*a0Input;
//	NumInput	*a1Input;
//	NumInput	*a2Input;
//	NumInput	*a3Input;
//	NumInput	*a4Input;
//	NumInput	*a5Input;
//	NumInput	*a6Input;
//	NumInput	*a7Input;
//	NumInput	*a8Input;
};

#endif
