#include "pFloat.h"

#include "extern.h"
#include "mbaCurveCollection.h"

//==============================================================================
PFloat::PFloat(float in)
//	: QObject()
{
	animated = false;
	updated = true;
	val = in;
}

PFloat::~PFloat()
{
}

PFloat::PFloat(PFloat& in)
//	: QObject()
{
	animated = in.animated;
	val = in.val;
}

//--------------------------------------------------------------------
float	PFloat::Value()
{	
	if (!animated) 
		return val;
	else
	{
		bool	ok;
		return g_curveControl->GetFloatValFromCurve( animated, g_frame,  ok);
	}
}

//--------------------------------------------------------------------
PFloat&	PFloat::operator = (PFloat& in)
{
//	warning("PFloat = PFloat, not properly implemented yet");
	updated		= true;
	animated	= in.animated;
	val			= in.val;
//	warning ("PFloat::operator = (PFloat &)"); 
	//emit ValueUpdated();
	return *this;
}

//--------------------------------------------------------------------
PFloat& PFloat::operator = (float in)
{
	updated = true;
	val = in;
//	warning ("PFloat::operator = (float %f)", in); 
	//emit ValueUpdated();
	return *this;
}

//--------------------------------------------------------------------
float PFloat::operator + (float in)
{
	updated = true;
	return val+in;
}
//--------------------------------------------------------------------
float PFloat::operator - (float in)
{
	updated = true;
	return val-in;
}
//--------------------------------------------------------------------
float PFloat::operator * (float in)
{
	updated = true;
	return val*in;
}
//--------------------------------------------------------------------
float PFloat::operator / (float in)
{
	updated = true;
	return val/in;
}

//--------------------------------------------------------------------
PFloat& PFloat::operator += (float in)
{
	updated = true;
	val += in;
//	warning ("PFloat::operator += (float %f)", in); 
	//emit ValueUpdated();
	return *this;
}

//--------------------------------------------------------------------
PFloat::operator float()
{
	if (!animated)
		return val;
	else
	{
		bool	ok;
		return g_curveControl->GetFloatValFromCurve( animated, g_frame,  ok);
	}
}

//--------------------------------------------------------------------
PFloat::operator int()
{
	if (!animated)
		return (int)val;
	else
		//lookup new value
		return (int)val;
}

//--------------------------------------------------------------------
float PFloat::SetVal(float in)
{
//	if (!animated)
//	{
		updated = true;
		val = in;
		//emit ValueUpdated();
//		return in;
//	}
	return val;
}

void	 PFloat::SetAnimation(int in)	
{
	updated = true;
	animated = in;	
}
////--------------------------------------------------------------------
//void PFloat::SetValSlot(float in)
//{
//	if (!animated)
//	{
//		updated = true;
//		val = in;
////		warning ("PFloat::SetValSlot(float %f) pointer = %p", in, this); 
//		emit ValueUpdated();
//	}
//}
//
