#include "pFloatWidget.h"
#include "extern.h"

PFloatWidget::PFloatWidget(PFloat *flt, const char* lbl, QWidget *parent, const char* name, bool showLabel )
	:	QWidget (parent, name)
{
	pFloat = flt;
	hasLabel = showLabel;
	
	label = 0;
	
	if (hasLabel)
	{
		label = new QLabel(this);
		label->setFixedSize(g_numInputWidth, 20);
		label->setAlignment(AlignHCenter | AlignBottom);
		label->setText(lbl);
//		label->setFont( *g_font_MB );
	}
	
	input = new NumInput(NumInput::Double, this);
	input->SetLabelWidth(g_numLabelWidth);
	input->SetTotalWidth(g_numInputWidth);
	if (pFloat)
		SetFloatPointer(flt, lbl);
	
	//----------------------------------
	QObject::connect(input, SIGNAL(ValueChanged(float)), SLOT(SetPFloatValue(float)) );
	
	QObject::connect(input, SIGNAL(Updated()), SIGNAL(Updated()) );
	//----------------------------------
	topLayout = new QVBoxLayout(this, 0, 0);
	
	if (hasLabel)
		topLayout->addWidget(label);
	topLayout->addWidget(input);
	
	topLayout->activate();
	
}

PFloatWidget::~PFloatWidget()
{	
}

//--------------------------------------------------------------------
void	PFloatWidget::setEnabled(bool status)
{
	if (hasLabel)
		label->setEnabled(status);
	input->setEnabled(status);
}


//--------------------------------------------------------------------
void	PFloatWidget::Update()
{
	input->SetValueSolid(pFloat->Value());
//	warning ("PFloatWidget::Update() %p", this);
}

//--------------------------------------------------------------------
void	PFloatWidget::SetFloatPointer(PFloat *inP, const char* lbl)
{
	if (hasLabel)
		label->setText(lbl);
	input->SetLabel(lbl);
	
	if (pFloat)
	{
//		QObject::disconnect(pFloat, SIGNAL(ValueUpdated()), this, SLOT(Update()) );
//		inP->count--;
	}
	if (inP)
	{
//		QObject::connect(inP, SIGNAL(ValueUpdated()), this, SLOT(Update()) );
//		inP->count++;
	}
		
	if (inP)
	{
		pFloat = inP;
		input->setEnabled(true);
		input->SetValueSolid((float)*pFloat);
	}
	else
	{
		input->setEnabled(false);
		pFloat = inP;
	}
//	
//	if (inP)
//	{
//		if (pFloat)
//		{
//			QObject::disconnect(input, SIGNAL(ValueChanged(float)), pFloat, SLOT(SetValSlot(float)) );
//		}
//		
//		pFloat = inP;
//		
//		input->setEnabled(true);
//		input->SetValueSolid((float)*pFloat);
//		QObject::connect(input, SIGNAL(ValueChanged(float)), pFloat, SLOT(SetValSlot(float)) );
//		
//		//input->setFocus();
//	}
//	else
//	{
//		input->setEnabled(false);
//		if (pFloat)
//		{
//			QObject::disconnect(input, SIGNAL(ValueChanged(float)), pFloat, SLOT(SetValSlot(float)) );
//		}
//		
//		pFloat = inP;
//	}
//	
}


//--------------------------------------------------------------------
void	PFloatWidget::SetPFloatValue(float in)
{
	if (pFloat)
	{
		pFloat->SetVal(in);
	}
}
