#ifndef PFLOATWIDGET_H
#define PFLOATWIDGET_H

#include <qwidget.h>
#include <qlayout.h>
#include <qcombobox.h>
#include <qlist.h>
#include <qlabel.h>

#include "numInput.h"
#include "pFloat.h"
#include <particle/papi.h>

/**
 * 
 */
class PFloatWidget : public QWidget
{
	Q_OBJECT
	
public:
	PFloatWidget(PFloat *flt = 0, const char* lbl = 0, QWidget *parent = 0, const char* name = 0, bool showLabel = true);
	~PFloatWidget();

	void	SetFloatPointer(PFloat *flt = 0, const char* lbl = 0);
	
	void	setEnabled(bool);
	
	inline void	SetFocus()	{	input->SetFocus();	}

signals:
	void	Updated();
	
public slots:
	void	Update();
	void	SetPFloatValue(float);

protected:
	QVBoxLayout	*topLayout;
	QLabel		*label;
	NumInput	*input;
	
	bool	hasLabel;
	
	PFloat	*pFloat;
	
};

#endif
