#ifndef pGeometry_h
#define pGeometry_h

#include "pAction.h"

/**
 *
 */
//==============================================================================
class PGSphere	: public FlowParticleAction
{
public:
	PGSphere(float r = 1.0, float zn = -1.0, float zx = 1.0, float thm = 360.0, float d = 16.0, bool drw = true, bool cls = false);
	~PGSphere();
	PGSphere(FlowParticleAction&);
	
	void drawRIB(int frame);
	void drawGL(int frame);
	void WriteCode(FILE* outfile);
//	void SaveToFile(FILE *outfile, int tabs);
	
};

/**
 *
 */
//==============================================================================
class PGCone	: public FlowParticleAction
{
public:
	PGCone(float h = 1.0, float r = 1.0, float thm = 360.0, float d = 16.0, bool drw = true, bool cls = false);
	~PGCone();
	PGCone(FlowParticleAction&);
	
	void drawRIB(int frame);
	void drawGL(int frame);
	void WriteCode(FILE* outfile);
//	void SaveToFile(FILE *outfile, int tabs);
	
};

/**
 *
 */
//==============================================================================
class PGDisk	: public FlowParticleAction
{
public:
	PGDisk(float h = 0.0, float r = 1.0, float thm = 360.0, float d = 16.0, bool drw = true, bool cls = false);
	~PGDisk();
	PGDisk(FlowParticleAction&);
	
	void drawRIB(int frame);
	void drawGL(int frame);
	void WriteCode(FILE* outfile);
//	void SaveToFile(FILE *outfile, int tabs);
	
};

/**
 *
 */
//==============================================================================
class PGCylinder	: public FlowParticleAction
{
public:
	PGCylinder(float r = 1.0, float zn = -1.0, float zx = 1.0, float thm = 360.0, float d = 16.0, bool drw = true, bool cls = false);
	~PGCylinder();
	PGCylinder(FlowParticleAction&);
	
	void drawRIB(int frame);
	void drawGL(int frame);
	void WriteCode(FILE* outfile);
//	void SaveToFile(FILE *outfile, int tabs);
	
};


#endif // pGeometry_h


