#include "pPolygonObject.h"

#include "compatibility.h"
#include <GL/gl.h>
#include <ri.h>

#include <stdio.h>
#include <qstring.h>
#include "extern.h"

MVertex PPolygonObject::nullVertex;

//--------------------------------------------------------------------
static MVertex* vertexFromString( QCString* aString )
{
    MVertex* newVertex = 0;
    float float0, float1, float2;

//  *aString = aString->stripWhiteSpace();
    sscanf( (const char*)*aString, "%f", &float0 );
    aString->remove( 0, aString->find( " " ) + 1 );
    sscanf( (const char*)*aString, "%f", &float1 );
    aString->remove( 0, aString->find( " " ) + 1 );
    sscanf( (const char*)*aString, "%f", &float2 );

    newVertex = new MVertex( float0, float1, -float2 );
    return newVertex;
}

//==============================================================================
PPolygonObject::PPolygonObject(FILE* infile)
{
	int		        byteSize = sizeof(PPolygonObject);
	char		    buffer[256];
	QString       	tmpString;
	PPolygon	    *newPoly;

	allNorms	= false;
	hilightPoly = -1;
	normalScale = 0.1;
	polygonList.setAutoDelete(true);
	updated = true;
	
	maxX = -10000.0;
	minX =  10000.0;
	maxY = -10000.0;
	minY =  10000.0;
	maxZ = -10000.0;
	minZ =  10000.0;
	maxArea = -10000.0;

	int	lineNum = 0;
//	int bufferPos;
//	int endPos;
	while(	fgets(buffer, 256, infile) > 0)
//	while ( tmpString.length() > 0 )
	{
		if (!(lineNum % 50))
		{
			fprintf(stderr, ".");
//			warning("read line %5d %s", lineNum, buffer);
		}

		lineNum++;

    	tmpString = buffer;
	    tmpString = tmpString.simplifyWhiteSpace();
// begin bg
        if ( tmpString.find( "PointsPolygons" ) >= 0 )
        {
			readPointsPolygons(infile, tmpString, byteSize);
//            QCString indicesString;
//            QCString pointsString;
//            QCString normalsString;
//
//	        // Skip the poly vert num list
//	        // Assume 3 vectors per poly (iaw: triangles)
//	        bufferPos = tmpString.find( "]" );
//            while ( bufferPos == -1 )
//	        {
//    	        fgets( buffer, 256, infile );
//            	tmpString = buffer;
//            	bufferPos = tmpString.find( "]" );
//	        }
//	        tmpString.remove( 0, bufferPos + 1 );
//
//	        // Read the indices
//			warning( "Reading poly indices..." );
//            do
//	        {
//    	        fgets( buffer, 256, infile );
//            	tmpString += buffer;
//            	endPos = tmpString.find( "]" );
//	        } while ( endPos == -1 );
//	        tmpString = tmpString.simplifyWhiteSpace();
//	        bufferPos = tmpString.find( "[" );
//           	endPos = tmpString.find( "]" );
//	        indicesString = tmpString.mid( bufferPos + 1, endPos - bufferPos - 1 );
//	        indicesString = indicesString.stripWhiteSpace();
//	        tmpString.remove( 0, endPos + 1 );
//
//	        // Read the points
//			warning( "Reading points..." );
//            do
//	        {
//    	        fgets( buffer, 256, infile );
//            	tmpString += buffer;
//            	endPos = tmpString.find( "]" );
//	        } while ( endPos == -1 );
//	        tmpString = tmpString.simplifyWhiteSpace();
//	        bufferPos = tmpString.find( "[" );
//           	endPos = tmpString.find( "]" );
//           	if ( tmpString.find( "\"P\"" ) != -1 )
//           	{
//	            pointsString = tmpString.mid( bufferPos + 1, endPos - bufferPos - 1 );
//	            pointsString = pointsString.stripWhiteSpace();
//	        }
//	        else
//	        {
//	            warning( "Expected points list not found." );
//	            break;
//	        }
//	        tmpString.remove( 0, endPos + 1 );
//
//	        // Read the normals
//   		    warning( "Reading normals..." );
//            do
//	        {
//    	        fgets( buffer, 256, infile );
//            	tmpString += buffer;
//            	endPos = tmpString.find( "]" );
//	        } while ( endPos == -1 );
//	        tmpString = tmpString.simplifyWhiteSpace();
//	        bufferPos = tmpString.find( "[" );
//           	endPos = tmpString.find( "]" );
//           	if ( tmpString.find( "\"N\"" ) != -1 )
//           	{
//	            normalsString = tmpString.mid( bufferPos + 1, endPos - bufferPos - 1 );
//	            normalsString = normalsString.stripWhiteSpace();
//	        }
//	        else
//	        {
//	            warning( "Expected normals list not found." );
//	            break;
//	        }
//	        tmpString.remove( 0, endPos + 2 );
//            
//            // Parse poly vert index list
////          warning( "Indices: %s", (const char*)indicesString );
//	        QList< int > indices;
//	        indices.setAutoDelete( true );
//	        int anIndex;
//	        bufferPos = 0;
//	        do
//	        {
//	            indicesString.remove( 0, bufferPos );
//   		        sscanf( (const char*)indicesString, "%d", &anIndex );
//   			    indices.append( new int( anIndex ) );
//   			    bufferPos = indicesString.find( " " ) + 1;
//	        } while ( bufferPos != 0 );
//
//			// Parse points
////          warning( "Points: %s", (const char*)pointsString );
//            QList< MVertex > vertices;
//		    vertices.setAutoDelete( true );
//			bufferPos = 0;
//			do
//			{
//	            pointsString.remove( 0, bufferPos );
//   			    vertices.append( vertexFromString( &pointsString ) );
//   			    bufferPos = pointsString.find( " " ) + 1;
//			} while ( bufferPos != 0 );
//
//			// Parse normals
////          warning( "Normals: %s", (const char*)normalsString );
//	        QList< MVertex > normals;
//	        normals.setAutoDelete( true );
//			bufferPos = 0;
//			do
//			{
//	            normalsString.remove( 0, bufferPos );
//   			    normals.append( vertexFromString( &normalsString ) );
//   			    bufferPos = normalsString.find( " " ) + 1;
//			} while ( bufferPos != 0 );
//				
//			// Add the polys to the list
//	        MVertex polyVertices[ 3 ];
//	        MVertex polyNormals[ 3 ];
//		    for ( uint i = 0; i < indices.count(); i += 3 )
//		    {
//		        for ( int j = 0; j < 3; j++ )
//		        {
//		            anIndex = *indices.at( i + j );
//		            polyVertices[ j ] = *vertices.at( anIndex );
//    	            polyNormals[ j ] = *normals.at( anIndex );
//                }
//        		polygonList.append( newPoly = new PPolygon( polyVertices, polyNormals ) );
//		        byteSize += sizeof( PPolygon );
//        		
//        		//-- calculate bounding box
//		        updateBoundingBox( newPoly );
//            }
        }
// end bg
		else if (tmpString.find("Polygon") >= 0)
		{
			polygonList.append(newPoly = new PPolygon((const char*)tmpString));
			byteSize += sizeof( PPolygon );
            
			//-- calculate bounding box
	        updateBoundingBox( newPoly );
		}
		else if (tmpString.find('}') == 0)
		{
//			warning ("pPolygonObject found \'}\'");
			break;
		}
		else if (tmpString.find('#') >= 0)
		{
		}
//		else
//			break;
	}
}

PPolygonObject::~PPolygonObject()
{
//	warning("PPolygonObject::~PPolygonObject() -- %6d polygons in this, %6d total", polygonList.count(), PPolygon::icount);
	polygonList.setAutoDelete(true);
	polygonList.clear();
//	warning("                                     %6d polygons in this, %6d total", polygonList.count(), PPolygon::icount);
}

//--------------------------------------------------------------------
PPolygonObject::PPolygonObject(PPolygonObject& copy)
{
	int			byteSize = sizeof(PPolygonObject);
	polygonList.setAutoDelete(true);
	allNorms	= false;
	hilightPoly = -1;
	normalScale = 0.1;
	maxX = copy.maxX;
	minX = copy.minX;
	maxY = copy.maxY;
	minY = copy.minY;
	maxZ = copy.maxZ;
	minZ = copy.minZ;
	maxArea = copy.maxArea;
	uint i;
	for (i = 0; i < copy.polygonList.count(); i++)
	{
		polygonList.append(new PPolygon( *(copy.polygonList.at(i))) );
		byteSize += sizeof(PPolygon);
	}
}

//--------------------------------------------------------------------
void    PPolygonObject::updateBoundingBox( PPolygon* newPoly )
{
	if ((newPoly->v0).X() > maxX)	maxX = (newPoly->v0).X();
	if ((newPoly->v1).X() > maxX)	maxX = (newPoly->v1).X();
	if ((newPoly->v2).X() > maxX)	maxX = (newPoly->v2).X();
	if ((newPoly->v0).X() < minX)	minX = (newPoly->v0).X();
	if ((newPoly->v1).X() < minX)	minX = (newPoly->v1).X();
	if ((newPoly->v2).X() < minX)	minX = (newPoly->v2).X();
	if ((newPoly->v0).Y() > maxY)	maxY = (newPoly->v0).Y();
	if ((newPoly->v1).Y() > maxY)	maxY = (newPoly->v1).Y();
	if ((newPoly->v2).Y() > maxY)	maxY = (newPoly->v2).Y();
	if ((newPoly->v0).Y() < minY)	minY = (newPoly->v0).Y();
	if ((newPoly->v1).Y() < minY)	minY = (newPoly->v1).Y();
	if ((newPoly->v2).Y() < minY)	minY = (newPoly->v2).Y();
	if ((newPoly->v0).Z() > maxZ)	maxZ = (newPoly->v0).Z();
	if ((newPoly->v1).Z() > maxZ)	maxZ = (newPoly->v1).Z();
	if ((newPoly->v2).Z() > maxZ)	maxZ = (newPoly->v2).Z();
	if ((newPoly->v0).Z() < minZ)	minZ = (newPoly->v0).Z();
	if ((newPoly->v1).Z() < minZ)	minZ = (newPoly->v1).Z();
	if ((newPoly->v2).Z() < minZ)	minZ = (newPoly->v2).Z();
	if ( newPoly->area > maxArea)
		maxArea = newPoly->area;
}

//--------------------------------------------------------------------
MVertex&	PPolygonObject::PolyNormal(int index)
{
	if (index >= 0 && index < NumPolygons() )
	{
		return polygonList.at(index)->nP;
	}
	else
		return nullVertex;
}
	
//--------------------------------------------------------------------
PPolygon	*PPolygonObject::PolygonAt(int index)
{
	if (index >= 0 && index < NumPolygons() )
	{
		return polygonList.at(index);
	}
	else
		return 0;
}

//--------------------------------------------------------------------
void	PPolygonObject::InvertNormal(int index, bool x, bool y, bool z)
{
	updated = true;
	if (index >= 0 && index < NumPolygons() )
	{
		polygonList.at(index)->InvertNormal(x, y, z);
	}
}

//--------------------------------------------------------------------
void	PPolygonObject::InvertPolygon(int index)
{
	updated = true;
	if (index >= 0 && index < NumPolygons() )
	{
		polygonList.at(index)->InvertPolygon();
	}
}

//--------------------------------------------------------------------
void	PPolygonObject::drawGL()
{
	uint i;
//	PPolygon	*poly;
	
	glBegin(GL_TRIANGLES);
	for (i = 0; i < polygonList.count(); i++)
	{
		polygonList.at(i)->drawGL();
	}
	glEnd();
	
	// this is horribly inefficient...
	if ( (hilightPoly >= 0 && hilightPoly < NumPolygons()) || allNorms )
	{
		GL__lighting = false;	glDisable(GL_LIGHTING);
		glLineWidth(1.0);
		
		if (allNorms)
		{
			glColor4f(0.5, 0.5, 0.5, 1.0);
			glBegin(GL_LINES);
			for (i = 0; i < polygonList.count(); i++)
			{
				polygonList.at(i)->DrawGLNormals(normalScale);
			}
			glEnd();
		}
		if ( hilightPoly >= 0 && hilightPoly < NumPolygons() )
		{
			glColor4f(1.0, 1.0, 1.0, 1.0);
			glBegin(GL_LINE_LOOP);
			polygonList.at(hilightPoly)->drawGL();
			glEnd();
			glBegin(GL_LINES);
			polygonList.at(hilightPoly)->DrawGLNormals(normalScale);
			glEnd();
		}
		
		GL__lighting = true;	glEnable(GL_LIGHTING);
	}
}

//--------------------------------------------------------------------
void	PPolygonObject::DrawGLBounds()
{
	glBegin(GL_LINE_STRIP);
	glVertex3f( minX, minY, minZ );	
	glVertex3f( maxX, minY, minZ );	
	glVertex3f( maxX, maxY, minZ );	
	glVertex3f( minX, maxY, minZ );
	glVertex3f( minX, minY, minZ );	
	
	glVertex3f( minX, minY, maxZ );	
	glVertex3f( maxX, minY, maxZ );	
	glVertex3f( maxX, maxY, maxZ );	
	glVertex3f( minX, maxY, maxZ );
	glVertex3f( minX, minY, maxZ );	
	
	glVertex3f( minX, maxY, maxZ );	
	glVertex3f( minX, maxY, minZ );	
	
	glVertex3f( maxX, maxY, minZ );	
	glVertex3f( maxX, maxY, maxZ );	
	
	glVertex3f( maxX, minY, maxZ );	
	glVertex3f( maxX, minY, minZ );	
	
	glEnd();
}
	
//--------------------------------------------------------------------
void	PPolygonObject::drawRIB()
{
	uint i;
	for (i = 0; i < polygonList.count(); i++)
	{
		polygonList.at(i)->drawRIB();
	}
}
	
//--------------------------------------------------------------------
void	PPolygonObject::SaveToFile(FILE *outfile, int tabs)
{
	char	buffer[1024];
	int		i;
	PPolygon	*poly;
	
	char	*walker = buffer;
	for (i = 0; i < tabs; i++)
	{	*walker = '\t';	*(walker+1) = '\0';	walker++;	}
	
	sprintf(walker, "POLYGONS\n");
	fputs(buffer, outfile);
	sprintf(walker, "{\n");
	fputs(buffer, outfile);
	for (i = 0; i < (int)polygonList.count(); i++)
	{
		poly = polygonList.at(i);
		sprintf(walker, "\tPolygon \"P\" [%f %f %f %f %f %f %f %f %f ] \"N\" [%f %f %f %f %f %f %f %f %f ]\n", 
			poly->v0.X(), poly->v0.Y(), -poly->v0.Z(), 
			poly->v1.X(), poly->v1.Y(), -poly->v1.Z(), 
			poly->v2.X(), poly->v2.Y(), -poly->v2.Z(), 
			poly->n0.X(), poly->n0.Y(), -poly->n0.Z(), 
			poly->n1.X(), poly->n1.Y(), -poly->n1.Z(), 
			poly->n2.X(), poly->n2.Y(), -poly->n2.Z() );
		fputs(buffer, outfile);
	}
	sprintf(walker, "}\n");
	fputs(buffer, outfile);
}

//--------------------------------------------------------------------
void	PPolygonObject::readPointsPolygons(FILE *infile, QString &tmpString, int &byteSize)
{
	char		buffer[256];
	int 		bufferPos;
	int 		endPos;
	PPolygon	*newPoly;
	QCString	indicesString;
	QCString	pointsString;
	QCString	normalsString;

	// Skip the poly vert num list
	// Assume 3 vectors per poly (iaw: triangles)
	bufferPos = tmpString.find( "]" );
	while ( bufferPos == -1 )
	{
    	fgets( buffer, 256, infile );
    	tmpString = buffer;
    	bufferPos = tmpString.find( "]" );
	}
	tmpString.remove( 0, bufferPos + 1 );

	// Read the indices
	warning( "Reading poly indices..." );
	do
	{
    	fgets( buffer, 256, infile );
    	tmpString += buffer;
    	endPos = tmpString.find( "]" );
	} while ( endPos == -1 );
	tmpString = tmpString.simplifyWhiteSpace();
	bufferPos = tmpString.find( "[" );
	endPos = tmpString.find( "]" );
	indicesString = tmpString.mid( bufferPos + 1, endPos - bufferPos - 1 );
	indicesString = indicesString.stripWhiteSpace();
	tmpString.remove( 0, endPos + 1 );

	// Read the points
	warning( "Reading points..." );
	do
	{
    	fgets( buffer, 256, infile );
    	tmpString += buffer;
    	endPos = tmpString.find( "]" );
	} while ( endPos == -1 );
	tmpString = tmpString.simplifyWhiteSpace();
	bufferPos = tmpString.find( "[" );
	endPos = tmpString.find( "]" );
	if ( tmpString.find( "\"P\"" ) != -1 )
	{
		pointsString = tmpString.mid( bufferPos + 1, endPos - bufferPos - 1 );
		pointsString = pointsString.stripWhiteSpace();
	}
	else
	{
		warning( "FATAL: Expected points list not found." );
		return;
	}
	tmpString.remove( 0, endPos + 1 );

	// Read the normals
	warning( "Reading normals..." );
	do
	{
    	fgets( buffer, 256, infile );
    	tmpString += buffer;
    	endPos = tmpString.find( "]" );
	} while ( endPos == -1 );
	tmpString = tmpString.simplifyWhiteSpace();
	bufferPos = tmpString.find( "[" );
	endPos = tmpString.find( "]" );
	if ( tmpString.find( "\"N\"" ) != -1 )
	{
		normalsString = tmpString.mid( bufferPos + 1, endPos - bufferPos - 1 );
		normalsString = normalsString.stripWhiteSpace();
	}
	else
	{
		warning( "FATAL: Expected normals list not found." );
		return;
	}
	tmpString.remove( 0, endPos + 2 );

	// Parse poly vert index list
	//          warning( "Indices: %s", (const char*)indicesString );
	QList< int > indices;
	indices.setAutoDelete( true );
	int anIndex;
	bufferPos = 0;
	do
	{
		indicesString.remove( 0, bufferPos );
   		sscanf( (const char*)indicesString, "%d", &anIndex );
   		indices.append( new int( anIndex ) );
   		bufferPos = indicesString.find( " " ) + 1;
	} while ( bufferPos != 0 );

	// Parse points
	//          warning( "Points: %s", (const char*)pointsString );
	QList< MVertex > vertices;
	vertices.setAutoDelete( true );
	bufferPos = 0;
	do
	{
		pointsString.remove( 0, bufferPos );
   		vertices.append( vertexFromString( &pointsString ) );
   		bufferPos = pointsString.find( " " ) + 1;
	} while ( bufferPos != 0 );

	// Parse normals
	//          warning( "Normals: %s", (const char*)normalsString );
	QList< MVertex > normals;
	normals.setAutoDelete( true );
	bufferPos = 0;
	do
	{
		normalsString.remove( 0, bufferPos );
   		normals.append( vertexFromString( &normalsString ) );
   		bufferPos = normalsString.find( " " ) + 1;
	} while ( bufferPos != 0 );

	// Add the polys to the list
	MVertex polyVertices[ 3 ];
	MVertex polyNormals[ 3 ];
	for ( uint i = 0; i < indices.count(); i += 3 )
	{
		for ( int j = 0; j < 3; j++ )
		{
			anIndex = *indices.at( i + j );
			polyVertices[ j ] = *vertices.at( anIndex );
    		polyNormals[ j ] = *normals.at( anIndex );
    	}
    	polygonList.append( newPoly = new PPolygon( polyVertices, polyNormals ) );
		byteSize += sizeof( PPolygon );

    	//-- calculate bounding box
		updateBoundingBox( newPoly );
	}
}

//==============================================================================
int	PPolygon::icount = 0;

PPolygon::PPolygon()
{
	icount++;
	v0.set(-1.0,  0.0, -1.0);
	v1.set( 1.0,  0.0, -1.0);
	v2.set( 0.0,  0.0,  1.0);
	n0.set( 0.0,  1.0,  0.0);
	n1.set( 0.0,  1.0,  0.0);
	n2.set( 0.0,  1.0,  0.0);
	nP.set( 0.0,  1.0,  0.0);
	area = 1.0;
}

PPolygon::PPolygon(const char* inString)
{
	icount++;
	v0.set(-1.0,  0.0, -1.0);
	v1.set( 1.0,  0.0, -1.0);
	v2.set( 0.0,  0.0,  1.0);
	n0.set( 0.0,  1.0,  0.0);
	n1.set( 0.0,  1.0,  0.0);
	n2.set( 0.0,  1.0,  0.0);
	nP.set( 0.0,  1.0,  0.0);
	area = 1.0;
	if (inString)
		ReadFromString(inString);
}

PPolygon::PPolygon( MVertex* v, MVertex* n )
{
	icount++;
	v0 = v[ 0 ];
	v1 = v[ 1 ];
	v2 = v[ 2 ];
	if ( n != 0 )
	{
    	n0 = n[ 0 ];
	    n1 = n[ 1 ];
    	n2 = n[ 2 ];
		MVertex	normSum( n0 );
		normSum.add( n1 );
		normSum.add( n2 );
		normSum.normalize();
		nP = normSum;
    }
    else
    {
    	n0.set( 0.0,  1.0,  0.0);
	    n1.set( 0.0,  1.0,  0.0);
    	n2.set( 0.0,  1.0,  0.0);
    	nP.set( 0.0,  1.0,  0.0);
    }
    calculateArea();
}

PPolygon::~PPolygon()
{
	icount--;
	//warning("PPolygon::~PPolygon()");
}

//--------------------------------------------------------------------
PPolygon::PPolygon(PPolygon &copy)
{
	icount++;
	v0 = copy.v0;
	v1 = copy.v1;
	v2 = copy.v2;
	n0 = copy.n0;
	n1 = copy.n1;
	n2 = copy.n2;
	nP = copy.nP;
	centroid = copy.centroid;
	area = copy.area;
}

//--------------------------------------------------------------------
void	PPolygon::drawGL()
{
	glNormal3f(n0.X(), n0.Y(), n0.Z());
	glVertex3f(v0.X(), v0.Y(), v0.Z());
	glNormal3f(n1.X(), n1.Y(), n1.Z());
	glVertex3f(v1.X(), v1.Y(), v1.Z());
	glNormal3f(n2.X(), n2.Y(), n2.Z());
	glVertex3f(v2.X(), v2.Y(), v2.Z());
}

//--------------------------------------------------------------------
void	PPolygon::drawGL(float addX, float addY, float addZ)
{
	glNormal3f(n0.X()     , n0.Y()     , n0.Z() 	);
	glVertex3f(v0.X()+addX, v0.Y()+addY, v0.Z()+addZ);
	glNormal3f(n1.X()	  , n1.Y()     , n1.Z() 	);
	glVertex3f(v1.X()+addX, v1.Y()+addY, v1.Z()+addZ);
	glNormal3f(n2.X()	  , n2.Y()     , n2.Z() 	);
	glVertex3f(v2.X()+addX, v2.Y()+addY, v2.Z()+addZ);
}

//--------------------------------------------------------------------
void	PPolygon::DrawGLNormals(float scale)
{
	glVertex3fv(v0.XYZ());
	glVertex3f(v0.X()+n0.X()*scale, v0.Y()+n0.Y()*scale, v0.Z()+n0.Z()*scale);
	glVertex3fv(v1.XYZ());
	glVertex3f(v1.X()+n1.X()*scale, v1.Y()+n1.Y()*scale, v1.Z()+n1.Z()*scale);
	glVertex3fv(v2.XYZ());
	glVertex3f(v2.X()+n2.X()*scale, v2.Y()+n2.Y()*scale, v2.Z()+n2.Z()*scale);
}

//--------------------------------------------------------------------
void	PPolygon::drawRIB()
{
	RtPoint	triangle[3];
	RtPoint	normal[3];
	triangle[0][0] = v2.X();	triangle[0][1] = v2.Y();	triangle[0][2] = -v2.Z();
	triangle[1][0] = v1.X();	triangle[1][1] = v1.Y();	triangle[1][2] = -v1.Z();
	triangle[2][0] = v0.X();	triangle[2][1] = v0.Y();	triangle[2][2] = -v0.Z();
	normal[0][0] = n2.X();     normal[0][1] = n2.Y();	   normal[0][2] = -n2.Z();
	normal[1][0] = n1.X();     normal[1][1] = n1.Y();	   normal[1][2] = -n1.Z();
	normal[2][0] = n0.X();     normal[2][1] = n0.Y();	   normal[2][2] = -n0.Z();
	
	RiPolygon(3, RI_P, (RtPointer)triangle, RI_N, (RtPointer)normal, RI_NULL);
}
//--------------------------------------------------------------------
void	PPolygon::drawRIB(float addX, float addY, float addZ)
{
	RtPoint	triangle[3];
	RtPoint	normal[3];
	triangle[0][0] = v2.X()+addX;	 triangle[0][1] = v2.Y()+addY;    triangle[0][2] = -v2.Z()-addZ;
	triangle[1][0] = v1.X()+addX;	 triangle[1][1] = v1.Y()+addY;    triangle[1][2] = -v1.Z()-addZ;
	triangle[2][0] = v0.X()+addX;	 triangle[2][1] = v0.Y()+addY;    triangle[2][2] = -v0.Z()-addZ;
	normal[0][0] = n2.X();     normal[0][1] = n2.Y();	   normal[0][2] = -n2.Z();
	normal[1][0] = n1.X();     normal[1][1] = n1.Y();	   normal[1][2] = -n1.Z();
	normal[2][0] = n0.X();     normal[2][1] = n0.Y();	   normal[2][2] = -n0.Z();
	
	RiPolygon(3, RI_P, (RtPointer)triangle, RI_N, (RtPointer)normal, RI_NULL);
}

//--------------------------------------------------------------------
void	PPolygon::InvertNormal(bool x, bool y, bool z)
{
	if (x)
	{
		n0.setX(-n0.X());
		n1.setX(-n1.X());
		n2.setX(-n2.X());
		nP.setX(-nP.X());
	}
	if (y)
	{
		n0.setY(-n0.Y());
		n1.setY(-n1.Y());
		n2.setY(-n2.Y());
		nP.setY(-nP.Y());
	}
	if (z)
	{
		n0.setZ(-n0.Z());
		n1.setZ(-n1.Z());
		n2.setZ(-n2.Z());
		nP.setZ(-nP.Z());
	}
}

//--------------------------------------------------------------------
void	PPolygon::InvertPolygon()
{
	MVertex tmpV;
	tmpV = v0;
	v0 = v2;
	v2 = tmpV;
	tmpV = n0;
	n0 = n2;
	n2 = tmpV;
}

//--------------------------------------------------------------------
bool	PPolygon::ReadFromString(const char* string)
{
	QCString	polyString;
	polyString = string;
	polyString = polyString.stripWhiteSpace();
	int		trunc;
	float	float00;
	float	float01;
	float	float02;
	float	float10;
	float	float11;
	float	float12;
	float	float20;
	float	float21;
	float	float22;
	bool	success = false;
	bool	polyRead = false;
	bool	normRead = false;
	
	if (polyString.find("Polygon") == 0)
	{
		polyString.remove(0, 8);
		while(polyString.length() > 0)
		{
			if (polyString.find("\"P\"") == 0)
			{
				sscanf((const char*)polyString, "\"P\" [%f %f %f %f %f %f %f %f %f",	
//															&float20, &float21, &float22,
//															&float10, &float11, &float12,
//															&float00, &float01, &float02 );
															&float00, &float01, &float02,
															&float10, &float11, &float12,
															&float20, &float21, &float22 );
				v0.setX(float00);	v0.setY(float01);	v0.setZ(-float02);
				v1.setX(float10);	v1.setY(float11);	v1.setZ(-float12);
				v2.setX(float20);	v2.setY(float21);	v2.setZ(-float22);
				trunc = polyString.find(']');
				polyString.remove(0, trunc+1);
				polyString = polyString.simplifyWhiteSpace();
				polyRead = true;
			}
			else if (polyString.find("\"N\"") == 0)
			{
				sscanf((const char*)polyString, "\"N\" [%f %f %f %f %f %f %f %f %f",	
															&float00, &float01, &float02,
															&float10, &float11, &float12,
															&float20, &float21, &float22 );
				n0.setX(float00); n0.setY(float01); n0.setZ(-float02);
				n1.setX(float10); n1.setY(float11); n1.setZ(-float12);
				n2.setX(float20); n2.setY(float21); n2.setZ(-float22);
				//n0.normalize();
				//n1.normalize();
				//n2.normalize();
				trunc = polyString.find(']');
				polyString.remove(0, trunc+1);
				polyString = polyString.simplifyWhiteSpace();
				normRead = true;
			}
			else
			{
				warning("ERROR reading polygon string : \n\"%s\"", (const char*)polyString);
				polyString = "";
			}						 
			//warning("%s", (const char*)polyString);
		}

		if (polyRead)
		{	
//			InvertPolygon();	// Should be read in in LEFT, switch to RIGHT for GL
			success = true;
			MVertex	normSum(n0);
			normSum.add(n1);
			normSum.add(n2);
			normSum.normalize();
			nP = normSum;
//			nP.CreateNormal(v0, v1, v2);
			if (!normRead)
			{
				warning("No normals read");
				n0 = nP;
				n1 = nP;
				n2 = nP;
			}
//			else
//			{
//				MVertex	normSum(n0);
//				normSum.add(n1);
//				normSum.add(n2);
//				normSum.normalize();
//				if (normSum.IsOpposite(nP))	// if nP is opposite read norms, change orientation
//				{
////					n0.Invert();
////					n1.Invert();
////					n2.Invert();
//					MVertex	tmpV;
//					tmpV = v0;
//					v0 = v2;
//					v2 = tmpV;
//					
//					tmpV = n0;
//					n0 = n2;
//					n2 = tmpV;
//					
//					nP.CreateNormal(v0, v1, v2);
//				}
//				
//			}
//				printf("opposite %d\n", normSum.IsOpposite(nP) );
//				printf("normSum = %f	%f	%f\n", normSum.X(), normSum.Y(), normSum.Z());
//				printf("normPoly= %f	%f	%f\n\n", nP.X(), nP.Y(), nP.Z() );
		}

		calculateArea();
		// Will this give me area? According to someone on usenet, it should
/*		MVertex	A = v1 - v0;
		MVertex	B = v2 - v0;
		MVertex a0;
		a0.setX(A.Y()*B.Z() - B.Y()*A.Z());
		a0.setY(A.Z()*B.X() - B.Z()*A.X());
		a0.setZ(A.X()*B.Y() - B.X()*A.Y());
		area = a0.length()*0.5;
		centroid.setX( (v0.X()+v1.X()+v2.X())/3.0);
		centroid.setY( (v0.Y()+v1.Y()+v2.Y())/3.0);
		centroid.setZ( (v0.Z()+v1.Z()+v2.Z())/3.0);*/
	}
        return success;
}

void    PPolygon::calculateArea( void )
{
	// Will this give me area? According to someone on usenet, it should
	MVertex	A = v1 - v0;
	MVertex	B = v2 - v0;
	MVertex a0;
	a0.setX(A.Y()*B.Z() - B.Y()*A.Z());
	a0.setY(A.Z()*B.X() - B.Z()*A.X());
	a0.setZ(A.X()*B.Y() - B.X()*A.Y());
	area = a0.length()*0.5;
	centroid.setX( (v0.X()+v1.X()+v2.X())/3.0);
	centroid.setY( (v0.Y()+v1.Y()+v2.Y())/3.0);
	centroid.setZ( (v0.Z()+v1.Z()+v2.Z())/3.0);
}
