#ifndef polygonTweak_h
#define polygonTweak_h

#include <qwidget.h>
#include <qscrollbar.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include "mwidgets.h"
#include <qcombobox.h>
#include <qlcdnumber.h>

#include "numInput.h"

class PPolygonObject;

/**
 *
 */
//==============================================================================
class PolygonTweak : public QWidget
{
	Q_OBJECT
public:
	PolygonTweak(QWidget *parent = 0, const char* name = 0);
	~PolygonTweak();

	void	SetPolyObject(PPolygonObject*);
	
public slots:
	void	SetHighlightPoly(int);
	void	SetShowAllNorms(bool);
	void	SetNormalScale(float);
	void	InvertNormal();
	void	InvertPolygon();
	void	DoBatch();
		
protected:
	PPolygonObject	*polyObject;
	QScrollBar		*polyScroll;
	QLCDNumber		*polyNumLCD;
	
	NumInput		*normalScaleInput;
	QPushButton		*showAllNorms;
	
	QPushButton		*invertNormalBut;
	QPushButton		*invertPolyBut;
	
	QComboBox		*modeSelectCombo;
	NumInput		*skipInput;
	NumInput		*startAtInput;
	NumInput		*finishAtInput;
	QPushButton		*invertBut;
	
	MToolButton		*xNormBut;
	MToolButton		*yNormBut;
	MToolButton		*zNormBut;
	
	QVBoxLayout		*topVBoxLayout;
	QHBoxLayout		*h1Layout;
	QHBoxLayout		*h2Layout;
	QVBoxLayout		*v1Layout;
	QVBoxLayout		*v2Layout;
	QVBoxLayout		*v3Layout;
	QHBoxLayout		*normButLayout;
};

#endif
