#ifndef renderParticles_h
#define renderParticles_h

#include "particleControl.h"
#include "extern.h"

#ifndef WIN32	
	#include <unistd.h>
	#include <sys/wait.h>
#endif
#include <qapp.h>

#include <ri.h>
#include "renderman.h"
#include "pPolyAction.h"

extern int g_numBlurSteps;

/**
 * Insert comment into RIB stream, and then call routines to 
 * output RIB for particle system
 */
//------------------------------------------------------------------------------
void ParticleControl::RenderParticles()
{
	if(enabled)
	{
		int i;
		pCurrentGroup(particle_handle);

		char	idString[128];
		sprintf(idString, "--------------------PARTICLES----------> \"%s\"", (const char*)name );
		RiArchiveRecord ("comment", "", RI_NULL );		
		RiArchiveRecord ("comment", idString, RI_NULL );		
		RiArchiveRecord ("comment", "", RI_NULL );		
		if (rmSurface)
		{
			rmSurface->DeclareVariables();
			rmSurface->Activate();
		}
		if (rmDisplace)
		{
			rmDisplace->DeclareVariables();
			rmDisplace->Activate();
		}
		
		ParticleControl	*particleControlTS = 0;
		if(g_motionBlur)
		{
			particleControlTS = new ParticleControl(*this, true);
			for(i = 0; i < g_numBlurSteps; i++)
				particleControlTS->Execute(g_frame);
		}

		PPolygonObject *polyObj = 0;
		if(primitiveType == Polygon)
			for (i = 0; i < (int)actionList.count(); i++)
				if ( (actionList.at(i))->Type() == FlowParticleAction::PPA_PolygonEmitter )
					polyObj = ((PPAPolygonAction*)actionList.at(i))->PolygonObject();
					
		if(g_motionBlur)
			pRenderGroupBlur(primitiveType, particle_handle, *particleControlTS, polyObj);
		else
			pRenderGroup(primitiveType, polyObj);
			
		for (i = 0; i < (int)actionList.count(); i++)
		{
			actionList.at(i)->drawRIB(g_frame);
		}
		
		if(particleControlTS)
			delete	particleControlTS;
	}
}

/**
 * Not implemented...
 */
//--------------------------------------------------------------------
void	ParticleControl::Render_RIBShader()
{


}

#endif
