#include "prefDialog.h"
#include "configFlowIO.h"

#include "extern.h"

//==============================================================================
PrefDialog::PrefDialog(QWidget *parent, const char* name)
	: QTabDialog(parent, name, true)
{
	prefGeneral = new PrefDialogGeneral(this);
	prefGeneral->setFrameStyle ( QFrame::Sunken | QFrame::Panel );
	prefGeneral->setLineWidth(2);
	
	prefUI = new PrefDialogUI(this);
	prefUI->setFrameStyle ( QFrame::Sunken | QFrame::Panel );
	prefUI->setLineWidth(2);
	
//	prefRender = new PrefDialogRender(this);
//	prefRender->setFrameStyle ( QFrame::Sunken | QFrame::Panel );
//	prefRender->setLineWidth(2);
	
//	prefCode = new PrefDialogCode(this);
//	prefCode->setFrameStyle ( QFrame::Sunken | QFrame::Panel );
//	prefCode->setLineWidth(2);
	
	QTabDialog::addTab(prefGeneral, "&general");
	QTabDialog::addTab(prefUI, "&interface");
//	QTabDialog::addTab(prefRender, "&render");
//	QTabDialog::addTab(prefCode, "co&de");
//	addTab(prefToolBar);

//	setOkButton(0);
//	setCancelButton("&close");
	setApplyButton("&Save");
//	QObject::connect( this, SIGNAL(cancelButtonPressed()), SLOT(reject()) );
	QObject::connect( this, SIGNAL(applyButtonPressed()), SLOT(SaveConfigFile()) );
	
	resize(350, 470);
}

PrefDialog::~PrefDialog()
{
}

//--------------------------------------------------------------------
void	PrefDialog::SaveConfigFile()
{
	//warning("PrefDialog::SaveConfigFile()");
	ConfigFlowIO::WriteConfigFile();
	QTabDialog::accept();
}

