#ifndef prefDialogGeneral_h
#define prefDialogGeneral_h

#include <qlabel.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

#include "mbaMainWindow.h"
#include "numInput.h"
#include "mwidgets.h"

/**
 *
 */
//==============================================================================
class PrefDialogGeneral : public QFrame
{
	Q_OBJECT
public:
	PrefDialogGeneral(QWidget *parent = 0, const char *name = 0);
	~PrefDialogGeneral();
	
	void	show();
	
protected slots:
	bool	SavePrefs();
	
	void	SetPreviewSize(int);
	void	SetPreviewInterlace(int);
	void	SetRandSeed(int);
	
	void	SetKillChildren(bool);
	void	SetSaveBaseScene(bool);
	
	void	SetRendName();
	void	SetRMRenderer();
	void	SetRMRenderOpts();
	void	SetShaderEnvironment();
	void	SetDefaultSurface();
	void	SetDefaultDisplacement();
	void	SetShaderInfo();
	void	SetShaderExtension();
	void	SetTiffToJpeg();

	void	RescanShaders();
	
private:
	QVBoxLayout		*topVBoxLayout;
	QVBoxLayout		*combo0Layout;
	QHBoxLayout		*numInputHLayout;
	QVBoxLayout		*numInput0Layout;
	QGridLayout		*textEditGLayout;
	QVBoxLayout		*butVLayout;
	
	
	NumInput		*previewSizeInput;
	NumInput		*previewInterlaceInput;
	NumInput		*randomSeedInput;
	
	QLabel			*rendNameLabel;
	QLabel			*shaderEnvLabel;
	QLabel			*defaultSurfaceLabel;
	QLabel			*defaultDisplaceLabel;
	QLabel			*shaderInfoLabel;
	QLabel			*tiffToJpgLabel;
	QLabel			*rendererLabel;
	QLabel			*renderOptsLabel;
	QLabel			*shaderExtLabel;
	
	MLineEdit		*rendNameEdit;
	MLineEdit		*rendererEdit;
	MLineEdit		*renderOptsEdit;
	MLineEdit		*shaderEnvEdit;
	MLineEdit		*defaultSurfaceEdit;
	MLineEdit		*defaultDisplaceEdit;
	MLineEdit		*shaderInfoEdit;
	MLineEdit		*shaderExtEdit;
	MLineEdit		*tiffToJpgEdit;
	
	QCheckBox		*saveBaseSceneCheck;
	QCheckBox		*killChildrenCheck;
	
	QPushButton		*rescanShadersBut;
};

#endif


