#ifndef prefDialogUI_h
#define prefDialogUI_h

#include <qlabel.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

#include "mbaMainWindow.h"
#include "numInput.h"

/**
 *
 */
//==============================================================================
class PrefDialogUI : public QFrame
{
	Q_OBJECT
public:
	PrefDialogUI(QWidget *parent = 0, const char *name = 0);
	~PrefDialogUI();

protected:
	int		TranslateDock(int);

public slots:
	void	show();
	
protected slots:
	bool	SavePrefs();
	void	MoveToolTo_Top();
	void	MoveToolTo_Bot();
	void	MoveToolTo_Left();
	void	MoveToolTo_Right();
	void	SelectToolBar(int);
	
	void	SetPersistent(bool);
	void	SetToolTips(bool);
	
	void	setBaseFont();
	
	void	setFgColor();
	void	setBgColor();
	
	void	SaveCurrentGeometry();
	
	void	SetWinManAddX(int);
	void	SetWinManAddY(int);
	
private:
	QVBoxLayout		*topVBoxLayout;
	QHBoxLayout		*buttonLayout;
	QHBoxLayout		*h1Layout;
	QVBoxLayout		*toolPosVLayout;
	QHBoxLayout		*toolPosH1Layout;
	QHBoxLayout		*toolPosH2Layout;
	QHBoxLayout		*toolPosH3Layout;
	QVBoxLayout		*check0Layout;
	QVBoxLayout		*combo0Layout;
	QHBoxLayout		*saveAndXYHLayout;
	QVBoxLayout		*winManAddLayout;
	QHBoxLayout		*fontHLayout;
	QGridLayout		*colorGLayout;
	
	QLabel			*startupOptionsLabel;
	
	QCheckBox		*persistentCheck;
	QCheckBox		*toolTipsCheck;
	
	QLabel			*widgetToolLabel;
	QListBox		*widgetToolList;
	QButtonGroup	*toolPosGroup;
	QRadioButton	*toolTopRadio;
	QRadioButton	*toolBotRadio;
	QRadioButton	*toolRightRadio;
	QRadioButton	*toolLeftRadio;
	QCheckBox		*newLineCheck;
	
	QPushButton		*fontBut;
	QLabel			*fontLabel;

	QLabel			*fgColorLabel;
	QLabel			*bgColorLabel;
	QPushButton		*fgColorBut;
	QPushButton		*bgColorBut;


	QLabel			*winManAddLabel;
	NumInput		*xWinManAdd;
	NumInput		*yWinManAdd;
	
	QPushButton		*saveGeomBut;
	
	MbaMainWindow*	window;
	int				tbIndex;
	
};

#endif //prefDialogUI_h
