#ifndef renderPanelCode_h
#define renderPanelCode_h

#include <qframe.h>
#include <qcombo.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qstring.h>
#include <qtabwidget.h>
#include <qcheckbox.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qwidgetstack.h>


#include "mwidgets.h"
#include "renderPanelCodeConfig.h"
#include "renderPanelCodeOptions.h"

class ColorButton;
class NumInput;

/**
 * Code output options
 * 
 */
//==============================================================================
class RenderPanelCode	:	public QFrame
{
	Q_OBJECT
	
public:
	RenderPanelCode(QWidget *parent = 0, const char* name = 0);
	~RenderPanelCode();

	
signals:
	void	Updated();
	
public slots:
	void	show();

protected:
	enum	Mode {	Config = 0, 
					Options,  
					Build
				 };
	
protected slots:
	void	selectMode(int);
	void	setConfigPalette(int);
	void	setBuildPalette(int);
	void	setOptionsPalette(int);
	void	writeCode();
	
private:
	QVBoxLayout *topVLayout;
	QHBoxLayout *topHLayout;
	QVBoxLayout	*v1Layout;
	
	MTabWidget	*viewTabWidget;
	QWidgetStack	*widgetStack;
	
	RenderPanelCodeConfig	*configTab;
	RenderPanelCodeOptions	*optionsTab;
	
	QButtonGroup	*modeSelButGroup;
	MToolButton		*configBut;
	MToolButton		*buildBut;
	MToolButton		*optionsBut;
	QPushButton		*writeCodeBut;
	
	QString		codeDir;
	QString		codeFileName;
	QString		templateFileName;
};

#endif
