#ifndef renderPanelCodeConfig_h
#define renderPanelCodeConfig_h

#include <qlabel.h>
#include <qdialog.h>
#include <qlayout.h>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qpushbutton.h>
#include "mwidgets.h"
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qbuttongroup.h>
#include <qcheckbox.h>

#include "numInput.h"

/**
 *
 */
//==============================================================================
class RenderPanelCodeConfig : public QFrame
{
	Q_OBJECT
public:
	RenderPanelCodeConfig(QWidget *parent = 0, const char *name = 0);
	~RenderPanelCodeConfig();

protected:

public slots:
	void	show();
	
protected slots:
	void	addFile();
	void	editFile();
	void	removeFile();
	void	browseForOutputDir();
	void	browseForConfig();
	void	loadConfig();
	void	saveConfig();	
		
protected:
	QGridLayout		*topGridLayout;
	QHBoxLayout		*butLayout;
	QHBoxLayout		*configLayout;
	QHBoxLayout		*outputLayout;
	
	QLabel			*configLabel;
	QLineEdit		*configEdit;
	MToolButton		*configBrowseBut;
	MToolButton		*configSaveBut;
	
	QLabel			*fileLabel;
	MToolButton		*addFileBut;
	MToolButton		*editFileBut;
	MToolButton		*removeFileBut;
	QListBox		*fileListBox;
	
	QLabel			*outputLabel;
	QLineEdit		*outputEdit;
	MToolButton		*outputBrowseBut;
	
	QString			lastFile;
	QString			lastConfigFile;
	QString			lastOutputDir;
	
};

#endif // renderPanelCodeConfig
