#ifndef renderPanelGL_h
#define renderPanelGL_h

#include <qframe.h>
#include <qcheckbox.h>
#include <qcombo.h>
#include <qlayout.h>
#include <qlabel.h>

#include "mwidgets.h"
#include "numInput.h"

class ColorButton;

/**
 *
 */
//==============================================================================
class RenderPanelGL	:	public QFrame
{
	Q_OBJECT
	
public:
	RenderPanelGL(QWidget *parent = 0, const char* name = 0);
	~RenderPanelGL();

signals:
	void	Updated();
	
public slots:
	void	show();
	
protected slots:
	void	setGLFillMode(bool);
	void	setGLCullFace(bool);
	void	setGLBlend(bool);
	void	setGLAlphaTest(bool);
	
	void	setTwoSideLighting(bool);
	
	void	setPointSmooth(bool);
	void	setLineSmooth(bool);
	
	void	setYZCheck(bool);
	void	setXZCheck(bool);
	void	setXYCheck(bool);
	
	void	setUnitSize(float);
	void	setNumUnits(int);
	void	setParticleSkip(int in);
	
	void	setFastParticles(bool status);
	void	setSortParticles(bool status);
	
protected:
	QVBoxLayout *topVLayout;
	QHBoxLayout *topHLayout;
	QVBoxLayout	*v1Layout;
	QVBoxLayout	*v2Layout;
	QVBoxLayout	*v3Layout;
	
	QCheckBox	*glFillCheck;
	QCheckBox	*glCullCheck;
	QCheckBox	*glBlendCheck;
	QCheckBox	*glAlphaTestCheck;
	QCheckBox	*glPointSmoothCheck;
	QCheckBox	*glLineSmoothCheck;
	QCheckBox	*glTwoSideLightCheck;
	
	QCheckBox	*gridYZCheck;
	QCheckBox	*gridXZCheck;
	QCheckBox	*gridXYCheck;
	NumInput	*unitSizeInput;
	NumInput	*numUnitsInput;

	QCheckBox		*fastParticlesCheck;
	QCheckBox		*sortParticlesCheck;
	
	QHBoxLayout		*particleSkipLayout;
	QLabel			*particleSkipLabel;
	QComboBox		*particleSkipCombo;
	
};

#endif
