#ifndef renderPanelGeneral_h
#define renderPanelGeneral_h

#include <qframe.h>
#include <qcheckbox.h>
#include <qcombo.h>
#include <qlayout.h>
#include <qlabel.h>

#include "mwidgets.h"

class ColorButton;
class NumInput;

/**
 * Widget for Render Options panel to control options common
 * to both GL and RenderMan.
 */
//==============================================================================
class RenderPanelGeneral	:	public QFrame
{
	Q_OBJECT
	
public:
	RenderPanelGeneral(QWidget *parent = 0, const char* name = 0);
	~RenderPanelGeneral();

signals:
	void	Updated();
	
public slots:
	void	show();
	
protected slots:
	void	SetBkGndColor(float, float, float);
	void	SetCamFOV(float);

private:
	QVBoxLayout *topVLayout;
	QHBoxLayout *topHLayout;
	QVBoxLayout	*v1Layout;
	QVBoxLayout	*v2Layout;
	QVBoxLayout	*v3Layout;
	
	QLabel		*bkGndColorLabel;
	ColorButton	*bkGndColorButton;
	
	NumInput	*fovInput;
	NumInput	*xLocInput;
	NumInput	*yLocInput;
	NumInput	*zLocInput;
	
};

#endif
