#include "renderPanelHosts.h"

#ifndef WIN32	
	#include <unistd.h>
	#include <sys/wait.h>
#endif

#include <ri.h>
#include <qvalidator.h>
#include <qapp.h>

#include "compatibility.h"
#include <GL/gl.h>

#include "define.h"
#include "extern.h"
#include "numInput.h"
#include "mbaScene.h"
#include "renderRIB.h"
	
//==============================================================================
LocalHostCheckListItem::LocalHostCheckListItem(int indx, QCheckListItem *parent, const char* text)
	:	QCheckListItem(parent, text, QCheckListItem::CheckBox)
{
	index = indx;
}

LocalHostCheckListItem::~LocalHostCheckListItem()
{
}

//--------------------------------------------------------------------
void LocalHostCheckListItem::stateChange(bool state)
{
	g_renderRIB->setLocalHostOn(index, state);
}
	
//==============================================================================
RenderPanelHosts::RenderPanelHosts(QWidget *parent, const char* name)
	: QFrame (parent, name)
{
	setFrameStyle( QFrame::Sunken | QFrame::Panel );
	setLineWidth( 2 );
		
	checkRemoteBut = new MToolButton(this);
	checkRemoteBut->setText("check remote hosts");
	checkRemoteBut->setFont(*g_font_S);
	checkRemoteBut->setFixedHeight( 15 );
	checkRemoteBut->setEnabled(false);

	hostListView = new QListView(this);
	hostListView->addColumn("Hosts");
	hostListView->setFrameStyle( QFrame::Panel | QFrame::Sunken );
	localHosts	= new QCheckListItem(hostListView, "Local");
	localHosts->setOpen(true);
	
	int		i;
	char	itemLabel[64];
	LocalHostCheckListItem	*tmpListItem;
	for (i = 0; i < NUM_RENDER_PROCS; i++)
	{
		sprintf(itemLabel, "process %d", i);
		tmpListItem = new LocalHostCheckListItem( i, localHosts, itemLabel );
		localHostList.append(tmpListItem);
	}
	localHostList.at(0)->setOn(true);
	
//	localHost0 = new QCheckListItem( localHosts, "processor 0", QCheckListItem::CheckBox );
//	localHost1 = new QCheckListItem( localHosts, "processor 1", QCheckListItem::CheckBox );
//	localHost2 = new QCheckListItem( localHosts, "processor 2", QCheckListItem::CheckBox );
//	localHost3 = new QCheckListItem( localHosts, "processor 3", QCheckListItem::CheckBox );


//	remoteHosts	= new QCheckListItem(hostListView, "Remote Hosts");
//	remoteHosts->setOpen(true);
	
	//----------------------------------
	topVLayout		= new QVBoxLayout(this, 10, 0);
	topHLayout		= new QHBoxLayout(5);
//	v1Layout		= new QVBoxLayout(5);
	v2Layout		= new QVBoxLayout(0);
//	v3Layout		= new QVBoxLayout(0);
		
	//----------------------------------
	QObject::connect(checkRemoteBut,	SIGNAL(clicked()), SLOT(CheckRemoteHosts()) );

	//----------------------------------
	topVLayout->addLayout(topHLayout, 1);
//		topHLayout->addLayout(v1Layout, 0);
//			v1Layout->addStretch(1);
		topHLayout->addLayout(v2Layout, 1);
			v2Layout->addWidget(hostListView, 1);
	topVLayout->addWidget(checkRemoteBut, 0);
		//topHLayout->addStretch(1);
			
	topVLayout->activate();
	
}

RenderPanelHosts::~RenderPanelHosts()
{
}

//--------------------------------------------------------------------
void	RenderPanelHosts::CheckRemoteHosts()
{
}


