#ifndef renderPanelHosts_h
#define renderPanelHosts_h

#include <qlist.h>
#include <qframe.h>
#include <qcombo.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qcheckbox.h>
#include <qlistview.h>
#include <qpushbutton.h>

#include "mwidgets.h"
/**
 * 
 */
//==============================================================================
class LocalHostCheckListItem : public QCheckListItem
{
public:
	LocalHostCheckListItem(int indx, QCheckListItem *parent, const char* text);
	~LocalHostCheckListItem();

protected:
	void	stateChange(bool);
	
protected:
	int	index;
};

/**
 * Widget for Render Options panel to control animation frame rendering.
 * Currently used to start concurrent rendrib processes for SMP machines, 
 * and will someday handle remote host renders.
 */
//==============================================================================
class RenderPanelHosts	:	public QFrame
{
	Q_OBJECT
	
public:
	RenderPanelHosts(QWidget *parent = 0, const char* name = 0);
	~RenderPanelHosts();
	
public slots:
	
protected slots:
	void	CheckRemoteHosts();
		
private:
	QVBoxLayout *topVLayout;
	QHBoxLayout *topHLayout;
	QVBoxLayout	*v1Layout;
	QVBoxLayout	*v2Layout;
	QVBoxLayout	*v3Layout;
	
	MToolButton	*checkRemoteBut;
	QListView	*hostListView;
	
	QCheckListItem	*localHosts;
	QCheckListItem	*remoteHosts;
	
	QList<LocalHostCheckListItem>	localHostList;
};

#endif
