#include "renderPanelMPEG.h"

#ifndef WIN32	
	#include <unistd.h>
	#include <sys/wait.h>
#endif

#include <ri.h>
#include <qvalidator.h>
#include <qapp.h>

#include "extern.h"
#include "numInput.h"
	
//==============================================================================
RenderPanelMPEG::RenderPanelMPEG(QWidget *parent, const char* name)
	: QFrame (parent, name)
{
	setFrameStyle( QFrame::Sunken | QFrame::Panel );
	setLineWidth( 2 );
	
	int labelWidth = 65;
	
	nameLabel = new QLabel(this);
	nameLabel->setText("filename : ");
	nameLabel->setFont(*g_font_SB);
	nameLabel->setAlignment( AlignVCenter | AlignRight );
//	nameLabel->setFrameStyle( QFrame::Sunken | QFrame::Panel );
	nameLabel->setFixedSize(labelWidth, 20);
	patternLabel = new QLabel(this);
	patternLabel->setText("pattern : ");
	patternLabel->setFont(*g_font_SB);
	patternLabel->setAlignment( AlignVCenter | AlignRight );
//	patternLabel->setFrameStyle( QFrame::Sunken | QFrame::Panel );
	patternLabel->setFixedSize(labelWidth, 20);
	
	nameEdit = new MLineEdit(this);
	nameEdit->setFixedHeight(20);
	nameEdit->setText("test.mpg");
	patternEdit = new MLineEdit(this);
	patternEdit->setFixedHeight(20);
	patternEdit->setText("IBBBPBBBPBBBPBB");
	
	iQScaleInput = new NumInput(NumInput::Int, this);
	iQScaleInput->SetLabelWidth(g_numLabelWidth);
	iQScaleInput->SetTotalWidth(g_numInputWidth);
	iQScaleInput->SetLabel("I Q-Scale");
	pQScaleInput = new NumInput(NumInput::Int, this);
	pQScaleInput->SetLabelWidth(g_numLabelWidth);
	pQScaleInput->SetTotalWidth(g_numInputWidth);
	pQScaleInput->SetLabel("P Q-Scale");
	bQScaleInput = new NumInput(NumInput::Int, this);
	bQScaleInput->SetLabelWidth(g_numLabelWidth);
	bQScaleInput->SetTotalWidth(g_numInputWidth);
	bQScaleInput->SetLabel("B Q-Scale");

	gopInput = new NumInput(NumInput::Int, this);
	gopInput->SetLabelWidth(g_numLabelWidth);
	gopInput->SetTotalWidth(g_numInputWidth);
	gopInput->SetLabel("GOP size");
	slicesInput = new NumInput(NumInput::Int, this);
	slicesInput->SetLabelWidth(g_numLabelWidth);
	slicesInput->SetTotalWidth(g_numInputWidth);
	slicesInput->SetLabel("slices");

	rangeInput = new NumInput(NumInput::Int, this);
	rangeInput->SetLabelWidth(g_numLabelWidth);
	rangeInput->SetTotalWidth(g_numInputWidth);
	rangeInput->SetLabel("range");
	
	startFrameInput = new NumInput(NumInput::Int, this);
	startFrameInput->SetLabelWidth(g_numLabelWidth);
	startFrameInput->SetTotalWidth(g_numInputWidth);
	startFrameInput->SetLabel("start frame");
	startFrameInput->SetValueSolid(0);
	endFrameInput = new NumInput(NumInput::Int, this);
	endFrameInput->SetLabelWidth(g_numLabelWidth);
	endFrameInput->SetTotalWidth(g_numInputWidth);
	endFrameInput->SetLabel("end frame");
	endFrameInput->SetValueSolid(2000);
	
	sizeXInput = new NumInput(NumInput::Int, this);
	sizeXInput->SetLabelWidth(g_numLabelWidth);
	sizeXInput->SetTotalWidth(g_numInputWidth);
	sizeXInput->SetLabel("width");
	sizeYInput = new NumInput(NumInput::Int, this);
	sizeYInput->SetLabelWidth(g_numLabelWidth);
	sizeYInput->SetTotalWidth(g_numInputWidth);
	sizeYInput->SetLabel("height");
	
	pSearchCombo = new QComboBox(this);
	pSearchCombo->setFixedHeight(25);
	pSearchCombo->insertItem(" exhaustive  ");
	pSearchCombo->insertItem(" two level  ");
	pSearchCombo->insertItem(" subsample  ");
	pSearchCombo->insertItem(" logarithmic  ");
	pSearchCombo->setCurrentItem(3);
	bSearchCombo = new QComboBox(this);
	bSearchCombo->setFixedHeight(25);
	bSearchCombo->insertItem(" exhaustive  ");
	bSearchCombo->insertItem(" cross 2  ");
	bSearchCombo->insertItem(" simple  ");
	pSearchCombo->setCurrentItem(1);
	
	pixelCombo = new QComboBox(this);
	pixelCombo->setFixedHeight(25);
	pixelCombo->insertItem(" full pixel  ");
	pixelCombo->insertItem(" half pixel  ");
	
	refFrameCombo = new QComboBox(this);
	refFrameCombo->setFixedHeight(25);
	refFrameCombo->insertItem(" original  ");
	refFrameCombo->insertItem(" decoded  ");
	
	frameRateCombo = new QComboBox(this);
	frameRateCombo->setFixedHeight(25);
	frameRateCombo->insertItem(" 23.976");
	frameRateCombo->insertItem(" 24");
	frameRateCombo->insertItem(" 25");
	frameRateCombo->insertItem(" 29.97");
	frameRateCombo->insertItem(" 30");
	frameRateCombo->insertItem(" 50");
	frameRateCombo->insertItem(" 59.94");
	frameRateCombo->insertItem(" 60 		  ");
	
	aspectCombo = new QComboBox(this);
	aspectCombo->setFixedHeight(25);
	aspectCombo->insertItem(" 1.0");
	aspectCombo->insertItem(" 0.6735		");
	aspectCombo->insertItem(" 0.7031");
	aspectCombo->insertItem(" 0.7615");
	aspectCombo->insertItem(" 0.8055");
	aspectCombo->insertItem(" 0.8437");
	aspectCombo->insertItem(" 0.8935");
	aspectCombo->insertItem(" 0.9157");
	aspectCombo->insertItem(" 0.9815");
	aspectCombo->insertItem(" 1.0255");
	aspectCombo->insertItem(" 1.0695");
	aspectCombo->insertItem(" 1.0950");
	aspectCombo->insertItem(" 1.1575");
	aspectCombo->insertItem(" 1.2015");
	
	pSearchLabel = new QLabel(this);
	pSearchLabel->setText("P search : ");
	pSearchLabel->setFont(*g_font_SB);
	pSearchLabel->setAlignment( AlignVCenter | AlignRight );
	pSearchLabel->setFixedSize(labelWidth, 25);
	bSearchLabel = new QLabel(this);
	bSearchLabel->setText("B search : ");
	bSearchLabel->setFont(*g_font_SB);
	bSearchLabel->setAlignment( AlignVCenter | AlignRight );
	bSearchLabel->setFixedSize(labelWidth, 25);
	
	pixelLabel = new QLabel(this);
	pixelLabel->setText("Window : ");
	pixelLabel->setFont(*g_font_SB);
	pixelLabel->setAlignment( AlignVCenter | AlignRight );
	pixelLabel->setFixedSize(labelWidth, 25);
	
	refFrameLabel = new QLabel(this);
	refFrameLabel->setText("ref frame : ");
	refFrameLabel->setFont(*g_font_SB);
	refFrameLabel->setAlignment( AlignVCenter | AlignRight );
	refFrameLabel->setFixedSize(labelWidth, 25);
	
	frameRateLabel = new QLabel(this);
	frameRateLabel->setText("frame rate : ");
	frameRateLabel->setFont(*g_font_SB);
	frameRateLabel->setAlignment( AlignVCenter | AlignRight );
	frameRateLabel->setFixedSize(labelWidth, 25);
	
	aspectLabel = new QLabel(this);
	aspectLabel->setText("aspect : ");
	aspectLabel->setFont(*g_font_SB);
	aspectLabel->setAlignment( AlignVCenter | AlignRight );
	aspectLabel->setFixedSize(labelWidth, 25);
	
	forceLastCheck = new QCheckBox("force last frame encoding", this);
	forceLastCheck->setFixedHeight(15);
	forceLastCheck->setFont(*g_font_S);
	forceLastCheck->setChecked(true);
	
	encodeDoneCheck = new QCheckBox("create mpeg after render", this);
	encodeDoneCheck->setFixedHeight(15);
	encodeDoneCheck->setFont(*g_font_S);
	encodeDoneCheck->setChecked(true);
	
	playDoneCheck = new QCheckBox("play mpeg when complete", this);
	playDoneCheck->setFixedHeight(15);
	playDoneCheck->setFont(*g_font_S);
	playDoneCheck->setChecked(true);
	
	//----------------------------------

	//----------------------------------
	topVLayout		= new QVBoxLayout(this, 10, 0);
	topHLayout		= new QHBoxLayout(0);
	nameHLayout		= new QHBoxLayout(0);
	patternHLayout	= new QHBoxLayout(0);
	v1Layout		= new QVBoxLayout(0);
	v2Layout		= new QVBoxLayout(0);
	v3Layout		= new QVBoxLayout(0);
	
	aspectCombo->setFixedWidth(g_numInputWidth);/***/
	
	topVLayout->addLayout(nameHLayout, 0);
		nameHLayout->addWidget(nameLabel);
		nameHLayout->addWidget(nameEdit);
	topVLayout->addSpacing(5);
	topVLayout->addLayout(patternHLayout, 0);
		patternHLayout->addWidget(patternLabel, 0);
		patternHLayout->addWidget(patternEdit, 1);
	topVLayout->addSpacing(5);
	topVLayout->addLayout(topHLayout, 1);
		topHLayout->addLayout(v2Layout, 0);
			v2Layout->addWidget(pixelLabel);
			v2Layout->addSpacing(5+20+2);
			v2Layout->addWidget(pSearchLabel);
			v2Layout->addSpacing(2);
			v2Layout->addWidget(bSearchLabel);
			v2Layout->addSpacing(5);
			v2Layout->addWidget(refFrameLabel);
			v2Layout->addSpacing(5);
			v2Layout->addWidget(frameRateLabel);
			v2Layout->addSpacing(5);
			v2Layout->addWidget(aspectLabel);
			v2Layout->addStretch(1);
		topHLayout->addLayout(v3Layout, 0);
			v3Layout->addWidget(pixelCombo);
			v3Layout->addWidget(rangeInput);
			v3Layout->addSpacing(8);
			v3Layout->addWidget(pSearchCombo);
			v3Layout->addSpacing(2);
			v3Layout->addWidget(bSearchCombo);
			v3Layout->addSpacing(5);
			v3Layout->addWidget(refFrameCombo);
			v3Layout->addSpacing(5);
			v3Layout->addWidget(frameRateCombo);
			v3Layout->addSpacing(5);
			v3Layout->addWidget(aspectCombo);
			v3Layout->addStretch(1);
		topHLayout->addSpacing(10);
		topHLayout->addStretch(1);
		topHLayout->addLayout(v1Layout, 0);
			v1Layout->addWidget(iQScaleInput);
			v1Layout->addWidget(pQScaleInput);
			v1Layout->addWidget(bQScaleInput);
			v1Layout->addSpacing(10);
			v1Layout->addWidget(gopInput);
			v1Layout->addSpacing(5);
			v1Layout->addWidget(slicesInput);
			v1Layout->addSpacing(10);
			v1Layout->addWidget( startFrameInput );
			v1Layout->addWidget( endFrameInput );
			v1Layout->addSpacing(10);
			v1Layout->addWidget( sizeXInput );
			v1Layout->addWidget( sizeYInput );
			v1Layout->addStretch(1);
	topVLayout->addWidget(forceLastCheck);
	topVLayout->addWidget(encodeDoneCheck);
	topVLayout->addWidget(playDoneCheck);
			
	topVLayout->activate();
	
}

RenderPanelMPEG::~RenderPanelMPEG()
{
}

//--------------------------------------------------------------------
void	RenderPanelMPEG::setSizeX(int in)
{
	sizeXInput->SetValueSolid(in);
}

//--------------------------------------------------------------------
void	RenderPanelMPEG::setSizeY(int in)
{
	sizeYInput->SetValueSolid(in);
}



