#ifndef renderPanelRIB_h
#define renderPanelRIB_h

#include <ri.h>

#include <qwidget.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qcombo.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qtimer.h>

#include "mwidgets.h"
#include "mbaMainWindow.h"
#include "numInput.h"

/**
 * Widget for Render Options panel to control RenderMan options
 */
//==============================================================================
class RenderPanelRIB	:	public QFrame
{
	Q_OBJECT
	
public:
	RenderPanelRIB(QWidget *parent = 0, const char* name = 0);
	~RenderPanelRIB();

public slots:
	void	show();
	void	setSizeX(int);
	void	setSizeY(int);
	void	setSizeAspect(float);
	void	setSamplesX(float);
	void	setSamplesY(float);
	void	RenderCurrentFrame();
	void	RenderAnimation();
	
protected slots:
	void	setTrueDisplace(bool);
	void	setAllowShadows(bool);
	void	setMotionBlur(bool);
	
	void	setNumBlurSteps(int);

	void	setStartFrame(int);
	void	setEndFrame(int);
	void	setSides(int);
	void	setMaxRays(int);
	void	setShadeRate(float);
	void	setRenderMode(int);
	
private:
	QVBoxLayout *topVLayout;
	QHBoxLayout *topHLayout;
	QVBoxLayout	*v0Layout;
	QVBoxLayout	*v1Layout;
	QVBoxLayout	*v2Layout;
	QVBoxLayout	*v3Layout;
	
	QCheckBox	*allowShadowsCheck;
	QCheckBox	*allowDisplaceCheck;
	QCheckBox	*motionBlurCheck;
	
	QComboBox	*renderModeCombo;
	RtToken		renderMode;
	
	MLineEdit	*rendermanOptions;
	
	NumInput	*startFrameInput;
	NumInput	*endFrameInput;
	
	QLabel		*optionsLabel;
	NumInput	*sizeXInput;
	NumInput	*sizeYInput;
	NumInput	*sizeAspectInput;
	NumInput	*samplesXInput;
	NumInput	*samplesYInput;
	NumInput	*maxRaysInput;
	NumInput	*sidesInput;
	NumInput	*shadeRateInput;
	
	QComboBox	*blurStepsCombo;
};

#endif
