#ifndef renderPanelTabDialog_h
#define renderPanelTabDialog_h

#include <qtabwidget.h>
#include <qpushbutton.h>
#include <qtoolbar.h>

#include "mbaMainWindow.h"
#include "renderPanelGL.h"
#include "renderPanelRIB.h"
#include "renderPanelMPEG.h"
#include "renderPanelGeneral.h"
#include "renderPanelHosts.h"
#include "renderPanelCode.h"

/**
 * 
 */
//====================================================================
class RenderPanelTabDialog	: public MbaMainWindow
{
	Q_OBJECT
public:
	RenderPanelTabDialog(QWidget *parent=0, const char*name=0, ToolBarDock buttonBarDock = Right);
	~RenderPanelTabDialog();

	inline void	setSizeX(int in)		{ renderPanelRIB->setSizeX(in);	/*renderPanelMPEG.setSizeX(in);	*/	 }
	inline void	setSizeY(int in)		{ renderPanelRIB->setSizeY(in);	/*renderPanelMPEG.setSizeY(in);	*/	 }
	inline void	setSizeAspect(float in)	{ renderPanelRIB->setSizeAspect(in);	}
	inline void	setSamplesX(float in)	{ renderPanelRIB->setSamplesX(in);	}
	inline void	setSamplesY(float in)	{ renderPanelRIB->setSamplesY(in);	}

	inline void	RenderFrame()	{	renderPanelRIB->RenderCurrentFrame();	}
	
	QToolBar	*GetToolBar(int toolBarNum);
	bool	setToolBar(int num, QMainWindow::ToolBarDock dock, bool newline = true);

signals:
	void	Updated();
	
protected slots:	
	void	RenderCurrentFrame();
	void	RenderAnimation();
	
protected:
	MTabWidget			*tabDialog;
	RenderPanelGeneral	*renderPanelGeneral;
	RenderPanelGL		*renderPanelGL;
	RenderPanelRIB		*renderPanelRIB;
	RenderPanelMPEG		*renderPanelMPEG;
	RenderPanelHosts	*renderPanelHosts;
	RenderPanelCode		*renderPanelCode;
	
	QToolBar		*manipToolBar;
	
	MToolButton		*closeBut;
	MToolButton		*frameBut;
	QPushButton		*aniBut;
//	MToolButton		*addBut;
//	MToolButton		*delBut;

};

#endif //renderPanelTabDialog_h
