#ifndef renderRIB_h
#define renderRIB_h

#include <qtimer.h>
#include <qlist.h>
#include <qprogressdialog.h>

#include "define.h"

/**
 *
 */
//==============================================================================
class RenderRIB : public QObject
{
	Q_OBJECT
public:
	int		pid_wait[NUM_RENDER_PROCS];
	int		pid_preview_wait[NUM_PREVIEW_PROCS];
	int		RenderSceneFrame(int frame, int process, bool framebuffer = false);

	RenderRIB();
	~RenderRIB();
		
	enum RenderStatus { Ok = 0, PreviewFull, WriteError, ForkError };
	
	bool	RenderCurrentFrame();
	bool	RenderAnimation();

	inline	int		setSides(int in)		{ if(in < 2) sides = 1; else sides = 2; return sides;	}
	inline	int		setMaxRays(int in)		{ if(in < 0) maxRays = 0; else maxRays = in; return maxRays;	}
	inline	float	setShadeRate(float in)	{ shadeRate = in; return shadeRate;	}
	inline	char*	setRenderMode(char* in)	{ renderMode = in;	return renderMode; }
	int		setStartFrame(int in);
	int		setEndFrame(int in);
	
	inline	int		StartFrame()	{	return startFrame;	}
	inline	int		EndFrame()		{	return endFrame;	}
	inline	int		Sides()			{	return sides;		}
	inline	int		MaxRays()		{	return maxRays;		}
	inline	float	ShadeRate()		{	return shadeRate;	}
	inline	char*	RenderMode()	{	return renderMode;	}
	
	void	setLocalHostOn(int index, bool state);
	
protected:
	int		UpdateProgress();
	void	EndProgress();

protected slots:
	void	WaitForNextFrame();
	
protected:

	bool	continueRendering;
	QTimer	checkPIDTimer;
	QProgressDialog	*progressDialog;
	int		fdiff;
	int		fcurrent;
		
	int		startFrame;
	int		endFrame;
	int		sides;
	int		maxRays;
	float	shadeRate;
	char	*renderMode;
	
	QList<bool>	localHostList;

};

#endif //renderRIB_h
