#ifndef startup_h
#define startup_h

#include "mbaMainWindow.h"
#include <qwidget.h>
#include <qframe.h>
#include <qlabel.h>
#include <qtimer.h>
#include <qstrlist.h>

/**
 * Class to handle flow's startup
 */
//==============================================================================
class MainStartup	: public QFrame
{
	Q_OBJECT
public:
	MainStartup();
	~MainStartup();
	
	enum	StartupIndex {	NoOp = 0, 
							ReadTheInitFile, 
							CheckForErrors, 
							CheckForShaders, 
							CreateMainFlow, 
							CreateDefaultScene,
							CreateSceneWidget, 
							CreateSurfaceTabDialog, 
							CreateLightGroupWidget, 
							CreateRenderPanelTabDialog,
							CreateParticleControlWidget, 
							CreatePolyTweakWidget,
							NumStartupSteps };
	
	void	BeginStartup();
	
protected slots:
	void	Startup();

protected:
	void	ErrorChecks();
	bool	CheckReptileDirs();
	bool	CheckFlowDirs();
	bool	CreateReptileDir(const char *);
	bool	CheckEnvironment();
	bool	CheckExternalExec();
	bool	ReadInitFile();
	void	InitDefaults();
//	bool	CheckShaders();
//	void	SortShaders(QStrList& masterList);
//	void	StrListFromPath(QStrList *list, const char* path);
	void	MoveAndResize();
	void	setFonts();
	
private:
	QLabel		*progressLabel;
	QLabel		*splashLabel;
	QPixmap		*splashPix;
	QTimer		*timer;
	
	int		mainFlowX;
	int		mainFlowY;
	int		mainFlowW;
	int		mainFlowH;
	bool	mainFlowShow;
	int		particleControlX;
	int		particleControlY;
	int		particleControlW;
	int		particleControlH;
	bool	particleControlShow;
	int		lightGroupX;
	int		lightGroupY;
	int		lightGroupW;
	int		lightGroupH;
	bool	lightGroupShow;
	int		renderX;
	int		renderY;
	int		renderW;
	int		renderH;
	bool	renderShow;
	int		surfaceX;
	int		surfaceY;
	int		surfaceW;
	int		surfaceH;
	bool	surfaceShow;
	int		sceneTreeX;
	int		sceneTreeY;
	int		sceneTreeW;
	int		sceneTreeH;
	bool	sceneTreeShow;
	
};

#endif //startup_h
